#ifndef _INC_SINCOSTABLE
#define _INC_SINCOSTABLE


#define PAI						(3.1415926535897932384626433832795)
#define PAI2					(6.2831853071795864769252867665590)
#define PAI_DIV2				(1.5707963267948966192313216916398)
#define PAI_DIV4				(0.7853981633974483096156608458198)
#define RADIAN360( a )			((a) * PAI / 180.0)
#define DEGREE360( a )			((a) * (180.0 / PAI))
#define RADIAN512( a )			((a) * PAI / 256.0)
#define DEGREE512( a )			((a) * (256.0 / PAI))
#define A360To512( a )			(((a) << 9 ) / 360 )
#define A512To360( a )			(((a) * 360) >> 9 )


/*----------------------------------------------------------------------------*
|	Sin Cos Table Class
*----------------------------------------------------------------------------*/
class CSinCosTable
{
protected:

	static	long	m_lSinTbl[ 512 ];
	static	bool	m_bInitialize;

public:

	CSinCosTable();
	virtual ~CSinCosTable(){}

	static long Sin( long a ){ return m_lSinTbl[ a&511 ]; }
	static long Cos( long a ){ return m_lSinTbl[ (a+128)&511 ]; };

};


#endif /* _INC_SINCOSTABLE */