
/******************************************************************************
*	SDIB32GL dll main Source
******************************************************************************/
#include "stdafx.h"
#include <initguid.h>	// ̃\[XGUID`
#include "sdib32gl.h"
#include "sdib32glbase.h"
#include "sdib32glx86.h"
#include "sdib32glpmmx.h"
#include "resource.h"

// LO[oϐ
#pragma data_seg(".shdib32")
ULONG				gs_ulRef = 0;
#pragma data_seg()

HINSTANCE			g_hInstance = 0;
map<HRESULT, DWORD> g_ErrorMap;


#ifdef _DEBUG
char				g_szLogName[256] = "";

void SetLogFile( void )
{
	char szModulePath[_MAX_PATH];
	char drive[_MAX_DRIVE];
	char dir[_MAX_DIR];
	char name[_MAX_FNAME];

	::sprintf( name, "SDIB32GLD[%d]", gs_ulRef );
	::GetModuleFileName( NULL, szModulePath, _MAX_PATH );
	::_splitpath( szModulePath, drive, dir, NULL, NULL );
	::_makepath( g_szLogName, drive, dir, name, ".log" );
	::DeleteFile( g_szLogName );
}

#else
  #define			SetLogFile()
#endif /* _DEBUG */


/*----------------------------------------------------------------------------*
|	DLL Gg[|Cg
*----------------------------------------------------------------------------*/
STDAPI_(BOOL) DllMain( HINSTANCE hModule, DWORD ul_reason_for_call, LPVOID lpReserved )
{
	switch( ul_reason_for_call )
	{
	case DLL_PROCESS_ATTACH:

		// CX^Xnhݒ
		g_hInstance = hModule;

		// TCRTCe[u쐬
		CSinCosTable();

		// G[}bvݒ (key=G[R[h, l=\[XID)
		g_ErrorMap[ SDIB32GLERR_SDIB32GLALREADYCREATED ] = IDS_SDIB32GLERR_SDIB32GLALREADYCREATED;
		g_ErrorMap[ SDIB32GLERR_DIBNOTCREATED ]       = IDS_SDIB32GLERR_DIBNOTCREATED;
		g_ErrorMap[ SDIB32GLERR_MEMORYDCNOTCREATED ]  = IDS_SDIB32GLERR_MEMORYDCNOTCREATED;
		g_ErrorMap[ SDIB32GLERR_FILENOTFOUND ]        = IDS_SDIB32GLERR_FILENOTFOUND;
		g_ErrorMap[ SDIB32GLERR_FILENOTCREATED ]      = IDS_SDIB32GLERR_FILENOTCREATED;
		g_ErrorMap[ SDIB32GLERR_NOTINITIALIZED ]      = IDS_SDIB32GLERR_NOTINITIALIZED;
		g_ErrorMap[ SDIB32GLERR_INVALIDPOSITION ]     = IDS_SDIB32GLERR_INVALIDPOSITION;
		g_ErrorMap[ SDIB32GLERR_INVALIDOBJECT ]       = IDS_SDIB32GLERR_INVALIDOBJECT;
		g_ErrorMap[ SDIB32GLERR_INVALIDPARAMS ]		  = IDS_SDIB32GLERR_INVALIDPARAMS;
		g_ErrorMap[ SDIB32GLERR_UNSUPPORTEDFILE ]     = IDS_SDIB32GLERR_UNSUPPORTEDFILE;
		g_ErrorMap[ SDIB32GLERR_UNSUPPORTEDBITCOUNT ] = IDS_SDIB32GLERR_UNSUPPORTEDBITCOUNT;
		g_ErrorMap[ SDIB32GLERR_UNSUPPORTEDFORMAT ]   = IDS_SDIB32GLERR_UNSUPPORTEDFORMAT;
		g_ErrorMap[ SDIB32GLS_ROTATEBLT64BIT ]        = IDS_SDIB32GLS_ROTATEBLT64BIT;

		// Ot@C쐬 (fobOp)
		SetLogFile();

		// DLLQƐCNg
		gs_ulRef++;

		// DLL[hꂽ (fobOp)
		::SDIB32GL_DebugOutput("load{\n\n");
		break;
	case DLL_PROCESS_DETACH:

		// G[}bvNA
		g_ErrorMap.clear();

		// DLLQƐfNg
		gs_ulRef--;

		// DLLA[hꂽ (fobOp)
		::SDIB32GL_DebugOutput("\n}unload");
		break;
	}

	return TRUE;
}


/*----------------------------------------------------------------------------*
|	SDIB32GLCX^X֐
*----------------------------------------------------------------------------*/
STDAPI SDIB32GL_CreateInstance( REFCLSID rclsid, REFIID riid, LPVOID* ppv )
{
	// w肳ꂽNXIDNXIuWFNg쐬
	if( ::IsEqualIID( rclsid, CLSID_SDib32GLX86 ) )
	{
		// x86݊CPUp
		CSDib32GLX86* pSDib32GLObj = new CSDib32GLX86;
		
		// mێs
		if( pSDib32GLObj == NULL )
		{
			*ppv = NULL;
			return E_OUTOFMEMORY;
		}

		// w肳ꂽC^[tFCXv
		HRESULT hr = pSDib32GLObj->QueryInterface( riid, ppv );

		pSDib32GLObj->Release();

		// C^[tFCX݂͑Ȃ
		if( FAILED(hr) )
		{
			return E_NOINTERFACE;
		}

	}else if( ::IsEqualIID( rclsid, CLSID_SDib32GLPMMX ) )
	{	
		// Pentium MMXΉCPUp
		CSDib32GLPMMX* pSDib32GLObj = new CSDib32GLPMMX;
		
		// mێs
		if( pSDib32GLObj == NULL )
		{
			*ppv = NULL;
			return E_OUTOFMEMORY;
		}

		// w肳ꂽC^[tFCXv
		HRESULT hr = pSDib32GLObj->QueryInterface( riid, ppv );

		pSDib32GLObj->Release();

		// C^[tFCX݂͑Ȃ
		if( FAILED(hr) )
		{
			return E_NOINTERFACE;
		}

	}else
	{
		// NX݂Ȃ
		*ppv = NULL;
		return CLASS_E_CLASSNOTAVAILABLE;
	}

	// 
	return S_OK;
}


/*----------------------------------------------------------------------------*
|	SDIB32GLobt@쐬֐
*----------------------------------------------------------------------------*/
STDAPI SDIB32GL_CreateBuffer( int nWidth, int nHeight, SDIB32GLCOLOR FillColor, HDC hdc, REFCLSID rclsid, REFIID riid, LPVOID* lplpSDIB32GL )
{
	// SDIB32GLCX^X
	HRESULT hr = ::SDIB32GL_CreateInstance( rclsid, riid, lplpSDIB32GL );

	// G[ȂA
	if( FAILED(hr) ) return hr;

	// x[XNXɃ_ELXg(̏ꍇ̌^͕ۏ؂Ă)
	LPSDIB32GLBASE lpSDib32GLBase = static_cast<LPSDIB32GLBASE>(*lplpSDIB32GL);

	// obt@쐬
	hr = lpSDib32GLBase->CreateBuffer( nWidth, nHeight, FillColor, hdc );

	// G[ȂCX^XċA
	if( FAILED(hr) )
	{
		lpSDib32GLBase->Release();
		*lplpSDIB32GL = NULL;
		return hr;
	}

	// 
	return S_OK;
}


/*----------------------------------------------------------------------------*
|	t@CSDIB32GLobt@쐬֐
*----------------------------------------------------------------------------*/
STDAPI SDIB32GL_LoadFromFile( const char* lpszFileName, SDIB32GLCOLOR ColorKey, HDC hdc, REFCLSID rclsid, REFIID riid, LPVOID* lplpSDIB32GL )
{
	// SDIB32GLCX^X
	HRESULT hr = ::SDIB32GL_CreateInstance( rclsid, riid, lplpSDIB32GL );

	// G[ȂA
	if( FAILED(hr) ) return hr;

	// x[XNXɃ_ELXg(̏ꍇ̌^͕ۏ؂Ă)
	LPSDIB32GLBASE lpSDib32GLBase = static_cast<LPSDIB32GLBASE>(*lplpSDIB32GL);

	// t@C烍[hăobt@쐬
	hr = lpSDib32GLBase->LoadFromFile( lpszFileName, ColorKey, hdc );

	// G[ȂCX^XċA
	if( FAILED(hr) )
	{
		lpSDib32GLBase->Release();
		*lplpSDIB32GL = NULL;
		return hr;
	}

	// 
	return S_OK;
}


/*----------------------------------------------------------------------------*
|	IWiSDIB32GL𕡐
*----------------------------------------------------------------------------*/
STDAPI SDIB32GL_DuplicateBuffer( LPVOID lpSDIB32GLOriginal, REFCLSID rclsid, REFIID riid, LPVOID* lplpSDIB32GLDuplicate )
{
	// NULL|C^w肳ꂽ
	if( lpSDIB32GLOriginal == NULL ) return E_POINTER;

	// SDIB32GLCX^X
	HRESULT hr = ::SDIB32GL_CreateInstance( rclsid, riid, lplpSDIB32GLDuplicate );

	// G[ȂA
	if( FAILED(hr) ) return hr;

	// x[XNXɃ_ELXg(̏ꍇ̌^͕ۏ؂Ă)
	LPSDIB32GLBASE lpSDib32GLBaseDuplicate = static_cast<LPSDIB32GLBASE>(*lplpSDIB32GLDuplicate);

	// obt@𕡐
	hr = lpSDib32GLBaseDuplicate->DuplicateBuffer( static_cast<LPSDIB32GL>(lpSDIB32GLOriginal) );

	// G[ȂCX^XċA
	if( FAILED(hr) )
	{
		lpSDib32GLBaseDuplicate->Release();
		*lplpSDIB32GLDuplicate = NULL;
		return hr;
	}

	return S_OK;
}


/*----------------------------------------------------------------------------*
|	G[eLXg擾
*----------------------------------------------------------------------------*/
STDAPI_(DWORD) SDIB32GL_GetErrorText( HRESULT hr, char* pBuffer, int nBufferMax )
{
	if( g_ErrorMap.count( hr ) )
	{
		return (DWORD)::LoadString( g_hInstance, g_ErrorMap[ hr ], pBuffer, nBufferMax );

	}else
	{
		return ::FormatMessage( FORMAT_MESSAGE_FROM_SYSTEM |
						 FORMAT_MESSAGE_IGNORE_INSERTS,
						 NULL, hr,
						 MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT),
						(LPTSTR)pBuffer, nBufferMax, NULL);
	}
}


/*----------------------------------------------------------------------------*
|	SDIB32GĽ݂̃o[W擾
*----------------------------------------------------------------------------*/
STDAPI_(DWORD) SDIB32GL_GetVersion( void )
{

	return SDIB32GLLIB_VERSION;

}


/*----------------------------------------------------------------------------*
|	DLL̎QƐ擾(܂)
*----------------------------------------------------------------------------*/
STDAPI_(ULONG) SDIB32GL_GetDllRefCount( void )
{

	return gs_ulRef;

}


/*----------------------------------------------------------------------------*
|	CPUMMXɑΉĂ邩ǂ
*----------------------------------------------------------------------------*/
#pragma warning( disable : 4035 )
STDAPI_(BOOL) SDIB32GL_IsMMX( void )
{
	__asm
	{
		// CPUID̃T|[g`FbN
		pushfd
        pop eax
        mov ecx, eax
        xor eax, 0x200000
        push eax
        popfd
        pushfd
        pop eax
        and eax, 0x200000
        and ecx, 0x200000
        xor eax, ecx
        jnz cpuid_true
		mov eax, 0
		jmp	mmx_false

		// MMXT|[g`FbN
cpuid_true:
		mov eax, 1
		cpuid
		and edx, 0x800000
		shr edx, 23
		mov eax, edx

mmx_false:
	}
}
#pragma warning( default : 4035 )


#ifdef _DEBUG
/*----------------------------------------------------------------------------*
|	fobOp֐
*----------------------------------------------------------------------------*/
STDAPI_(void) SDIB32GL_DebugOutput( const char* format, ... )
{
	char buf[ 256 ];
	va_list argpt;
	va_start( argpt, format );
	::vsprintf( buf, format, argpt );
	va_end( argpt );

	FILE* fp = ::fopen( g_szLogName, "a" );
	::fprintf( fp, "%s", buf );
	::fclose( fp );
}

#else
STDAPI_(void) SDIB32GL_DebugOutput( const char* format, ... ){}
#endif