
/******************************************************************************
*	SDIB32GLX86 Class
******************************************************************************/

#include "stdafx.h"
#include "sdib32gl.h"
#include "sdib32glbase.h"
#include "sdib32glx86.h"


// At@Ŏgp}XN
#define __AxGx_MASK_H		0xff00ff00
#define __xRxB_MASK_L		0x00ff00ff
#define __xGxx_MASK_H		0x00ff0000
#define __RxBx_MASK_L		0xff00ff00

// ZAZŎg}XN
#define __MASK_fefefefe		0xfefefefe
#define __MASK_01010100		0x01010100
#define __MASK_7f7f7f7f		0x7f7f7f7f


#define __xRxB_MONO_MASK	0x00ff00ff	
#define __xxGx_MONO_MASK	0x0000ff00
#define __xxBB_MONO_MASK	0x0000ffff

/*----------------------------------------------------------------------------*
|	ufBO
|	
|	[]
|	LPSDIB32GL lpSrcSDIB32GLc]SDIB32GLC^[tFCX
|	int nDstXc] x W
|	int nDstYc] y W
|	LPSIZE  lpDstSizec]̕Bl𕉂ɂ邱ƂŃ~[]B
|				NULLw肷΃ftHgTCYɂȂ܂B
|	LPPOINT lpSrcPtc]WBNULLw肷΍W(0)ɂȂ܂B
|	LPSIZE  lpSrcSizec]̕BNULLw肷΃ftHgTCYɂȂ܂B
|	BYTE AlphaclB
*----------------------------------------------------------------------------*/
STDMETHODIMP CSDib32GLX86::AlphaBlendBlt( LPSDIB32GL lpSrcSDIB32GL, int nDstX, int nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize, BYTE Alpha )
{
	// IuWFNgNULL`FbN
	_ASSERTE( lpSrcSDIB32GL != NULL );
	if( lpSrcSDIB32GL == NULL ) return E_POINTER;

	CSDib32GLX86* lpSrc = safe_cast( CSDib32GLX86*, lpSrcSDIB32GL );
	INVALIDOBJECTCHECK( lpSrc );

	_ASSERTE( m_pBits != NULL);
	_ASSERTE( lpSrc->m_pBits != NULL );

	if( m_pBits == NULL ) return SDIB32GLERR_NOTINITIALIZED;
	if( lpSrc->m_pBits == NULL ) return SDIB32GLERR_NOTINITIALIZED;

	// `Xe[^Xɓ]W̑
	SDIB32GLSTATUS Status = { nDstX, nDstY };

	// NbsO
	if( !Clipping( lpSrc, Status, lpDstSize, lpSrcPt, lpSrcSize ) ) return SDIB32GLERR_INVALIDPOSITION;

	// ]恕]̊JnAhX
	LPSDIB32GLCOLOR pSrcBits = &lpSrc->m_ppScanLine[ Status.nSrcY ][ Status.nSrcX ];
	LPSDIB32GLCOLOR pDstBits = &m_ppScanLine[ Status.nDstY ][ Status.nDstX ];

	DWORD dwAlphaSrc = CONVERT_255To256( Alpha );	// At@
	DWORD dwAlphaDst = DEST_ALPHA( dwAlphaSrc );


	// [vJE^AZupɕϊ
	Status.nWidth  = CONVERT_WIDTH( Status.nWidth );
	Status.nHeight = CONVERT_HEIGHT( Status.nHeight );


	if( !Status.bZoom )
	{
		// W]

		__asm
		{
			mov esi, pSrcBits				// ]AhX
			mov edi, pDstBits				// ]AhX

			mov ecx, Status.nHeight			// ]鍂(Y[vJE^)

		loop_y0:

			or ecx, Status.nWidth			// ]镝(X[vJE^)

		loop_x0:
		
			mov edx, [esi]					// ]sNZf[^擾
			mov ebx, [edi]					// ]sNZf[^擾

			and edx, __xRxB_MASK_L			// }XN eax & 0x00ff00ff	
			and ebx, __xRxB_MASK_L			// }XN ebx & 0x00ff00ff

			imul edx, dwAlphaSrc			// (np) Kp

			imul ebx, dwAlphaDst			// (np) Kp
			
			add edx, ebx					// ]̃J[(RB)Ɠ]̃J[(RB)Z
			mov eax, [esi]					// ]sNZf[^擾

			mov ebx, [edi]					// ]sNZf[^擾
			and eax, __AxGx_MASK_H			// }XN eax & 0x0000ff00

			and ebx, __AxGx_MASK_H			// (np) }XN eax & 0x0000ff00
			add esi, Status.nSrcAddDirX		// ~[]XZς

			imul eax, dwAlphaSrc			// (np) Kp

			imul ebx, dwAlphaDst			// (np) Kp
			
			add eax, ebx					// (np) ]̃J[(G)Ɠ]̃J[(G)Z
			add edi, 4						// ]͒ʏ

			and eax, __xGxx_MASK_H			// [؂̂(G)
			and edx, __RxBx_MASK_L			// [؂̂(R,B)

			or eax, edx						// (np) GR,B
			
			shr eax, 8
			sub ecx, __DEC_WIDTH

			mov [edi-4], eax				// ]sNZf[^ɓ]
			jns loop_x0

			add esi, Status.nSrcAddDirY		// ̃C ~[]YZς
			add edi, Status.nDstAddY		// ̃C ]͒ʏ

			sub ecx, __DEC_HEIGHT
			jns loop_y0	

		}

	}else
	{
		// Y[]

		__asm
		{
			mov esi, pSrcBits				// ]AhX
			mov edi, pDstBits				// ]AhX
			
			mov eax, Status.nEx				// 덷
			mov ebx, Status.nEy				// c덷

			mov ecx, Status.nHeight			// (np) ]鍂(Y[vJE^)

		loop_y1:

			or ecx, Status.nWidth			// ]镝(X[vJE^)
			mov Status.pLineHead, esi		// C̊Jn擪AhXۑ

		loop_x1:

			push eax
			push ebx

			mov edx, [esi]					// ]sNZf[^擾
			mov ebx, [edi]					// ]sNZf[^擾

			and edx, __xRxB_MASK_L			// }XN eax & 0x00ff00ff	
			and ebx, __xRxB_MASK_L			// }XN ebx & 0x00ff00ff

			imul edx, dwAlphaSrc			// (np) Kp

			imul ebx, dwAlphaDst			// (np) Kp
			
			add edx, ebx					// ]̃J[(RB)Ɠ]̃J[(RB)Z
			mov eax, [esi]					// ]sNZf[^擾

			mov ebx, [edi]					// ]sNZf[^擾
			and eax, __AxGx_MASK_H			// }XN eax & 0x0000ff00

			and ebx, __AxGx_MASK_H			// (np) }XN eax & 0x0000ff00
			add esi, Status.nSrcAddRx		// k̓]XZ

			imul eax, dwAlphaSrc			// (np) Kp

			imul ebx, dwAlphaDst			// (np) Kp
			
			add eax, ebx					// (np) ]̃J[(G)Ɠ]̃J[(G)Z
			add edi, 4						// ]WXɐi߂

			and eax, __xGxx_MASK_H			// [؂̂(G)
			and edx, __RxBx_MASK_L			// [؂̂(R,B)

			or eax, edx						// (np) GR,B

			shr eax, 8
			pop ebx

			mov [edi-4], eax				// ]sNZf[^ɓ]
			pop eax

			add eax, Status.nMx				// X̌덷Z
			js skip_addsrcx

			add esi, Status.nSrcAddDirX		// ]Xɐi߂
			sub eax, Status.nERx			// X덷ɕ␳ľZ

		skip_addsrcx:

			sub ecx, __DEC_WIDTH
			jns loop_x1

			mov esi, Status.pLineHead		// ۑĂAhX𕜋A
			mov eax, Status.nEx				// X̏덷𕜋A

			add esi, Status.nSrcAddRy		// k̓]YZ
			add edi, Status.nDstAddY		// ]WYɐi߂

			add ebx, Status.nMy				// Y̌덷Z
			js skip_addsrcy

			add esi, Status.nSrcAddDirY		// ]Yɐi߂
			sub ebx, Status.nERy			// Y덷ɕ␳ľZ

		skip_addsrcy:

			sub ecx, __DEC_HEIGHT
			jns loop_y1
		}
	}

	return S_OK;
}


/*----------------------------------------------------------------------------*
|	߃ufBO
|	
|	[]
|	LPSDIB32GL lpSrcSDIB32GLc]SDIB32GLC^[tFCX
|	int nDstXc] x W
|	int nDstYc] y W
|	LPSIZE  lpDstSizec]̕Bl𕉂ɂ邱ƂŃ~[]B
|				NULLw肷΃ftHgTCYɂȂ܂B
|	LPPOINT lpSrcPtc]WBNULLw肷΍W(0)ɂȂ܂B
|	LPSIZE  lpSrcSizec]̕BNULLw肷΃ftHgTCYɂȂ܂B
|	BYTE AlphaclB
*----------------------------------------------------------------------------*/
STDMETHODIMP CSDib32GLX86::ColorKeyAlphaBlendBlt( LPSDIB32GL lpSrcSDIB32GL, int nDstX, int nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize, BYTE Alpha )
{
	// IuWFNgNULL`FbN
	_ASSERTE( lpSrcSDIB32GL != NULL );
	if( lpSrcSDIB32GL == NULL ) return E_POINTER;

	CSDib32GLX86* lpSrc = safe_cast( CSDib32GLX86*, lpSrcSDIB32GL );
	INVALIDOBJECTCHECK( lpSrc );

	_ASSERTE( m_pBits != NULL);
	_ASSERTE( lpSrc->m_pBits != NULL );

	if( m_pBits == NULL ) return SDIB32GLERR_NOTINITIALIZED;
	if( lpSrc->m_pBits == NULL ) return SDIB32GLERR_NOTINITIALIZED;

	// `Xe[^Xɓ]W̑
	SDIB32GLSTATUS Status = { nDstX, nDstY };

	// NbsO
	if( !Clipping( lpSrc, Status, lpDstSize, lpSrcPt, lpSrcSize ) ) return SDIB32GLERR_INVALIDPOSITION;

	// ]恕]̊JnAhX
	LPSDIB32GLCOLOR pSrcBits = &lpSrc->m_ppScanLine[ Status.nSrcY ][ Status.nSrcX ];
	LPSDIB32GLCOLOR pDstBits = &m_ppScanLine[ Status.nDstY ][ Status.nDstX ];

	DWORD dwAlphaSrc = CONVERT_255To256( Alpha );	// At@
	DWORD dwAlphaDst = DEST_ALPHA( dwAlphaSrc );
	SDIB32GLCOLOR ColorKey = lpSrc->m_ColorKey;

	// [vJE^AZupɕϊ
	Status.nWidth  = CONVERT_WIDTH( Status.nWidth );
	Status.nHeight = CONVERT_HEIGHT( Status.nHeight );


	if( !Status.bZoom )
	{
		// W]

		__asm
		{
			mov esi, pSrcBits				// ]AhX
			mov edi, pDstBits				// ]AhX

			mov ecx, Status.nHeight			// ]鍂(Y[vJE^)

		loop_y0:

			or ecx, Status.nWidth			// ]镝(X[vJE^)

		loop_x0:
		
			mov edx, [esi]					// ]sNZf[^擾

			cmp edx, ColorKey
			je skip_draw0

			mov ebx, [edi]					// ]sNZf[^擾

			and edx, __xRxB_MASK_L			// }XN eax & 0x00ff00ff	
			and ebx, __xRxB_MASK_L			// }XN ebx & 0x00ff00ff

			imul edx, dwAlphaSrc			// (np) Kp

			imul ebx, dwAlphaDst			// (np) Kp
			
			add edx, ebx					// ]̃J[(RB)Ɠ]̃J[(RB)Z
			mov eax, [esi]					// ]sNZf[^擾

			mov ebx, [edi]					// ]sNZf[^擾
			and eax, __AxGx_MASK_H			// }XN eax & 0x0000ff00

			and ebx, __AxGx_MASK_H			// (np) }XN eax & 0x0000ff00

			imul eax, dwAlphaSrc			// (np) Kp

			imul ebx, dwAlphaDst			// (np) Kp
			
			add eax, ebx					// (np) ]̃J[(G)Ɠ]̃J[(G)Z

			and eax, __xGxx_MASK_H			// [؂̂(G)
			and edx, __RxBx_MASK_L			// [؂̂(R,B)

			or eax, edx						// (np) GR,B

			shr eax, 8						// (np)

			mov [edi], eax					// (np) ]sNZf[^ɓ]

		skip_draw0:

			add esi, Status.nSrcAddDirX		// ~[]XZς
			add edi, 4						// ]͒ʏ

			sub ecx, __DEC_WIDTH
			jns loop_x0

			add esi, Status.nSrcAddDirY		// ̃C ~[]YZς
			add edi, Status.nDstAddY		// ̃C ]͒ʏ

			sub ecx, __DEC_HEIGHT
			jns loop_y0	

		}

	}else
	{
		// Y[]

		__asm
		{
			mov esi, pSrcBits				// ]AhX
			mov edi, pDstBits				// ]AhX
			
			mov eax, Status.nEx				// 덷
			mov ebx, Status.nEy				// c덷

			mov ecx, Status.nHeight			// (np) ]鍂(Y[vJE^)

		loop_y1:

			or ecx, Status.nWidth			// ]镝(X[vJE^)
			mov Status.pLineHead, esi		// C̊Jn擪AhXۑ

		loop_x1:

			mov edx, [esi]					// ]sNZf[^擾
			
			cmp edx, ColorKey
			je skip_draw1

			push eax
			push ebx

			mov ebx, [edi]					// ]sNZf[^擾

			and edx, __xRxB_MASK_L			// }XN eax & 0x00ff00ff	
			and ebx, __xRxB_MASK_L			// }XN ebx & 0x00ff00ff

			imul edx, dwAlphaSrc			// (np) Kp

			imul ebx, dwAlphaDst			// (np) Kp
			
			add edx, ebx					// ]̃J[(RB)Ɠ]̃J[(RB)Z
			mov eax, [esi]					// ]sNZf[^擾

			mov ebx, [edi]					// ]sNZf[^擾
			and eax, __AxGx_MASK_H			// }XN eax & 0x0000ff00

			and ebx, __AxGx_MASK_H			// (np) }XN eax & 0x0000ff00

			imul eax, dwAlphaSrc			// (np) Kp

			imul ebx, dwAlphaDst			// (np) Kp
			
			add eax, ebx					// (np) ]̃J[(G)Ɠ]̃J[(G)Z

			and eax, __xGxx_MASK_H			// [؂̂(G)
			and edx, __RxBx_MASK_L			// [؂̂(R,B)

			or eax, edx						// (np) GR,B

			shr eax, 8
			pop ebx

			mov [edi], eax					// ]sNZf[^ɓ]
			pop eax

		skip_draw1:

			add esi, Status.nSrcAddRx		// k̓]XZ
			add edi, 4						// ]WXɐi߂

			add eax, Status.nMx				// X̌덷Z
			js skip_addsrcx

			add esi, Status.nSrcAddDirX		// ]Xɐi߂
			sub eax, Status.nERx			// X덷ɕ␳ľZ

		skip_addsrcx:

			sub ecx, __DEC_WIDTH
			jns loop_x1

			mov esi, Status.pLineHead		// ۑĂAhX𕜋A
			mov eax, Status.nEx				// X̏덷𕜋A

			add esi, Status.nSrcAddRy		// k̓]YZ
			add edi, Status.nDstAddY		// ]WYɐi߂

			add ebx, Status.nMy				// Y̌덷Z
			js skip_addsrcy

			add esi, Status.nSrcAddDirY		// ]Yɐi߂
			sub ebx, Status.nERy			// Y덷ɕ␳ľZ

		skip_addsrcy:

			sub ecx, __DEC_HEIGHT
			jns loop_y1
		}
	}

	return S_OK;
}


/*----------------------------------------------------------------------------*
|	ZufBO
|	
|	[]
|	LPSDIB32GL lpSrcSDIB32GLc]SDIB32GLC^[tFCX
|	int nDstXc] x W
|	int nDstYc] y W
|	LPSIZE  lpDstSizec]̕Bl𕉂ɂ邱ƂŃ~[]B
|				NULLw肷΃ftHgTCYɂȂ܂B
|	LPPOINT lpSrcPtc]WBNULLw肷΍W(0)ɂȂ܂B
|	LPSIZE  lpSrcSizec]̕BNULLw肷΃ftHgTCYɂȂ܂B
*----------------------------------------------------------------------------*/
STDMETHODIMP CSDib32GLX86::AddBlendBlt( LPSDIB32GL lpSrcSDIB32GL, int nDstX, int nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize )
{
	// IuWFNgNULL`FbN
	_ASSERTE( lpSrcSDIB32GL != NULL );
	if( lpSrcSDIB32GL == NULL ) return E_POINTER;

	CSDib32GLX86* lpSrc = safe_cast( CSDib32GLX86*, lpSrcSDIB32GL );
	INVALIDOBJECTCHECK( lpSrc );

	_ASSERTE( m_pBits != NULL);
	_ASSERTE( lpSrc->m_pBits != NULL );

	if( m_pBits == NULL ) return SDIB32GLERR_NOTINITIALIZED;
	if( lpSrc->m_pBits == NULL ) return SDIB32GLERR_NOTINITIALIZED;

	// `Xe[^Xɓ]W̑
	SDIB32GLSTATUS Status = { nDstX, nDstY };

	// NbsO
	if( !Clipping( lpSrc, Status, lpDstSize, lpSrcPt, lpSrcSize ) ) return SDIB32GLERR_INVALIDPOSITION;

	// ]恕]̊JnAhX
	LPSDIB32GLCOLOR pSrcBits = &lpSrc->m_ppScanLine[ Status.nSrcY ][ Status.nSrcX ];
	LPSDIB32GLCOLOR pDstBits = &m_ppScanLine[ Status.nDstY ][ Status.nDstX ];

	// [vJE^AZupɕϊ
	Status.nWidth  = CONVERT_WIDTH( Status.nWidth );
	Status.nHeight = CONVERT_HEIGHT( Status.nHeight );


	if( !Status.bZoom )
	{
		// W]

		__asm
		{
			mov esi, pSrcBits				// ]AhX
			mov edi, pDstBits				// ]AhX

			mov ecx, Status.nHeight			// ]鍂(Y[vJE^)
			mov edx, Status.nSrcAddDirX

		loop_y0:

			or ecx, Status.nWidth			// ]镝(X[vJE^)
				
		loop_x0:
		
			mov eax, [esi]					// ]J[
			mov ebx, [edi]					// ]J[

			and ebx, eax					// rbgJオ蕔
			xor eax, [edi]					// rbgJオȂ

			shl ebx, 1						// Jオlɂ								<u>
			and eax, __MASK_fefefefe		// ӂꔻŎgŉ1rbg̃S~폜		<v>

			add eax, ebx					// 	(dst+src)=((dst&src)<<1)+(dst^src)
			mov ebx, [esi]

			and eax, __MASK_01010100		// ӂ̌o
			add ebx, [edi]

			shr eax, 8						// ӂŌJオrbgŉʃrbgɈړ		<u>
			add esi, edx					// ~[]XZς						<v>

			add eax, __MASK_7f7f7f7f		// ӂꂪ80AȂ7f
			add edi, 4						// ]͒ʏ

			xor eax, __MASK_7f7f7f7f		// (np) ӂꏈ̃}XN𐶐 (Jオ肠=0xFF JオȂ=0x00)

			sub ebx, eax					// (np) ӂɂĂł̐F̌덷C

			or ebx, eax						// ӂ}XNOR
			sub ecx, __DEC_WIDTH

			mov [edi-4], ebx				// ]sNZf[^ɓ]		
			jns loop_x0

			add esi, Status.nSrcAddDirY		// ̃C ~[]YZς
			add edi, Status.nDstAddY		// ̃C ]͒ʏ

			sub ecx, __DEC_HEIGHT
			jns loop_y0	
		}

	}else
	{
		// Y[]

		__asm
		{
			mov esi, pSrcBits				// ]AhX
			mov edi, pDstBits				// ]AhX
			
			mov eax, Status.nEx				// 덷
			mov ebx, Status.nEy				// c덷

			mov ecx, Status.nHeight			// (np) ]鍂(Y[vJE^)

		loop_y1:

			or ecx, Status.nWidth			// ]镝(X[vJE^)
			mov Status.pLineHead, esi		// C̊Jn擪AhXۑ

		loop_x1:

			push eax						// (np)

			mov eax, [esi]					// ]J[
			mov edx, [edi]					// ]J[

			and edx, eax					// rbgJオ蕔
			xor eax, [edi]					// rbgJオȂ

			shl edx, 1						// Jオlɂ								<u>
			and eax, __MASK_fefefefe		// ӂꔻŎgŉ1rbg̃S~폜		<v>

			add eax, edx					// 	(dst+src)=((dst&src)<<1)+(dst^src)
			mov edx, [esi]

			and eax, __MASK_01010100		// ӂ̌o
			add edx, [edi]

			shr eax, 8						// ӂŌJオrbgŉʃrbgɈړ		<u>
			add esi, Status.nSrcAddRx		// k̓]XZ						<v>

			add eax, __MASK_7f7f7f7f		// ӂꂪ80AȂ7f
			add edi, 4						// ]͒ʏ

			xor eax, __MASK_7f7f7f7f		// (np) ӂꏈ̃}XN𐶐 (Jオ肠=0xFF JオȂ=0x00)

			sub edx, eax					// (np) ӂɂĂł̐F̌덷C

			or edx, eax						// ӂ}XNOR
			pop eax

			mov [edi-4], edx				// ]sNZf[^ɓ]		
			add eax, Status.nMx				// X̌덷Z

			js skip_addsrcx					// (np)

			add esi, Status.nSrcAddDirX		// ]Xɐi߂
			sub eax, Status.nERx			// X덷ɕ␳ľZ

		skip_addsrcx:

			sub ecx, __DEC_WIDTH
			jns loop_x1

			mov esi, Status.pLineHead		// ۑĂAhX𕜋A
			mov eax, Status.nEx				// X̏덷𕜋A

			add esi, Status.nSrcAddRy		// k̓]YZ
			add edi, Status.nDstAddY		// ]WYɐi߂

			add ebx, Status.nMy				// Y̌덷Z
			js skip_addsrcy

			add esi, Status.nSrcAddDirY		// ]Yɐi߂
			sub ebx, Status.nERy			// Y덷ɕ␳ľZ

		skip_addsrcy:

			sub ecx, __DEC_HEIGHT
			jns loop_y1
		}
	}

	return S_OK;
}


/*----------------------------------------------------------------------------*
|	ZufBO
|	
|	[]
|	LPSDIB32GL lpSrcSDIB32GLc]SDIB32GLC^[tFCX
|	int nDstXc] x W
|	int nDstYc] y W
|	LPSIZE  lpDstSizec]̕Bl𕉂ɂ邱ƂŃ~[]B
|				NULLw肷΃ftHgTCYɂȂ܂B
|	LPPOINT lpSrcPtc]WBNULLw肷΍W(0)ɂȂ܂B
|	LPSIZE  lpSrcSizec]̕BNULLw肷΃ftHgTCYɂȂ܂B
|	BYTE AlphaclB
*----------------------------------------------------------------------------*/
STDMETHODIMP CSDib32GLX86::AddAlphaBlendBlt( LPSDIB32GL lpSrcSDIB32GL, int nDstX, int nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize, BYTE Alpha )
{
	// IuWFNgNULL`FbN
	_ASSERTE( lpSrcSDIB32GL != NULL );
	if( lpSrcSDIB32GL == NULL ) return E_POINTER;

	CSDib32GLX86* lpSrc = safe_cast( CSDib32GLX86*, lpSrcSDIB32GL );
	INVALIDOBJECTCHECK( lpSrc );

	_ASSERTE( m_pBits != NULL);
	_ASSERTE( lpSrc->m_pBits != NULL );

	if( m_pBits == NULL ) return SDIB32GLERR_NOTINITIALIZED;
	if( lpSrc->m_pBits == NULL ) return SDIB32GLERR_NOTINITIALIZED;

	// `Xe[^Xɓ]W̑
	SDIB32GLSTATUS Status = { nDstX, nDstY };

	// NbsO
	if( !Clipping( lpSrc, Status, lpDstSize, lpSrcPt, lpSrcSize ) ) return SDIB32GLERR_INVALIDPOSITION;

	// ]恕]̊JnAhX
	LPSDIB32GLCOLOR pSrcBits = &lpSrc->m_ppScanLine[ Status.nSrcY ][ Status.nSrcX ];
	LPSDIB32GLCOLOR pDstBits = &m_ppScanLine[ Status.nDstY ][ Status.nDstX ];
	DWORD dwAlphaSrc = CONVERT_255To256( Alpha );	// At@

	// [vJE^AZupɕϊ
	Status.nWidth  = CONVERT_WIDTH( Status.nWidth );
	Status.nHeight = CONVERT_HEIGHT( Status.nHeight );


	if( !Status.bZoom )
	{
		// W]

		__asm
		{
			mov esi, pSrcBits				// ]AhX
			mov edi, pDstBits				// ]AhX

			mov ecx, Status.nHeight			// ]鍂(Y[vJE^)

		loop_y0:

			or ecx, Status.nWidth			// ]镝(X[vJE^)
				
		loop_x0:
		
			mov eax, [esi]
			mov edx, [esi]

			and eax, __AxGx_MASK_H			// ARGBlAGɕ(A͎gȂ)
			and edx, __xRxB_MASK_L			// ARGBlRBɕ
			
			imul eax, dwAlphaSrc			// (np) Kp

			imul edx, dwAlphaSrc			// (np) Kp

			and eax, __xGxx_MASK_H			// [؂̂(G)
			and edx, __RxBx_MASK_L			// [؂̂(R,B)

			or edx, eax						// (np) GR,B

			shr edx, 8						// (np)

			mov eax, edx					// ]J[
			mov ebx, [edi]					// ]J[

			and ebx, eax					// rbgJオ蕔
			xor eax, [edi]					// rbgJオȂ

			shl ebx, 1						// Jオlɂ								<u>
			and eax, __MASK_fefefefe		// ӂꔻŎgŉ1rbg̃S~폜		<v>

			add eax, ebx					// 	(dst+src)=((dst&src)<<1)+(dst^src)
			mov ebx, edx

			and eax, __MASK_01010100		// ӂ̌o
			add ebx, [edi]

			shr eax, 8						// ӂŌJオrbgŉʃrbgɈړ		<u>
			add esi, Status.nSrcAddDirX		// ~[]XZς						<v>

			add eax, __MASK_7f7f7f7f		// ӂꂪ80AȂ7f
			add edi, 4						// ]͒ʏ

			xor eax, __MASK_7f7f7f7f		// (np) ӂꏈ̃}XN𐶐 (Jオ肠=0xFF JオȂ=0x00)

			sub ebx, eax					// (np) ӂɂĂł̐F̌덷C

			or ebx, eax						// ӂ}XNOR
			sub ecx, __DEC_WIDTH

			mov [edi-4], ebx				// ]sNZf[^ɓ]		
			jns loop_x0

			add esi, Status.nSrcAddDirY		// ̃C ~[]YZς
			add edi, Status.nDstAddY		// ̃C ]͒ʏ

			sub ecx, __DEC_HEIGHT
			jns loop_y0	
		}

	}else
	{
		// Y[]

		__asm
		{
			mov esi, pSrcBits				// ]AhX
			mov edi, pDstBits				// ]AhX
			
			mov eax, Status.nEx				// 덷
			mov ebx, Status.nEy				// c덷

			mov ecx, Status.nHeight			// (np) ]鍂(Y[vJE^)

		loop_y1:

			or ecx, Status.nWidth			// ]镝(X[vJE^)
			mov Status.pLineHead, esi		// C̊Jn擪AhXۑ

		loop_x1:

			push eax
			push ebx

			mov eax, [esi]
			mov ebx, [esi]

			and eax, __AxGx_MASK_H			// ARGBlAGɕ(A͎gȂ)
			and ebx, __xRxB_MASK_L			// ARGBlRBɕ
			
			imul eax, dwAlphaSrc			// (np) Kp

			imul ebx, dwAlphaSrc			// (np) Kp

			and eax, __xGxx_MASK_H			// [؂̂(G)
			and ebx, __RxBx_MASK_L			// [؂̂(R,B)

			or ebx, eax						// (np) GR,B

			shr ebx, 8						// (np)

			mov eax, ebx					// ]J[
			mov edx, [edi]					// ]J[

			and edx, eax					// rbgJオ蕔
			xor eax, [edi]					// rbgJオȂ

			shl edx, 1						// Jオlɂ								<u>
			and eax, __MASK_fefefefe		// ӂꔻŎgŉ1rbg̃S~폜		<v>

			add eax, edx					// 	(dst+src)=((dst&src)<<1)+(dst^src)
			mov edx, ebx

			and eax, __MASK_01010100		// ӂ̌o
			add edx, [edi]

			shr eax, 8						// ӂŌJオrbgŉʃrbgɈړ	<u>
			add esi, Status.nSrcAddRx		// k̓]XZ						<v>

			add eax, __MASK_7f7f7f7f		// ӂꂪ80AȂ7f
			add edi, 4						// ]͒ʏ

			xor eax, __MASK_7f7f7f7f		// (np) ӂꏈ̃}XN𐶐 (ӂꂠ=0xFF ӂȂ=0x00)

			sub edx, eax					// ӂɂĂł̐F̌덷C
			pop ebx

			or edx, eax						// ӂ}XNOR
			pop eax

			mov [edi-4], edx				// ]sNZf[^ɓ]		
			add eax, Status.nMx				// X̌덷Z

			js skip_addsrcx					// (np)

			add esi, Status.nSrcAddDirX		// ]Xɐi߂
			sub eax, Status.nERx			// X덷ɕ␳ľZ

		skip_addsrcx:

			sub ecx, __DEC_WIDTH
			jns loop_x1

			mov esi, Status.pLineHead		// ۑĂAhX𕜋A
			mov eax, Status.nEx				// X̏덷𕜋A

			add esi, Status.nSrcAddRy		// k̓]YZ
			add edi, Status.nDstAddY		// ]WYɐi߂

			add ebx, Status.nMy				// Y̌덷Z
			js skip_addsrcy

			add esi, Status.nSrcAddDirY		// ]Yɐi߂
			sub ebx, Status.nERy			// Y덷ɕ␳ľZ

		skip_addsrcy:

			sub ecx, __DEC_HEIGHT
			jns loop_y1
		}
	}

	return S_OK;
}


/*----------------------------------------------------------------------------*
|	ZufBO
|	
|	[]
|	LPSDIB32GL lpSrcSDIB32GLc]SDIB32GLC^[tFCX
|	int nDstXc] x W
|	int nDstYc] y W
|	LPSIZE  lpDstSizec]̕Bl𕉂ɂ邱ƂŃ~[]B
|				NULLw肷΃ftHgTCYɂȂ܂B
|	LPPOINT lpSrcPtc]WBNULLw肷΍W(0)ɂȂ܂B
|	LPSIZE  lpSrcSizec]̕BNULLw肷΃ftHgTCYɂȂ܂B
*----------------------------------------------------------------------------*/
STDMETHODIMP CSDib32GLX86::SubBlendBlt( LPSDIB32GL lpSrcSDIB32GL, int nDstX, int nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize )
{
	// IuWFNgNULL`FbN
	_ASSERTE( lpSrcSDIB32GL != NULL );
	if( lpSrcSDIB32GL == NULL ) return E_POINTER;

	CSDib32GLX86* lpSrc = safe_cast( CSDib32GLX86*, lpSrcSDIB32GL );
	INVALIDOBJECTCHECK( lpSrc );

	_ASSERTE( m_pBits != NULL);
	_ASSERTE( lpSrc->m_pBits != NULL );

	if( m_pBits == NULL ) return SDIB32GLERR_NOTINITIALIZED;
	if( lpSrc->m_pBits == NULL ) return SDIB32GLERR_NOTINITIALIZED;

	// `Xe[^Xɓ]W̑
	SDIB32GLSTATUS Status = { nDstX, nDstY };

	// NbsO
	if( !Clipping( lpSrc, Status, lpDstSize, lpSrcPt, lpSrcSize ) ) return SDIB32GLERR_INVALIDPOSITION;

	// ]恕]̊JnAhX
	LPSDIB32GLCOLOR pSrcBits = &lpSrc->m_ppScanLine[ Status.nSrcY ][ Status.nSrcX ];
	LPSDIB32GLCOLOR pDstBits = &m_ppScanLine[ Status.nDstY ][ Status.nDstX ];

	// [vJE^AZupɕϊ
	Status.nWidth  = CONVERT_WIDTH( Status.nWidth );
	Status.nHeight = CONVERT_HEIGHT( Status.nHeight );


	if( !Status.bZoom )
	{
		// W]

		__asm
		{
			mov esi, pSrcBits				// ]AhX
			mov edi, pDstBits				// ]AhX

			mov ecx, Status.nHeight			// ]鍂(Y[vJE^)

		loop_y0:

			or ecx, Status.nWidth			// ]镝(X[vJE^)
				
		loop_x0:
		
			mov eax, [esi]					// ]J[
			mov ebx, [edi]					// ]J[

			not ebx							// (np) J艺蕔JオԂɂ邽߂ɔ]

			mov edx, eax
			and eax, ebx					// rbgJオ蕔

			shl eax, 1						// Jオlɂ		<u>
			xor edx, ebx					// rbgJオȂ	<v>

			and edx, __MASK_fefefefe		// (np) ӂꔻŎgŉ1rbg̃S~폜

			add eax, edx					// (np) ӂꂷ邩ǂ

			mov edx, [esi]
			and eax, __MASK_01010100		// ӂ̌o

			shr eax, 8						// ӂŌJオrbgŉʃrbgɈړ <u>
			mov ebx, [edi]					//													<v>

			add eax, __MASK_7f7f7f7f		// ӂꂪ80AȂ7f
			add esi, Status.nSrcAddDirX		// ~[]XZς

			xor eax, __MASK_7f7f7f7f		// ӂꏈ̃}XN𐶐 (ӂꂠ=0xFF ӂȂ=0x00)
			add edi, 4						// ]͒ʏ

			or edx, eax						// ]ӂ}XNOR
			or ebx, eax						// ]ӂ}XNOR

			sub ebx, edx					// ӂĂȂ 0xFF(Dst)-0xFF(Src) = 0
			sub ecx, __DEC_WIDTH

			mov [edi-4], ebx				// `
			jns loop_x0

			add esi, Status.nSrcAddDirY		// ̃C ~[]YZς
			add edi, Status.nDstAddY		// ̃C ]͒ʏ

			sub ecx, __DEC_HEIGHT
			jns loop_y0	
		}

	}else
	{
		// Y[]

		__asm
		{
			mov esi, pSrcBits				// ]AhX
			mov edi, pDstBits				// ]AhX
			
			mov eax, Status.nEx				// 덷
			mov ebx, Status.nEy				// c덷

			mov ecx, Status.nHeight			// (np) ]鍂(Y[vJE^)

		loop_y1:

			or ecx, Status.nWidth			// ]镝(X[vJE^)
			mov Status.pLineHead, esi		// C̊Jn擪AhXۑ

		loop_x1:

			push ebx
			push eax

			mov eax, [esi]					// ]J[
			mov ebx, [edi]					// ]J[

			not ebx							// (np) J艺蕔JオԂɂ邽߂ɔ]

			mov edx, eax
			and eax, ebx					// rbgJオ蕔

			shl eax, 1						// Jオlɂ		<u>
			xor edx, ebx					// rbgJオȂ	<v>

			and edx, __MASK_fefefefe		// (np) ӂꔻŎgŉ1rbg̃S~폜

			add eax, edx					// (np) ӂꂷ邩ǂ

			mov edx, [esi]
			and eax, __MASK_01010100		// ӂ̌o

			shr eax, 8						// ӂŌJオrbgŉʃrbgɈړ <u>
			mov ebx, [edi]					//													<v>

			add eax, __MASK_7f7f7f7f		// ӂꂪ80AȂ7f
			add esi, Status.nSrcAddRx		// k̓]XZ

			xor eax, __MASK_7f7f7f7f		// ӂꏈ̃}XN𐶐 (ӂꂠ=0xFF ӂȂ=0x00)
			add edi, 4						// ]͒ʏ

			or edx, eax						// ]ӂ}XNOR
			or ebx, eax						// ]ӂ}XNOR

			sub ebx, edx					// ӂĂȂ 0xFF(Dst)-0xFF(Src) = 0
			pop eax

			mov [edi-4], ebx				// `
			pop ebx

			add eax, Status.nMx				// X̌덷Z
			js skip_addsrcx

			add esi, Status.nSrcAddDirX		// ]Xɐi߂
			sub eax, Status.nERx			// X덷ɕ␳ľZ

		skip_addsrcx:

			sub ecx, __DEC_WIDTH
			jns loop_x1

			mov esi, Status.pLineHead		// ۑĂAhX𕜋A
			mov eax, Status.nEx				// X̏덷𕜋A

			add esi, Status.nSrcAddRy		// k̓]YZ
			add edi, Status.nDstAddY		// ]WYɐi߂

			add ebx, Status.nMy				// Y̌덷Z
			js skip_addsrcy

			add esi, Status.nSrcAddDirY		// ]Yɐi߂
			sub ebx, Status.nERy			// Y덷ɕ␳ľZ

		skip_addsrcy:

			sub ecx, __DEC_HEIGHT
			jns loop_y1
		}
	}

	return S_OK;
}


/*----------------------------------------------------------------------------*
|	ZufBO
|	
|	[]
|	LPSDIB32GL lpSrcSDIB32GLc]SDIB32GLC^[tFCX
|	int nDstXc] x W
|	int nDstYc] y W
|	LPSIZE  lpDstSizec]̕Bl𕉂ɂ邱ƂŃ~[]B
|				NULLw肷΃ftHgTCYɂȂ܂B
|	LPPOINT lpSrcPtc]WBNULLw肷΍W(0)ɂȂ܂B
|	LPSIZE  lpSrcSizec]̕BNULLw肷΃ftHgTCYɂȂ܂B
|	BYTE AlphaclB
*----------------------------------------------------------------------------*/
STDMETHODIMP CSDib32GLX86::SubAlphaBlendBlt( LPSDIB32GL lpSrcSDIB32GL, int nDstX, int nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize, BYTE Alpha )
{
	// IuWFNgNULL`FbN
	_ASSERTE( lpSrcSDIB32GL != NULL );
	if( lpSrcSDIB32GL == NULL ) return E_POINTER;

	CSDib32GLX86* lpSrc = safe_cast( CSDib32GLX86*, lpSrcSDIB32GL );
	INVALIDOBJECTCHECK( lpSrc );

	_ASSERTE( m_pBits != NULL);
	_ASSERTE( lpSrc->m_pBits != NULL );

	if( m_pBits == NULL ) return SDIB32GLERR_NOTINITIALIZED;
	if( lpSrc->m_pBits == NULL ) return SDIB32GLERR_NOTINITIALIZED;

	// `Xe[^Xɓ]W̑
	SDIB32GLSTATUS Status = { nDstX, nDstY };

	// NbsO
	if( !Clipping( lpSrc, Status, lpDstSize, lpSrcPt, lpSrcSize ) ) return SDIB32GLERR_INVALIDPOSITION;

	// ]恕]̊JnAhX
	LPSDIB32GLCOLOR pSrcBits = &lpSrc->m_ppScanLine[ Status.nSrcY ][ Status.nSrcX ];
	LPSDIB32GLCOLOR pDstBits = &m_ppScanLine[ Status.nDstY ][ Status.nDstX ];
	DWORD dwAlphaSrc = CONVERT_255To256( Alpha );	// At@
	

	// [vJE^AZupɕϊ
	Status.nWidth  = CONVERT_WIDTH( Status.nWidth );
	Status.nHeight = CONVERT_HEIGHT( Status.nHeight );


	if( !Status.bZoom )
	{
		// W]

		__asm
		{
			mov esi, pSrcBits				// ]AhX
			mov edi, pDstBits				// ]AhX

			mov ecx, Status.nHeight			// ]鍂(Y[vJE^)

		loop_y0:

			or ecx, Status.nWidth			// ]镝(X[vJE^)
				
		loop_x0:
		
			mov eax, [esi]
			mov edx, [esi]

			and eax, __AxGx_MASK_H			// ARGBlAGɕ(A͎gȂ)
			and edx, __xRxB_MASK_L			// ARGBlRBɕ
			
			imul eax, dwAlphaSrc			// (np) Kp

			imul edx, dwAlphaSrc			// (np) Kp

			and eax, __xGxx_MASK_H			// [؂̂(G)
			and edx, __RxBx_MASK_L			// [؂̂(R,B)

			or edx, eax						// (np) GR,B

			shr edx, 8						// (np)

			mov eax, edx					// ]J[
			mov ebx, [edi]					// ]J[

			not ebx							// (np) J艺蕔JオԂɂ邽߂ɔ]

			and eax, ebx					// (np) rbgJオ蕔

			shl eax, 1						// Jオlɂ		<u>
			xor ebx, edx					// rbgJオȂ	<v>

			and ebx, __MASK_fefefefe		// (np) ӂꔻŎgŉ1rbg̃S~폜

			add eax, ebx					// (np) ӂꂷ邩ǂ

			and eax, __MASK_01010100		// ӂ̌o

			shr eax, 8						// ӂŌJオrbgŉʃrbgɈړ <u>
			mov ebx, [edi]					//													<v>

			add eax, __MASK_7f7f7f7f		// ӂꂪ80AȂ7f
			add esi, Status.nSrcAddDirX		// ~[]XZς

			xor eax, __MASK_7f7f7f7f		// ӂꏈ̃}XN𐶐 (ӂꂠ=0xFF ӂȂ=0x00)
			add edi, 4						// ]͒ʏ

			or edx, eax						// ]ӂ}XNOR
			or ebx, eax						// ]ӂ}XNOR

			sub ebx, edx					// ӂĂȂ 0xFF(Dst)-0xFF(Src) = 0
			sub ecx, __DEC_WIDTH

			mov [edi-4], ebx				// `
			jns loop_x0

			add esi, Status.nSrcAddDirY		// ̃C ~[]YZς
			add edi, Status.nDstAddY		// ̃C ]͒ʏ

			sub ecx, __DEC_HEIGHT
			jns loop_y0	
		}

	}else
	{
		// Y[]

		__asm
		{
			mov esi, pSrcBits				// ]AhX
			mov edi, pDstBits				// ]AhX
			
			mov eax, Status.nEx				// 덷
			mov ebx, Status.nEy				// c덷

			mov ecx, Status.nHeight			// (np) ]鍂(Y[vJE^)

		loop_y1:

			or ecx, Status.nWidth			// ]镝(X[vJE^)
			mov Status.pLineHead, esi		// C̊Jn擪AhXۑ

		loop_x1:

			push ebx
			push eax

			mov eax, [esi]
			mov edx, [esi]

			and eax, __AxGx_MASK_H			// ARGBlAGɕ(A͎gȂ)
			and edx, __xRxB_MASK_L			// ARGBlRBɕ
			
			imul eax, dwAlphaSrc			// (np) Kp

			imul edx, dwAlphaSrc			// (np) Kp

			and eax, __xGxx_MASK_H			// [؂̂(G)
			and edx, __RxBx_MASK_L			// [؂̂(R,B)

			or edx, eax						// (np) GR,B

			shr edx, 8						// (np)

			mov eax, edx					// ]J[
			mov ebx, [edi]					// ]J[

			not ebx							// (np) J艺蕔JオԂɂ邽߂ɔ]

			and eax, ebx					// (np) rbgJオ蕔

			shl eax, 1						// Jオlɂ		<u>
			xor ebx, edx					// rbgJオȂ	<v>

			and ebx, __MASK_fefefefe		// (np) ӂꔻŎgŉ1rbg̃S~폜

			add eax, ebx					// (np) ӂꂷ邩ǂ

			and eax, __MASK_01010100		// ӂ̌o

			shr eax, 8						// ӂŌJオrbgŉʃrbgɈړ <u>
			mov ebx, [edi]					//													<v>

			add eax, __MASK_7f7f7f7f		// ӂꂪ80AȂ7f
			add esi, Status.nSrcAddRx		// k̓]XZ

			xor eax, __MASK_7f7f7f7f		// ӂꏈ̃}XN𐶐 (ӂꂠ=0xFF ӂȂ=0x00)
			add edi, 4						// ]͒ʏ

			or edx, eax						// ]ӂ}XNOR
			or ebx, eax						// ]ӂ}XNOR

			sub ebx, edx					// ӂĂȂ 0xFF(Dst)-0xFF(Src) = 0
			pop eax

			mov [edi-4], ebx				// `
			pop ebx

			add eax, Status.nMx				// X̌덷Z
			js skip_addsrcx

			add esi, Status.nSrcAddDirX		// ]Xɐi߂
			sub eax, Status.nERx			// X덷ɕ␳ľZ

		skip_addsrcx:

			sub ecx, __DEC_WIDTH
			jns loop_x1

			mov esi, Status.pLineHead		// ۑĂAhX𕜋A
			mov eax, Status.nEx				// X̏덷𕜋A

			add esi, Status.nSrcAddRy		// k̓]YZ
			add edi, Status.nDstAddY		// ]WYɐi߂

			add ebx, Status.nMy				// Y̌덷Z
			js skip_addsrcy

			add esi, Status.nSrcAddDirY		// ]Yɐi߂
			sub ebx, Status.nERy			// Y덷ɕ␳ľZ

		skip_addsrcy:

			sub ecx, __DEC_HEIGHT
			jns loop_y1
		}
	}

	return S_OK;
}


/*----------------------------------------------------------------------------*
|	`l摜]
|	
|	[]
|	LPSDIB32GL lpSrcSDIB32GLc]SDIB32GLC^[tFCX
|	int nDstXc] x W
|	int nDstYc] y W
|	LPSIZE  lpDstSizec]̕Bl𕉂ɂ邱ƂŃ~[]B
|				NULLw肷΃ftHgTCYɂȂ܂B
|	LPPOINT lpSrcPtc]WBNULLw肷΍W(0)ɂȂ܂B
|	LPSIZE  lpSrcSizec]̕BNULLw肷΃ftHgTCYɂȂ܂B
*----------------------------------------------------------------------------*/
STDMETHODIMP CSDib32GLX86::AlphaChannelBlt( LPSDIB32GL lpSrcSDIB32GL, int nDstX, int nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize )
{
	// IuWFNgNULL`FbN
	_ASSERTE( lpSrcSDIB32GL != NULL );
	if( lpSrcSDIB32GL == NULL ) return E_POINTER;

	CSDib32GLX86* lpSrc = safe_cast( CSDib32GLX86*, lpSrcSDIB32GL );
	INVALIDOBJECTCHECK( lpSrc );

	_ASSERTE( m_pBits != NULL);
	_ASSERTE( lpSrc->m_pBits != NULL );

	if( m_pBits == NULL ) return SDIB32GLERR_NOTINITIALIZED;
	if( lpSrc->m_pBits == NULL ) return SDIB32GLERR_NOTINITIALIZED;

	// `Xe[^Xɓ]W̑
	SDIB32GLSTATUS Status = { nDstX, nDstY };

	// NbsO
	if( !Clipping( lpSrc, Status, lpDstSize, lpSrcPt, lpSrcSize ) ) return SDIB32GLERR_INVALIDPOSITION;

	// ]恕]̊JnAhX
	LPSDIB32GLCOLOR pSrcBits = &lpSrc->m_ppScanLine[ Status.nSrcY ][ Status.nSrcX ];
	LPSDIB32GLCOLOR pDstBits = &m_ppScanLine[ Status.nDstY ][ Status.nDstX ];

	DWORD dwAlphaSrc;
	DWORD dwAlphaDst;

	// [vJE^AZupɕϊ
	Status.nWidth  = CONVERT_WIDTH( Status.nWidth );
	Status.nHeight = CONVERT_HEIGHT( Status.nHeight );


	if( !Status.bZoom )
	{
		// W]
		__asm
		{
			mov esi, pSrcBits				// ]AhX
			mov edi, pDstBits				// ]AhX

			mov ecx, Status.nHeight			// ]鍂(Y[vJE^)

		loop_y0:

			or ecx, Status.nWidth			// ]镝(X[vJE^)

		loop_x0:
		
			mov ebx, [esi]					// ]sNZf[^擾
			mov eax, 256					// ]̃`lp

			shr ebx, 24						// `l擾
			mov edx, [esi]					// ]sNZf[^擾
			
			shr edx, 31						// ŏʃrbg擾
			sub eax, ebx					// 256-`l

			add ebx, edx					// ]`l256iKɂ
			sub eax, edx					// ]惿`l256iKɂ

			mov dwAlphaSrc, ebx				// ]`l
			mov dwAlphaDst, eax				// ]惿`l

			mov edx, [esi]					// ]sNZf[^擾
			mov ebx, [edi]					// ]sNZf[^擾

			and edx, __xRxB_MASK_L			// }XN eax & 0x00ff00ff	
			and ebx, __xRxB_MASK_L			// }XN ebx & 0x00ff00ff

			imul edx, dwAlphaSrc			// (np) Kp

			imul ebx, dwAlphaDst			// (np) Kp
			
			add edx, ebx					// ]̃J[(RB)Ɠ]̃J[(RB)Z
			mov eax, [esi]					// ]sNZf[^擾

			mov ebx, [edi]					// ]sNZf[^擾
			and eax, __AxGx_MASK_H			// }XN eax & 0x0000ff00

			and ebx, __AxGx_MASK_H			// (np) }XN eax & 0x0000ff00
			add esi, Status.nSrcAddDirX		// ~[]XZς

			imul eax, dwAlphaSrc			// (np) Kp

			imul ebx, dwAlphaDst			// (np) Kp
			
			add eax, ebx					// (np) ]̃J[(G)Ɠ]̃J[(G)Z
			add edi, 4						// ]͒ʏ

			and eax, __xGxx_MASK_H			// [؂̂(G)
			and edx, __RxBx_MASK_L			// [؂̂(R,B)

			or eax, edx						// (np) GR,B
			
			shr eax, 8
			sub ecx, __DEC_WIDTH

			mov [edi-4], eax				// ]sNZf[^ɓ]
			jns loop_x0

			add esi, Status.nSrcAddDirY		// ̃C ~[]YZς
			add edi, Status.nDstAddY		// ̃C ]͒ʏ

			sub ecx, __DEC_HEIGHT
			jns loop_y0	

		}


	}else
	{
		// Y[]

		__asm
		{
			mov esi, pSrcBits				// ]AhX
			mov edi, pDstBits				// ]AhX
			
			mov eax, Status.nEx				// 덷
			mov ebx, Status.nEy				// c덷

			mov ecx, Status.nHeight			// (np) ]鍂(Y[vJE^)

		loop_y1:

			or ecx, Status.nWidth			// ]镝(X[vJE^)
			mov Status.pLineHead, esi		// C̊Jn擪AhXۑ

		loop_x1:

			push eax
			push ebx

			mov ebx, [esi]					// ]sNZf[^擾
			mov eax, 256					// ]̃`lp

			shr ebx, 24						// `l擾
			mov edx, [esi]					// ]sNZf[^擾
			
			shr edx, 31						// ŏʃrbg擾
			sub eax, ebx					// 256-`l

			add ebx, edx					// ]`l256iKɂ
			sub eax, edx					// ]惿`l256iKɂ

			mov dwAlphaSrc, ebx				// ]
			mov dwAlphaDst, eax				// ]惿

			mov edx, [esi]					// ]sNZf[^擾
			mov ebx, [edi]					// ]sNZf[^擾

			and edx, __xRxB_MASK_L			// }XN eax & 0x00ff00ff	
			and ebx, __xRxB_MASK_L			// }XN ebx & 0x00ff00ff

			imul edx, dwAlphaSrc			// (np) Kp

			imul ebx, dwAlphaDst			// (np) Kp
			
			add edx, ebx					// ]̃J[(RB)Ɠ]̃J[(RB)Z
			mov eax, [esi]					// ]sNZf[^擾

			mov ebx, [edi]					// ]sNZf[^擾
			and eax, __AxGx_MASK_H			// }XN eax & 0x0000ff00

			and ebx, __AxGx_MASK_H			// (np) }XN eax & 0x0000ff00
			add esi, Status.nSrcAddRx		// k̓]XZ

			imul eax, dwAlphaSrc			// (np) Kp

			imul ebx, dwAlphaDst			// (np) Kp
			
			add eax, ebx					// (np) ]̃J[(G)Ɠ]̃J[(G)Z
			add edi, 4						// ]WXɐi߂

			and eax, __xGxx_MASK_H			// [؂̂(G)
			and edx, __RxBx_MASK_L			// [؂̂(R,B)

			or eax, edx						// (np) GR,B

			shr eax, 8
			pop ebx

			mov [edi-4], eax				// ]sNZf[^ɓ]
			pop eax

			add eax, Status.nMx				// X̌덷Z
			js skip_addsrcx

			add esi, Status.nSrcAddDirX		// ]Xɐi߂
			sub eax, Status.nERx			// X덷ɕ␳ľZ

		skip_addsrcx:

			sub ecx, __DEC_WIDTH
			jns loop_x1

			mov esi, Status.pLineHead		// ۑĂAhX𕜋A
			mov eax, Status.nEx				// X̏덷𕜋A

			add esi, Status.nSrcAddRy		// k̓]YZ
			add edi, Status.nDstAddY		// ]WYɐi߂

			add ebx, Status.nMy				// Y̌덷Z
			js skip_addsrcy

			add esi, Status.nSrcAddDirY		// ]Yɐi߂
			sub ebx, Status.nERy			// Y덷ɕ␳ľZ

		skip_addsrcy:

			sub ecx, __DEC_HEIGHT
			jns loop_y1
		}
	}

	return S_OK;
}


/*----------------------------------------------------------------------------*
|	`l摜ufBO]
|	
|	[]
|	LPSDIB32GL lpSrcSDIB32GLc]SDIB32GLC^[tFCX
|	int nDstXc] x W
|	int nDstYc] y W
|	LPSIZE  lpDstSizec]̕Bl𕉂ɂ邱ƂŃ~[]B
|				NULLw肷΃ftHgTCYɂȂ܂B
|	LPPOINT lpSrcPtc]WBNULLw肷΍W(0)ɂȂ܂B
|	LPSIZE  lpSrcSizec]̕BNULLw肷΃ftHgTCYɂȂ܂B
|	BYTE AlphaclB
*----------------------------------------------------------------------------*/
STDMETHODIMP CSDib32GLX86::AlphaChannelAlphaBlendBlt( LPSDIB32GL lpSrcSDIB32GL, int nDstX, int nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize, BYTE Alpha )
{

	// IuWFNgNULL`FbN
	_ASSERTE( lpSrcSDIB32GL != NULL );
	if( lpSrcSDIB32GL == NULL ) return E_POINTER;

	CSDib32GLX86* lpSrc = safe_cast( CSDib32GLX86*, lpSrcSDIB32GL );
	INVALIDOBJECTCHECK( lpSrc );

	_ASSERTE( m_pBits != NULL);
	_ASSERTE( lpSrc->m_pBits != NULL );

	if( m_pBits == NULL ) return SDIB32GLERR_NOTINITIALIZED;
	if( lpSrc->m_pBits == NULL ) return SDIB32GLERR_NOTINITIALIZED;

	// `Xe[^Xɓ]W̑
	SDIB32GLSTATUS Status = { nDstX, nDstY };

	// NbsO
	if( !Clipping( lpSrc, Status, lpDstSize, lpSrcPt, lpSrcSize ) ) return SDIB32GLERR_INVALIDPOSITION;

	// ]恕]̊JnAhX
	LPSDIB32GLCOLOR pSrcBits = &lpSrc->m_ppScanLine[ Status.nSrcY ][ Status.nSrcX ];
	LPSDIB32GLCOLOR pDstBits = &m_ppScanLine[ Status.nDstY ][ Status.nDstX ];

	DWORD dwAlpha = CONVERT_255To256( Alpha );
	DWORD dwAlphaSrc;
	DWORD dwAlphaDst;

	// [vJE^AZupɕϊ
	Status.nWidth  = CONVERT_WIDTH( Status.nWidth );
	Status.nHeight = CONVERT_HEIGHT( Status.nHeight );


	if( !Status.bZoom )
	{
		// W]
		__asm
		{
			mov esi, pSrcBits				// ]AhX
			mov edi, pDstBits				// ]AhX

			mov ecx, Status.nHeight			// ]鍂(Y[vJE^)

		loop_y0:

			or ecx, Status.nWidth			// ]镝(X[vJE^)

		loop_x0:
		
			mov ebx, [esi]					// ]sNZf[^擾
			mov eax, 256					// ]̃`lp

			shr ebx, 24						// `l擾
			mov edx, [esi]					// ]sNZf[^擾
			
			shr edx, 31						// ŏʃrbg擾

			add ebx, edx					// ]`l256iKɂ
	
			imul ebx, dwAlpha				// `l

			shr ebx, 8						// 
			mov edx, [esi]					// ]sNZf[^擾

			sub eax, ebx					// 256-
			mov dwAlphaSrc, ebx				// ]`l

			mov ebx, [edi]					// ]sNZf[^擾
			mov dwAlphaDst, eax				// ]惿`l

			and edx, __xRxB_MASK_L			// }XN eax & 0x00ff00ff	
			and ebx, __xRxB_MASK_L			// }XN ebx & 0x00ff00ff

			imul edx, dwAlphaSrc			// (np) Kp

			imul ebx, dwAlphaDst			// (np) Kp
			
			add edx, ebx					// ]̃J[(RB)Ɠ]̃J[(RB)Z
			mov eax, [esi]					// ]sNZf[^擾

			mov ebx, [edi]					// ]sNZf[^擾
			and eax, __AxGx_MASK_H			// }XN eax & 0x0000ff00

			and ebx, __AxGx_MASK_H			// (np) }XN eax & 0x0000ff00
			add esi, Status.nSrcAddDirX		// ~[]XZς

			imul eax, dwAlphaSrc			// (np) Kp

			imul ebx, dwAlphaDst			// (np) Kp
			
			add eax, ebx					// (np) ]̃J[(G)Ɠ]̃J[(G)Z
			add edi, 4						// ]͒ʏ

			and eax, __xGxx_MASK_H			// [؂̂(G)
			and edx, __RxBx_MASK_L			// [؂̂(R,B)

			or eax, edx						// (np) GR,B
			
			shr eax, 8
			sub ecx, __DEC_WIDTH

			mov [edi-4], eax				// ]sNZf[^ɓ]
			jns loop_x0

			add esi, Status.nSrcAddDirY		// ̃C ~[]YZς
			add edi, Status.nDstAddY		// ̃C ]͒ʏ

			sub ecx, __DEC_HEIGHT
			jns loop_y0	

		}


	}else
	{
		// Y[]

		__asm
		{
			mov esi, pSrcBits				// ]AhX
			mov edi, pDstBits				// ]AhX
			
			mov eax, Status.nEx				// 덷
			mov ebx, Status.nEy				// c덷

			mov ecx, Status.nHeight			// (np) ]鍂(Y[vJE^)

		loop_y1:

			or ecx, Status.nWidth			// ]镝(X[vJE^)
			mov Status.pLineHead, esi		// C̊Jn擪AhXۑ

		loop_x1:

			push eax
			push ebx

			mov ebx, [esi]					// ]sNZf[^擾
			mov eax, 256					// ]̃`lp

			shr ebx, 24						// `l擾
			mov edx, [esi]					// ]sNZf[^擾
			
			shr edx, 31						// ŏʃrbg擾

			add ebx, edx					// ]`l256iKɂ
	
			imul ebx, dwAlpha				// `lɃKp

			shr ebx, 8						// 
			mov edx, [esi]					// ]sNZf[^擾

			sub eax, ebx					// 256-
			mov dwAlphaSrc, ebx				// ]`l

			mov ebx, [edi]					// ]sNZf[^擾
			mov dwAlphaDst, eax				// ]惿`l

			and edx, __xRxB_MASK_L			// }XN eax & 0x00ff00ff	
			and ebx, __xRxB_MASK_L			// }XN ebx & 0x00ff00ff

			imul edx, dwAlphaSrc			// (np) Kp

			imul ebx, dwAlphaDst			// (np) Kp
			
			add edx, ebx					// ]̃J[(RB)Ɠ]̃J[(RB)Z
			mov eax, [esi]					// ]sNZf[^擾

			mov ebx, [edi]					// ]sNZf[^擾
			and eax, __AxGx_MASK_H			// }XN eax & 0x0000ff00

			and ebx, __AxGx_MASK_H			// (np) }XN eax & 0x0000ff00
			add esi, Status.nSrcAddRx		// k̓]XZ

			imul eax, dwAlphaSrc			// (np) Kp

			imul ebx, dwAlphaDst			// (np) Kp
			
			add eax, ebx					// (np) ]̃J[(G)Ɠ]̃J[(G)Z
			add edi, 4						// ]WXɐi߂

			and eax, __xGxx_MASK_H			// [؂̂(G)
			and edx, __RxBx_MASK_L			// [؂̂(R,B)

			or eax, edx						// (np) GR,B

			shr eax, 8
			pop ebx

			mov [edi-4], eax				// ]sNZf[^ɓ]
			pop eax

			add eax, Status.nMx				// X̌덷Z
			js skip_addsrcx

			add esi, Status.nSrcAddDirX		// ]Xɐi߂
			sub eax, Status.nERx			// X덷ɕ␳ľZ

		skip_addsrcx:

			sub ecx, __DEC_WIDTH
			jns loop_x1

			mov esi, Status.pLineHead		// ۑĂAhX𕜋A
			mov eax, Status.nEx				// X̏덷𕜋A

			add esi, Status.nSrcAddRy		// k̓]YZ
			add edi, Status.nDstAddY		// ]WYɐi߂

			add ebx, Status.nMy				// Y̌덷Z
			js skip_addsrcy

			add esi, Status.nSrcAddDirY		// ]Yɐi߂
			sub ebx, Status.nERy			// Y덷ɕ␳ľZ

		skip_addsrcy:

			sub ecx, __DEC_HEIGHT
			jns loop_y1
		}
	}

	return S_OK;
}


/*----------------------------------------------------------------------------*
|	]ufBO
|	
|	[]
|	LPSDIB32GL lpSrcSDIB32GLc]SDIB32GLC^[tFCX
|	int nDstXc] x W
|	int nDstYc] y W
|	LPSIZE  lpDstSizec]̕Bl𕉂ɂ邱ƂŃ~[]B
|				NULLw肷΃ftHgTCYɂȂ܂B
|	LPPOINT lpSrcPtc]WBNULLw肷΍W(0)ɂȂ܂B
|	LPSIZE  lpSrcSizec]̕BNULLw肷΃ftHgTCYɂȂ܂B
|	BYTE AlphaclB
|	int		nAnglec]pxB1512x̒lłB
|	LPPOINT lpCenterPtc]SWBNULLw肷Ό݂̃|WV𒆐Sɂ܂B
*----------------------------------------------------------------------------*/
STDMETHODIMP CSDib32GLX86::RotateAlphaBlendBlt( LPSDIB32GL lpSrcSDIB32GL, int nDstX, int nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize, BYTE Alpha, int nAngle, LPPOINT lpCenterPt )
{
	// IuWFNgNULL`FbN
	_ASSERTE( lpSrcSDIB32GL != NULL );
	if( lpSrcSDIB32GL == NULL ) return E_POINTER;

	CSDib32GLX86* lpSrc = safe_cast( CSDib32GLX86*, lpSrcSDIB32GL );
	INVALIDOBJECTCHECK( lpSrc );

	_ASSERTE( m_pBits != NULL);
	_ASSERTE( lpSrc->m_pBits != NULL );

	if( m_pBits == NULL ) return SDIB32GLERR_NOTINITIALIZED;
	if( lpSrc->m_pBits == NULL ) return SDIB32GLERR_NOTINITIALIZED;

	// `Xe[^Xɓ]W̑
	SDIB32GLROTATESTATUS Status = { nDstX, nDstY, nAngle };

	// NbsO
	if( !Clipping( lpSrc, Status, lpDstSize, lpSrcPt, lpSrcSize, lpCenterPt ) ) return SDIB32GLERR_INVALIDPOSITION;

	// ]恕]̊JnAhX
	LPSDIB32GLCOLOR* ppSrcScanLine = lpSrc->m_ppScanLine;
	LPSDIB32GLCOLOR pDstBits = &m_ppScanLine[ Status.nDstY ][ Status.nDstX ];

	DWORD dwAlphaSrc = CONVERT_255To256( Alpha );	// At@
	DWORD dwAlphaDst = DEST_ALPHA( dwAlphaSrc );

	// [vJE^AZupɕϊ
	Status.nWidth  = CONVERT_WIDTH( Status.nWidth );
	Status.nHeight = CONVERT_HEIGHT( Status.nHeight );

	if( !Status.b64bit )
	{
		// Œ菬32rbgvZ

		__asm
		{
			mov ecx, Status.nHeight			// ]鍂(Y[vJE^)
			mov edi, pDstBits				// ]AhX

			mov eax, Status.fxSrcScanX		// JnWx
			mov ebx, Status.fxSrcScanY		// JnWy

		loop_y0:

			or ecx, Status.nWidth			// ]镝(X[vJE^)

		loop_x0:
		
			// ]NbsO
			cmp eax, Status.fxSrcLeft		// if( x < Status.fxSrcLeft ) skip
			jl skip_draw0

			cmp ebx, Status.fxSrcTop		// if( y < Status.fxSrcTop ) skip
			jl skip_draw0

			cmp eax, Status.fxSrcRight		// if( x >= Status.fxSrcRight ) skip
			jge skip_draw0

			cmp ebx, Status.fxSrcBottom		// if( y >= Status.fxSrcBottom ) skip
			jge skip_draw0

			push eax						// Œ菬xX^bNɕۑ
			push ebx						// Œ菬yX^bNɕۑ
			
			shr ebx, 16						// Œ菬y𐮐ɂ
			mov esi, ppSrcScanLine			// ]AhX

			shr eax, 16						// Œ菬x𐮐ɂ
			mov esi, [esi+ebx*4]			// ppSrcScanLine[y]

			mov esi, [esi+eax*4]			// (np) ]sNZf[^擾 = ppSrcScanLine[y][x]
			
			mov edx, esi					// ]sNZf[^擾
			mov ebx, [edi]					// ]sNZf[^擾

			and edx, __xRxB_MASK_L			// }XN eax & 0x00ff00ff	
			and ebx, __xRxB_MASK_L			// }XN ebx & 0x00ff00ff

			imul edx, dwAlphaSrc			// (np) Kp
			
			imul ebx, dwAlphaDst			// (np) Kp

			add edx, ebx					// ]̃J[(RB)Ɠ]̃J[(RB)Z
			mov ebx, [edi]					// ]sNZf[^擾

			and esi, __AxGx_MASK_H			// }XN eax & 0x0000ff00
			and ebx, __AxGx_MASK_H			// (np) }XN eax & 0x0000ff00

			imul esi, dwAlphaSrc			// (np) Kp

			imul ebx, dwAlphaDst			// (np) Kp

			add esi, ebx					// (np) ]̃J[(G)Ɠ]̃J[(G)Z

			and esi, __xGxx_MASK_H			// [؂̂(G)
			and edx, __RxBx_MASK_L			// [؂̂(R,B)

			or esi, edx						// (np) GR,B

			shr esi, 8
			pop ebx							// Œ菬xX^bNo

			mov [edi], esi					// ]sNZf[^ɓ]
			pop eax							// Œ菬yX^bNo

	skip_draw0:

			add eax, Status.fxSrcAddXx		// x += Status.fxSrcAddXx
			add ebx, Status.fxSrcAddXy		// y += Status.fxSrcAddXy
			
			add edi, 4						// ]͒ʏ
			sub ecx, __DEC_WIDTH

			jns loop_x0						// (np)

			add eax, Status.fxSrcAddYx		// x += Status.fxSrcAddYx
			add ebx, Status.fxSrcAddYy		// y += Status.fxSrcAddYy
			
			add edi, Status.nDstAddY		// ̃C ]͒ʏ
			sub ecx, __DEC_HEIGHT

			jns loop_y0						// (np)

		}

	}else
	{
		// Œ菬64rbgvZ(d)

		__asm
		{
			mov ecx, Status.nHeight			// ]鍂(Y[vJE^)
			mov edi, pDstBits				// ]AhX

			mov eax, Status.fxSrcScanX_H	// JnWx ()
			mov ebx, Status.fxSrcScanY_H	// JnWy ()
			
			mov esi, Status.fxSrcScanX_L	// JnWx ()
			mov edx, Status.fxSrcScanY_L	// JnWy ()

		loop_y1:

			or ecx, Status.nWidth			// ]镝(X[vJE^)

		loop_x1:
		
			// ]NbsO
			cmp eax, Status.nSrcLeft		// if( x < Status.nSrcLeft ) skip
			jl skip_draw1

			cmp ebx, Status.nSrcTop			// if( y < Status.nSrcTop ) skip
			jl skip_draw1

			cmp eax, Status.nSrcRight		// if( x >= Status.nSrcRight ) skip
			jge skip_draw1

			cmp ebx, Status.nSrcBottom		// if( y >= Status.nSrcBottom ) skip
			jge skip_draw1
			
			push esi						// (np)
			push edx

			mov esi, ppSrcScanLine			// (np) ]AhX
			push ebx

			mov esi, [esi+ebx*4]			// (np) ppSrcScanLine[y]

			mov esi, [esi+eax*4]			// (np) ]sNZf[^擾 = ppSrcScanLine[y][x]
			
			mov edx, esi					// ]sNZf[^擾
			mov ebx, [edi]					// ]sNZf[^擾

			and edx, __xRxB_MASK_L			// }XN eax & 0x00ff00ff	
			and ebx, __xRxB_MASK_L			// }XN ebx & 0x00ff00ff

			imul edx, dwAlphaSrc			// (np) Kp

			imul ebx, dwAlphaDst			// (np) Kp

			add edx, ebx					// ]̃J[(RB)Ɠ]̃J[(RB)Z
			mov ebx, [edi]					// ]sNZf[^擾

			and esi, __AxGx_MASK_H			// }XN eax & 0x0000ff00
			and ebx, __AxGx_MASK_H			// (np) }XN eax & 0x0000ff00

			imul esi, dwAlphaSrc			// (np) Kp

			imul ebx, dwAlphaDst			// (np) Kp

			add esi, ebx					// (np) ]̃J[(G)Ɠ]̃J[(G)Z

			and esi, __xGxx_MASK_H			// [؂̂(G)
			and edx, __RxBx_MASK_L			// [؂̂(R,B)

			or esi, edx						// (np) GR,B
			pop ebx

			shr esi, 8
			pop edx

			mov [edi], esi					// (np) ]sNZf[^ɓ]
			pop esi							// (np)

	skip_draw1:

			add esi, Status.fxSrcAddXx_L	// (np) x += Status.fxSrcAddXx_L@()

			adc eax, Status.fxSrcAddXx_H	// x += Status.fxSrcAddXx_H ()	<u>
			add edx, Status.fxSrcAddXy_L	// y += Status.fxSrcAddXy_L	()	<v>

			adc ebx, Status.fxSrcAddXy_H	// y += Status.fxSrcAddXy_H	()	<u>
			add edi, 4						// ]͒ʏ					<v>

			sub ecx, __DEC_WIDTH
			jns loop_x1

			add esi, Status.fxSrcAddYx_L	// (np) x += Status.fxSrcAddYx_L@()

			adc eax, Status.fxSrcAddYx_H	// x += Status.fxSrcAddYx_H ()	<u>
			add edx, Status.fxSrcAddYy_L	// y += Status.fxSrcAddYy_L	()	<v>

			adc ebx, Status.fxSrcAddYy_H	// y += Status.fxSrcAddYy_H	()	<u>
			add edi, Status.nDstAddY		// ̃C ]͒ʏ	<v>

			sub ecx, __DEC_HEIGHT
			jns loop_y1
		}

		return SDIB32GLS_ROTATEBLT64BIT;
	}

	return S_OK;
}


/*----------------------------------------------------------------------------*
|	]߃ufBO
|	
|	[]
|	LPSDIB32GL lpSrcSDIB32GLc]SDIB32GLC^[tFCX
|	int nDstXc] x W
|	int nDstYc] y W
|	LPSIZE  lpDstSizec]̕Bl𕉂ɂ邱ƂŃ~[]B
|				NULLw肷΃ftHgTCYɂȂ܂B
|	LPPOINT lpSrcPtc]WBNULLw肷΍W(0)ɂȂ܂B
|	LPSIZE  lpSrcSizec]̕BNULLw肷΃ftHgTCYɂȂ܂B
|	BYTE AlphaclB
|	int		nAnglec]pxB1512x̒lłB
|	LPPOINT lpCenterPtc]SWBNULLw肷Ό݂̃|WV𒆐Sɂ܂B
*----------------------------------------------------------------------------*/
STDMETHODIMP CSDib32GLX86::RotateColorKeyAlphaBlendBlt( LPSDIB32GL lpSrcSDIB32GL, int nDstX, int nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize, BYTE Alpha, int nAngle, LPPOINT lpCenterPt )
{
	// IuWFNgNULL`FbN
	_ASSERTE( lpSrcSDIB32GL != NULL );
	if( lpSrcSDIB32GL == NULL ) return E_POINTER;

	CSDib32GLX86* lpSrc = safe_cast( CSDib32GLX86*, lpSrcSDIB32GL );
	INVALIDOBJECTCHECK( lpSrc );

	_ASSERTE( m_pBits != NULL);
	_ASSERTE( lpSrc->m_pBits != NULL );

	if( m_pBits == NULL ) return SDIB32GLERR_NOTINITIALIZED;
	if( lpSrc->m_pBits == NULL ) return SDIB32GLERR_NOTINITIALIZED;

	// `Xe[^Xɓ]W̑
	SDIB32GLROTATESTATUS Status = { nDstX, nDstY, nAngle };

	// NbsO
	if( !Clipping( lpSrc, Status, lpDstSize, lpSrcPt, lpSrcSize, lpCenterPt ) ) return SDIB32GLERR_INVALIDPOSITION;

	// ]恕]̊JnAhX
	LPSDIB32GLCOLOR* ppSrcScanLine = lpSrc->m_ppScanLine;
	LPSDIB32GLCOLOR pDstBits = &m_ppScanLine[ Status.nDstY ][ Status.nDstX ];

	DWORD dwAlphaSrc = CONVERT_255To256( Alpha );	// At@
	DWORD dwAlphaDst = DEST_ALPHA( dwAlphaSrc );
	SDIB32GLCOLOR ColorKey = lpSrc->m_ColorKey;

	// [vJE^AZupɕϊ
	Status.nWidth  = CONVERT_WIDTH( Status.nWidth );
	Status.nHeight = CONVERT_HEIGHT( Status.nHeight );

	if( !Status.b64bit )
	{
		// Œ菬32rbgvZ

		__asm
		{
			mov ecx, Status.nHeight			// ]鍂(Y[vJE^)
			mov edi, pDstBits				// ]AhX

			mov eax, Status.fxSrcScanX		// JnWx
			mov ebx, Status.fxSrcScanY		// JnWy

		loop_y0:

			or ecx, Status.nWidth			// ]镝(X[vJE^)

		loop_x0:
		
			// ]NbsO
			cmp eax, Status.fxSrcLeft		// if( x < Status.fxSrcLeft ) skip
			jl skip_draw0

			cmp ebx, Status.fxSrcTop		// if( y < Status.fxSrcTop ) skip
			jl skip_draw0

			cmp eax, Status.fxSrcRight		// if( x >= Status.fxSrcRight ) skip
			jge skip_draw0

			cmp ebx, Status.fxSrcBottom		// if( y >= Status.fxSrcBottom ) skip
			jge skip_draw0

			push eax						// Œ菬xX^bNɕۑ
			push ebx						// Œ菬yX^bNɕۑ
			
			shr ebx, 16						// Œ菬y𐮐ɂ
			mov esi, ppSrcScanLine			// ]AhX

			shr eax, 16						// Œ菬x𐮐ɂ
			mov esi, [esi+ebx*4]			// ppSrcScanLine[y]

			mov esi, [esi+eax*4]			// (np) ]sNZf[^擾 = ppSrcScanLine[y][x]
			
			cmp esi, ColorKey
			je skip_draw0_colkey

			mov edx, esi					// ]sNZf[^擾
			mov ebx, [edi]					// ]sNZf[^擾

			and edx, __xRxB_MASK_L			// }XN eax & 0x00ff00ff	
			and ebx, __xRxB_MASK_L			// }XN ebx & 0x00ff00ff

			imul edx, dwAlphaSrc			// (np) Kp
			
			imul ebx, dwAlphaDst			// (np) Kp

			add edx, ebx					// ]̃J[(RB)Ɠ]̃J[(RB)Z
			mov ebx, [edi]					// ]sNZf[^擾

			and esi, __AxGx_MASK_H			// }XN eax & 0x0000ff00
			and ebx, __AxGx_MASK_H			// (np) }XN eax & 0x0000ff00

			imul esi, dwAlphaSrc			// (np) Kp

			imul ebx, dwAlphaDst			// (np) Kp

			add esi, ebx					// (np) ]̃J[(G)Ɠ]̃J[(G)Z

			and esi, __xGxx_MASK_H			// [؂̂(G)
			and edx, __RxBx_MASK_L			// [؂̂(R,B)

			or esi, edx						// (np) GR,B

			shr esi, 8
			
			mov [edi], esi					// ]sNZf[^ɓ]

	skip_draw0_colkey:

			pop ebx							// Œ菬xX^bNo
			pop eax							// Œ菬yX^bNo

	skip_draw0:

			add eax, Status.fxSrcAddXx		// x += Status.fxSrcAddXx
			add ebx, Status.fxSrcAddXy		// y += Status.fxSrcAddXy
			
			add edi, 4						// ]͒ʏ
			sub ecx, __DEC_WIDTH

			jns loop_x0						// (np)

			add eax, Status.fxSrcAddYx		// x += Status.fxSrcAddYx
			add ebx, Status.fxSrcAddYy		// y += Status.fxSrcAddYy
			
			add edi, Status.nDstAddY		// ̃C ]͒ʏ
			sub ecx, __DEC_HEIGHT

			jns loop_y0						// (np)

		}

	}else
	{
		// Œ菬64rbgvZ(d)

		__asm
		{
			mov ecx, Status.nHeight			// ]鍂(Y[vJE^)
			mov edi, pDstBits				// ]AhX

			mov eax, Status.fxSrcScanX_H	// JnWx ()
			mov ebx, Status.fxSrcScanY_H	// JnWy ()
			
			mov esi, Status.fxSrcScanX_L	// JnWx ()
			mov edx, Status.fxSrcScanY_L	// JnWy ()

		loop_y1:

			or ecx, Status.nWidth			// ]镝(X[vJE^)

		loop_x1:
		
			// ]NbsO
			cmp eax, Status.nSrcLeft		// if( x < Status.nSrcLeft ) skip
			jl skip_draw1

			cmp ebx, Status.nSrcTop			// if( y < Status.nSrcTop ) skip
			jl skip_draw1

			cmp eax, Status.nSrcRight		// if( x >= Status.nSrcRight ) skip
			jge skip_draw1

			cmp ebx, Status.nSrcBottom		// if( y >= Status.nSrcBottom ) skip
			jge skip_draw1

			push esi						// (np)

			mov esi, ppSrcScanLine			// (np) ]AhX

			mov esi, [esi+ebx*4]			// (np) ppSrcScanLine[y]

			mov esi, [esi+eax*4]			// (np) ]sNZf[^擾 = ppSrcScanLine[y][x]
			
			cmp esi, ColorKey
			je skip_draw1_colkey

			push edx
			push ebx

			mov edx, esi					// ]sNZf[^擾
			mov ebx, [edi]					// ]sNZf[^擾

			and edx, __xRxB_MASK_L			// }XN eax & 0x00ff00ff	
			and ebx, __xRxB_MASK_L			// }XN ebx & 0x00ff00ff

			imul edx, dwAlphaSrc			// (np) Kp

			imul ebx, dwAlphaDst			// (np) Kp

			add edx, ebx					// ]̃J[(RB)Ɠ]̃J[(RB)Z
			mov ebx, [edi]					// ]sNZf[^擾

			and esi, __AxGx_MASK_H			// }XN eax & 0x0000ff00
			and ebx, __AxGx_MASK_H			// (np) }XN eax & 0x0000ff00

			imul esi, dwAlphaSrc			// (np) Kp

			imul ebx, dwAlphaDst			// (np) Kp

			add esi, ebx					// (np) ]̃J[(G)Ɠ]̃J[(G)Z

			and esi, __xGxx_MASK_H			// [؂̂(G)
			and edx, __RxBx_MASK_L			// [؂̂(R,B)

			or esi, edx						// (np) GR,B
			pop ebx

			shr esi, 8
			pop edx

			mov [edi], esi					// (np) ]sNZf[^ɓ]
	
	skip_draw1_colkey:
		
			pop esi

	skip_draw1:

			add esi, Status.fxSrcAddXx_L	// (np) x += Status.fxSrcAddXx_L@()

			adc eax, Status.fxSrcAddXx_H	// x += Status.fxSrcAddXx_H ()	<u>
			add edx, Status.fxSrcAddXy_L	// y += Status.fxSrcAddXy_L	()	<v>

			adc ebx, Status.fxSrcAddXy_H	// y += Status.fxSrcAddXy_H	()	<u>
			add edi, 4						// ]͒ʏ					<v>

			sub ecx, __DEC_WIDTH
			jns loop_x1

			add esi, Status.fxSrcAddYx_L	// (np) x += Status.fxSrcAddYx_L@()

			adc eax, Status.fxSrcAddYx_H	// x += Status.fxSrcAddYx_H ()	<u>
			add edx, Status.fxSrcAddYy_L	// y += Status.fxSrcAddYy_L	()	<v>

			adc ebx, Status.fxSrcAddYy_H	// y += Status.fxSrcAddYy_H	()	<u>
			add edi, Status.nDstAddY		// ̃C ]͒ʏ	<v>

			sub ecx, __DEC_HEIGHT
			jns loop_y1
		}

		return SDIB32GLS_ROTATEBLT64BIT;
	}

	return S_OK;
}


/*----------------------------------------------------------------------------*
|	]ZufBO
|	
|	[]
|	LPSDIB32GL lpSrcSDIB32GLc]SDIB32GLC^[tFCX
|	int nDstXc] x W
|	int nDstYc] y W
|	LPSIZE  lpDstSizec]̕Bl𕉂ɂ邱ƂŃ~[]B
|				NULLw肷΃ftHgTCYɂȂ܂B
|	LPPOINT lpSrcPtc]WBNULLw肷΍W(0)ɂȂ܂B
|	LPSIZE  lpSrcSizec]̕BNULLw肷΃ftHgTCYɂȂ܂B
|	int		nAnglec]pxB1512x̒lłB
|	LPPOINT lpCenterPtc]SWBNULLw肷Ό݂̃|WV𒆐Sɂ܂B
*----------------------------------------------------------------------------*/
STDMETHODIMP CSDib32GLX86::RotateAddBlendBlt( LPSDIB32GL lpSrcSDIB32GL, int nDstX, int nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize, int nAngle, LPPOINT lpCenterPt )
{
	// IuWFNgNULL`FbN
	_ASSERTE( lpSrcSDIB32GL != NULL );
	if( lpSrcSDIB32GL == NULL ) return E_POINTER;

	CSDib32GLX86* lpSrc = safe_cast( CSDib32GLX86*, lpSrcSDIB32GL );
	INVALIDOBJECTCHECK( lpSrc );

	_ASSERTE( m_pBits != NULL);
	_ASSERTE( lpSrc->m_pBits != NULL );

	if( m_pBits == NULL ) return SDIB32GLERR_NOTINITIALIZED;
	if( lpSrc->m_pBits == NULL ) return SDIB32GLERR_NOTINITIALIZED;

	// `Xe[^Xɓ]W̑
	SDIB32GLROTATESTATUS Status = { nDstX, nDstY, nAngle };

	// NbsO
	if( !Clipping( lpSrc, Status, lpDstSize, lpSrcPt, lpSrcSize, lpCenterPt ) ) return SDIB32GLERR_INVALIDPOSITION;

	// ]恕]̊JnAhX
	LPSDIB32GLCOLOR* ppSrcScanLine = lpSrc->m_ppScanLine;
	LPSDIB32GLCOLOR pDstBits = &m_ppScanLine[ Status.nDstY ][ Status.nDstX ];

	// [vJE^AZupɕϊ
	Status.nWidth  = CONVERT_WIDTH( Status.nWidth );
	Status.nHeight = CONVERT_HEIGHT( Status.nHeight );

	if( !Status.b64bit )
	{
		// Œ菬32rbgvZ

		__asm
		{
			mov ecx, Status.nHeight			// ]鍂(Y[vJE^)
			mov edi, pDstBits				// ]AhX

			mov eax, Status.fxSrcScanX		// JnWx
			mov ebx, Status.fxSrcScanY		// JnWy

		loop_y0:

			or ecx, Status.nWidth			// ]镝(X[vJE^)

		loop_x0:
		
			// ]NbsO
			cmp eax, Status.fxSrcLeft		// if( x < Status.fxSrcLeft ) skip
			jl skip_draw0

			cmp ebx, Status.fxSrcTop		// if( y < Status.fxSrcTop ) skip
			jl skip_draw0

			cmp eax, Status.fxSrcRight		// if( x >= Status.fxSrcRight ) skip
			jge skip_draw0

			cmp ebx, Status.fxSrcBottom		// if( y >= Status.fxSrcBottom ) skip
			jge skip_draw0

			push eax						// Œ菬xX^bNɕۑ
			push ebx						// Œ菬yX^bNɕۑ
			
			shr ebx, 16						// Œ菬y𐮐ɂ
			mov esi, ppSrcScanLine			// ]AhX

			shr eax, 16						// Œ菬x𐮐ɂ
			mov esi, [esi+ebx*4]			// ppSrcScanLine[y]

			mov esi, [esi+eax*4]			// (np) ]sNZf[^擾 = ppSrcScanLine[y][x]
			mov edx, [edi]

			mov eax, esi					// ]J[
			mov ebx, edx					// ]J[

			and ebx, eax					// rbgJオ蕔
			xor eax, edx					// rbgJオȂ

			shl ebx, 1						// Jオlɂ								<u>
			and eax, __MASK_fefefefe		// ӂꔻŎgŉ1rbg̃S~폜		<v>

			add eax, ebx					// 	(dst+src)=((dst&src)<<1)+(dst^src)

			and eax, __MASK_01010100		// ӂ̌o
			add esi, edx

			shr eax, 8						// ӂŌJオrbgŉʃrbgɈړ		<u>

			add eax, __MASK_7f7f7f7f		// ӂꂪ80AȂ7f

			xor eax, __MASK_7f7f7f7f		// (np) ӂꏈ̃}XN𐶐 (Jオ肠=0xFF JオȂ=0x00)

			sub esi, eax					// (np) ӂɂĂł̐F̌덷C

			or esi, eax						// ӂ}XNOR
			pop ebx							// Œ菬xX^bNo

			mov [edi], esi					// ]sNZf[^ɓ]
			pop eax							// Œ菬yX^bNo

	skip_draw0:

			add eax, Status.fxSrcAddXx		// x += Status.fxSrcAddXx
			add ebx, Status.fxSrcAddXy		// y += Status.fxSrcAddXy
			
			add edi, 4						// ]͒ʏ
			sub ecx, __DEC_WIDTH

			jns loop_x0						// (np)

			add eax, Status.fxSrcAddYx		// x += Status.fxSrcAddYx
			add ebx, Status.fxSrcAddYy		// y += Status.fxSrcAddYy
			
			add edi, Status.nDstAddY		// ̃C ]͒ʏ
			sub ecx, __DEC_HEIGHT

			jns loop_y0						// (np)

		}

	}else
	{
		// Œ菬64rbgvZ(d)

		__asm
		{
			mov ecx, Status.nHeight			// ]鍂(Y[vJE^)
			mov edi, pDstBits				// ]AhX

			mov eax, Status.fxSrcScanX_H	// JnWx ()
			mov ebx, Status.fxSrcScanY_H	// JnWy ()
			
			mov esi, Status.fxSrcScanX_L	// JnWx ()
			mov edx, Status.fxSrcScanY_L	// JnWy ()

		loop_y1:

			or ecx, Status.nWidth			// ]镝(X[vJE^)

		loop_x1:
		
			// ]NbsO
			cmp eax, Status.nSrcLeft		// if( x < Status.nSrcLeft ) skip
			jl skip_draw1

			cmp ebx, Status.nSrcTop			// if( y < Status.nSrcTop ) skip
			jl skip_draw1

			cmp eax, Status.nSrcRight		// if( x >= Status.nSrcRight ) skip
			jge skip_draw1

			cmp ebx, Status.nSrcBottom		// if( y >= Status.nSrcBottom ) skip
			jge skip_draw1
			
			push esi						// (np)
			push eax

			mov esi, ppSrcScanLine			// (np) ]AhX
			push ebx

			mov esi, [esi+ebx*4]			// (np) ppSrcScanLine[y]
			push edx

			mov esi, [esi+eax*4]			// (np) ]sNZf[^擾 = ppSrcScanLine[y][x]
			mov edx, [edi]

			mov eax, esi					// ]J[
			mov ebx, edx					// ]J[

			and ebx, eax					// rbgJオ蕔
			xor eax, edx					// rbgJオȂ

			shl ebx, 1						// Jオlɂ								<u>
			and eax, __MASK_fefefefe		// ӂꔻŎgŉ1rbg̃S~폜		<v>

			add eax, ebx					// 	(dst+src)=((dst&src)<<1)+(dst^src)

			and eax, __MASK_01010100		// ӂ̌o
			add esi, edx

			shr eax, 8						// ӂŌJオrbgŉʃrbgɈړ		<u>

			add eax, __MASK_7f7f7f7f		// ӂꂪ80AȂ7f

			xor eax, __MASK_7f7f7f7f		// (np) ӂꏈ̃}XN𐶐 (Jオ肠=0xFF JオȂ=0x00)
			pop edx

			sub esi, eax					// (np) ӂɂĂł̐F̌덷C
			pop ebx							// Œ菬xX^bNo

			or esi, eax						// ӂ}XNOR
			pop eax							// Œ菬yX^bNo		

			mov [edi], esi					// ]sNZf[^ɓ]
			pop esi							// (np)

	skip_draw1:

			add esi, Status.fxSrcAddXx_L	// (np) x += Status.fxSrcAddXx_L@()

			adc eax, Status.fxSrcAddXx_H	// x += Status.fxSrcAddXx_H ()	<u>
			add edx, Status.fxSrcAddXy_L	// y += Status.fxSrcAddXy_L	()	<v>

			adc ebx, Status.fxSrcAddXy_H	// y += Status.fxSrcAddXy_H	()	<u>
			add edi, 4						// ]͒ʏ					<v>

			sub ecx, __DEC_WIDTH
			jns loop_x1

			add esi, Status.fxSrcAddYx_L	// (np) x += Status.fxSrcAddYx_L@()

			adc eax, Status.fxSrcAddYx_H	// x += Status.fxSrcAddYx_H ()	<u>
			add edx, Status.fxSrcAddYy_L	// y += Status.fxSrcAddYy_L	()	<v>

			adc ebx, Status.fxSrcAddYy_H	// y += Status.fxSrcAddYy_H	()	<u>
			add edi, Status.nDstAddY		// ̃C ]͒ʏ	<v>

			sub ecx, __DEC_HEIGHT
			jns loop_y1
		}

		return SDIB32GLS_ROTATEBLT64BIT;
	}

	return S_OK;
}


/*----------------------------------------------------------------------------*
|	]ZufBO
|	
|	[]
|	LPSDIB32GL lpSrcSDIB32GLc]SDIB32GLC^[tFCX
|	int nDstXc] x W
|	int nDstYc] y W
|	LPSIZE  lpDstSizec]̕Bl𕉂ɂ邱ƂŃ~[]B
|				NULLw肷΃ftHgTCYɂȂ܂B
|	LPPOINT lpSrcPtc]WBNULLw肷΍W(0)ɂȂ܂B
|	LPSIZE  lpSrcSizec]̕BNULLw肷΃ftHgTCYɂȂ܂B
|	BYTE AlphaclB
|	int		nAnglec]pxB1512x̒lłB
|	LPPOINT lpCenterPtc]SWBNULLw肷Ό݂̃|WV𒆐Sɂ܂B
*----------------------------------------------------------------------------*/
STDMETHODIMP CSDib32GLX86::RotateAddAlphaBlendBlt( LPSDIB32GL lpSrcSDIB32GL, int nDstX, int nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize, BYTE Alpha, int nAngle, LPPOINT lpCenterPt )
{
	// IuWFNgNULL`FbN
	_ASSERTE( lpSrcSDIB32GL != NULL );
	if( lpSrcSDIB32GL == NULL ) return E_POINTER;

	CSDib32GLX86* lpSrc = safe_cast( CSDib32GLX86*, lpSrcSDIB32GL );
	INVALIDOBJECTCHECK( lpSrc );

	_ASSERTE( m_pBits != NULL);
	_ASSERTE( lpSrc->m_pBits != NULL );

	if( m_pBits == NULL ) return SDIB32GLERR_NOTINITIALIZED;
	if( lpSrc->m_pBits == NULL ) return SDIB32GLERR_NOTINITIALIZED;

	// `Xe[^Xɓ]W̑
	SDIB32GLROTATESTATUS Status = { nDstX, nDstY, nAngle };

	// NbsO
	if( !Clipping( lpSrc, Status, lpDstSize, lpSrcPt, lpSrcSize, lpCenterPt ) ) return SDIB32GLERR_INVALIDPOSITION;

	// ]恕]̊JnAhX
	LPSDIB32GLCOLOR* ppSrcScanLine = lpSrc->m_ppScanLine;
	LPSDIB32GLCOLOR pDstBits = &m_ppScanLine[ Status.nDstY ][ Status.nDstX ];

	DWORD dwAlphaSrc = CONVERT_255To256( Alpha );	// At@

	// [vJE^AZupɕϊ
	Status.nWidth  = CONVERT_WIDTH( Status.nWidth );
	Status.nHeight = CONVERT_HEIGHT( Status.nHeight );

	if( !Status.b64bit )
	{
		// Œ菬32rbgvZ

		__asm
		{
			mov ecx, Status.nHeight			// ]鍂(Y[vJE^)
			mov edi, pDstBits				// ]AhX

			mov eax, Status.fxSrcScanX		// JnWx
			mov ebx, Status.fxSrcScanY		// JnWy

		loop_y0:

			or ecx, Status.nWidth			// ]镝(X[vJE^)

		loop_x0:
		
			// ]NbsO
			cmp eax, Status.fxSrcLeft		// if( x < Status.fxSrcLeft ) skip
			jl skip_draw0

			cmp ebx, Status.fxSrcTop		// if( y < Status.fxSrcTop ) skip
			jl skip_draw0

			cmp eax, Status.fxSrcRight		// if( x >= Status.fxSrcRight ) skip
			jge skip_draw0

			cmp ebx, Status.fxSrcBottom		// if( y >= Status.fxSrcBottom ) skip
			jge skip_draw0

			push eax						// Œ菬xX^bNɕۑ
			push ebx						// Œ菬yX^bNɕۑ
			
			shr ebx, 16						// Œ菬y𐮐ɂ
			mov esi, ppSrcScanLine			// ]AhX

			shr eax, 16						// Œ菬x𐮐ɂ
			mov esi, [esi+ebx*4]			// ppSrcScanLine[y]

			mov esi, [esi+eax*4]			// (np) ]sNZf[^擾 = ppSrcScanLine[y][x]

			mov ebx, esi					// (np)

			and esi, __AxGx_MASK_H			// ARGBlAGɕ(A͎gȂ)
			and ebx, __xRxB_MASK_L			// ARGBlRBɕ

			imul esi, dwAlphaSrc			// (np) Kp

			imul ebx, dwAlphaSrc			// (np) Kp

			and esi, __xGxx_MASK_H			// [؂̂(G)
			and ebx, __RxBx_MASK_L			// [؂̂(R,B)

			or esi, ebx						// (np) GR,B

			shr esi, 8						//							<u>
			mov edx, [edi]					//							<v>

			mov eax, esi					// ]J[
			mov ebx, edx					// ]J[

			and ebx, eax					// rbgJオ蕔
			xor eax, edx					// rbgJオȂ

			shl ebx, 1						// Jオlɂ								<u>
			and eax, __MASK_fefefefe		// ӂꔻŎgŉ1rbg̃S~폜		<v>

			add eax, ebx					// 	(dst+src)=((dst&src)<<1)+(dst^src)

			and eax, __MASK_01010100		// ӂ̌o
			add esi, edx

			shr eax, 8						// ӂŌJオrbgŉʃrbgɈړ		<u>

			add eax, __MASK_7f7f7f7f		// ӂꂪ80AȂ7f

			xor eax, __MASK_7f7f7f7f		// (np) ӂꏈ̃}XN𐶐 (Jオ肠=0xFF JオȂ=0x00)

			sub esi, eax					// (np) ӂɂĂł̐F̌덷C

			or esi, eax						// ӂ}XNOR
			pop ebx							// Œ菬xX^bNo

			mov [edi], esi					// ]sNZf[^ɓ]
			pop eax							// Œ菬yX^bNo

	skip_draw0:

			add eax, Status.fxSrcAddXx		// x += Status.fxSrcAddXx
			add ebx, Status.fxSrcAddXy		// y += Status.fxSrcAddXy
			
			add edi, 4						// ]͒ʏ
			sub ecx, __DEC_WIDTH

			jns loop_x0						// (np)

			add eax, Status.fxSrcAddYx		// x += Status.fxSrcAddYx
			add ebx, Status.fxSrcAddYy		// y += Status.fxSrcAddYy
			
			add edi, Status.nDstAddY		// ̃C ]͒ʏ
			sub ecx, __DEC_HEIGHT

			jns loop_y0						// (np)

		}

	}else
	{
		// Œ菬64rbgvZ(d)

		__asm
		{
			mov ecx, Status.nHeight			// ]鍂(Y[vJE^)
			mov edi, pDstBits				// ]AhX

			mov eax, Status.fxSrcScanX_H	// JnWx ()
			mov ebx, Status.fxSrcScanY_H	// JnWy ()
			
			mov esi, Status.fxSrcScanX_L	// JnWx ()
			mov edx, Status.fxSrcScanY_L	// JnWy ()

		loop_y1:

			or ecx, Status.nWidth			// ]镝(X[vJE^)

		loop_x1:
		
			// ]NbsO
			cmp eax, Status.nSrcLeft		// if( x < Status.nSrcLeft ) skip
			jl skip_draw1

			cmp ebx, Status.nSrcTop			// if( y < Status.nSrcTop ) skip
			jl skip_draw1

			cmp eax, Status.nSrcRight		// if( x >= Status.nSrcRight ) skip
			jge skip_draw1

			cmp ebx, Status.nSrcBottom		// if( y >= Status.nSrcBottom ) skip
			jge skip_draw1
			
			push esi						// (np)
			push eax

			mov esi, ppSrcScanLine			// (np) ]AhX
			push ebx

			mov esi, [esi+ebx*4]			// (np) ppSrcScanLine[y]
			push edx

			mov esi, [esi+eax*4]			// (np) ]sNZf[^擾 = ppSrcScanLine[y][x]

			mov ebx, esi					// (np)

			and esi, __AxGx_MASK_H			// ARGBlAGɕ(A͎gȂ)
			and ebx, __xRxB_MASK_L			// ARGBlRBɕ

			imul esi, dwAlphaSrc			// (np) Kp

			imul ebx, dwAlphaSrc			// (np) Kp

			and esi, __xGxx_MASK_H			// [؂̂(G)
			and ebx, __RxBx_MASK_L			// [؂̂(R,B)

			or esi, ebx						// (np) GR,B

			shr esi, 8						//							<u>
			mov edx, [edi]					//							<v>

			mov eax, esi					// ]J[
			mov ebx, edx					// ]J[

			and ebx, eax					// rbgJオ蕔
			xor eax, edx					// rbgJオȂ

			shl ebx, 1						// Jオlɂ								<u>
			and eax, __MASK_fefefefe		// ӂꔻŎgŉ1rbg̃S~폜		<v>

			add eax, ebx					// 	(dst+src)=((dst&src)<<1)+(dst^src)

			and eax, __MASK_01010100		// ӂ̌o
			add esi, edx

			shr eax, 8						// ӂŌJオrbgŉʃrbgɈړ		<u>

			add eax, __MASK_7f7f7f7f		// ӂꂪ80AȂ7f

			xor eax, __MASK_7f7f7f7f		// (np) ӂꏈ̃}XN𐶐 (Jオ肠=0xFF JオȂ=0x00)
			pop edx

			sub esi, eax					// (np) ӂɂĂł̐F̌덷C
			pop ebx							// Œ菬xX^bNo

			or esi, eax						// ӂ}XNOR
			pop eax							// Œ菬yX^bNo		

			mov [edi], esi					// ]sNZf[^ɓ]
			pop esi							// (np)

	skip_draw1:

			add esi, Status.fxSrcAddXx_L	// (np) x += Status.fxSrcAddXx_L@()

			adc eax, Status.fxSrcAddXx_H	// x += Status.fxSrcAddXx_H ()	<u>
			add edx, Status.fxSrcAddXy_L	// y += Status.fxSrcAddXy_L	()	<v>

			adc ebx, Status.fxSrcAddXy_H	// y += Status.fxSrcAddXy_H	()	<u>
			add edi, 4						// ]͒ʏ					<v>

			sub ecx, __DEC_WIDTH
			jns loop_x1

			add esi, Status.fxSrcAddYx_L	// (np) x += Status.fxSrcAddYx_L@()

			adc eax, Status.fxSrcAddYx_H	// x += Status.fxSrcAddYx_H ()	<u>
			add edx, Status.fxSrcAddYy_L	// y += Status.fxSrcAddYy_L	()	<v>

			adc ebx, Status.fxSrcAddYy_H	// y += Status.fxSrcAddYy_H	()	<u>
			add edi, Status.nDstAddY		// ̃C ]͒ʏ	<v>

			sub ecx, __DEC_HEIGHT
			jns loop_y1
		}

		return SDIB32GLS_ROTATEBLT64BIT;
	}

	return S_OK;
}


/*----------------------------------------------------------------------------*
|	]ZufBO
|	
|	[]
|	LPSDIB32GL lpSrcSDIB32GLc]SDIB32GLC^[tFCX
|	int nDstXc] x W
|	int nDstYc] y W
|	LPSIZE  lpDstSizec]̕Bl𕉂ɂ邱ƂŃ~[]B
|				NULLw肷΃ftHgTCYɂȂ܂B
|	LPPOINT lpSrcPtc]WBNULLw肷΍W(0)ɂȂ܂B
|	LPSIZE  lpSrcSizec]̕BNULLw肷΃ftHgTCYɂȂ܂B
|	int		nAnglec]pxB1512x̒lłB
|	LPPOINT lpCenterPtc]SWBNULLw肷Ό݂̃|WV𒆐Sɂ܂B
*----------------------------------------------------------------------------*/
STDMETHODIMP CSDib32GLX86::RotateSubBlendBlt( LPSDIB32GL lpSrcSDIB32GL, int nDstX, int nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize, int nAngle, LPPOINT lpCenterPt )
{
	// IuWFNgNULL`FbN
	_ASSERTE( lpSrcSDIB32GL != NULL );
	if( lpSrcSDIB32GL == NULL ) return E_POINTER;

	CSDib32GLX86* lpSrc = safe_cast( CSDib32GLX86*, lpSrcSDIB32GL );
	INVALIDOBJECTCHECK( lpSrc );

	_ASSERTE( m_pBits != NULL);
	_ASSERTE( lpSrc->m_pBits != NULL );

	if( m_pBits == NULL ) return SDIB32GLERR_NOTINITIALIZED;
	if( lpSrc->m_pBits == NULL ) return SDIB32GLERR_NOTINITIALIZED;

	// `Xe[^Xɓ]W̑
	SDIB32GLROTATESTATUS Status = { nDstX, nDstY, nAngle };

	// NbsO
	if( !Clipping( lpSrc, Status, lpDstSize, lpSrcPt, lpSrcSize, lpCenterPt ) ) return SDIB32GLERR_INVALIDPOSITION;

	// ]恕]̊JnAhX
	LPSDIB32GLCOLOR* ppSrcScanLine = lpSrc->m_ppScanLine;
	LPSDIB32GLCOLOR pDstBits = &m_ppScanLine[ Status.nDstY ][ Status.nDstX ];

	// [vJE^AZupɕϊ
	Status.nWidth  = CONVERT_WIDTH( Status.nWidth );
	Status.nHeight = CONVERT_HEIGHT( Status.nHeight );

	if( !Status.b64bit )
	{
		// Œ菬32rbgvZ

		__asm
		{
			mov ecx, Status.nHeight			// ]鍂(Y[vJE^)
			mov edi, pDstBits				// ]AhX

			mov eax, Status.fxSrcScanX		// JnWx
			mov ebx, Status.fxSrcScanY		// JnWy

		loop_y0:

			or ecx, Status.nWidth			// ]镝(X[vJE^)

		loop_x0:
		
			// ]NbsO
			cmp eax, Status.fxSrcLeft		// if( x < Status.fxSrcLeft ) skip
			jl skip_draw0

			cmp ebx, Status.fxSrcTop		// if( y < Status.fxSrcTop ) skip
			jl skip_draw0

			cmp eax, Status.fxSrcRight		// if( x >= Status.fxSrcRight ) skip
			jge skip_draw0

			cmp ebx, Status.fxSrcBottom		// if( y >= Status.fxSrcBottom ) skip
			jge skip_draw0

			push ebx						// Œ菬xX^bNɕۑ
			push eax						// Œ菬yX^bNɕۑ
			
			shr ebx, 16						// Œ菬y𐮐ɂ
			mov esi, ppSrcScanLine			// ]AhX

			shr eax, 16						// Œ菬x𐮐ɂ
			mov esi, [esi+ebx*4]			// ppSrcScanLine[y]

			mov esi, [esi+eax*4]			// (np) ]sNZf[^擾 = ppSrcScanLine[y][x]

			mov eax, esi					// ]J[
			mov ebx, [edi]					// ]J[

			not ebx							// (np) J艺蕔JオԂɂ邽߂ɔ]

			mov edx, eax
			and eax, ebx					// rbgJオ蕔

			shl eax, 1						// Jオlɂ		<u>
			xor edx, ebx					// rbgJオȂ	<v>

			and edx, __MASK_fefefefe		// (np) ӂꔻŎgŉ1rbg̃S~폜

			add eax, edx					// (np) ӂꂷ邩ǂ

			and eax, __MASK_01010100		// ӂ̌o

			shr eax, 8						// ӂŌJオrbgŉʃrbgɈړ <u>
			mov ebx, [edi]					//													<v>

			add eax, __MASK_7f7f7f7f		// ӂꂪ80AȂ7f

			xor eax, __MASK_7f7f7f7f		// ӂꏈ̃}XN𐶐 (ӂꂠ=0xFF ӂȂ=0x00)

			or esi, eax						// ]ӂ}XNOR
			or ebx, eax						// ]ӂ}XNOR

			sub ebx, esi					// ӂĂȂ 0xFF(Dst)-0xFF(Src) = 0
			pop eax							// Œ菬yX^bNo

			mov [edi], ebx					// ]sNZf[^ɓ]
			pop ebx							// Œ菬xX^bNo

	skip_draw0:

			add eax, Status.fxSrcAddXx		// x += Status.fxSrcAddXx
			add ebx, Status.fxSrcAddXy		// y += Status.fxSrcAddXy
			
			add edi, 4						// ]͒ʏ
			sub ecx, __DEC_WIDTH

			jns loop_x0						// (np)

			add eax, Status.fxSrcAddYx		// x += Status.fxSrcAddYx
			add ebx, Status.fxSrcAddYy		// y += Status.fxSrcAddYy
			
			add edi, Status.nDstAddY		// ̃C ]͒ʏ
			sub ecx, __DEC_HEIGHT

			jns loop_y0						// (np)

		}

	}else
	{
		// Œ菬64rbgvZ(d)

		__asm
		{
			mov ecx, Status.nHeight			// ]鍂(Y[vJE^)
			mov edi, pDstBits				// ]AhX

			mov eax, Status.fxSrcScanX_H	// JnWx ()
			mov ebx, Status.fxSrcScanY_H	// JnWy ()
			
			mov esi, Status.fxSrcScanX_L	// JnWx ()
			mov edx, Status.fxSrcScanY_L	// JnWy ()

		loop_y1:

			or ecx, Status.nWidth			// ]镝(X[vJE^)

		loop_x1:
		
			// ]NbsO
			cmp eax, Status.nSrcLeft		// if( x < Status.nSrcLeft ) skip
			jl skip_draw1

			cmp ebx, Status.nSrcTop			// if( y < Status.nSrcTop ) skip
			jl skip_draw1

			cmp eax, Status.nSrcRight		// if( x >= Status.nSrcRight ) skip
			jge skip_draw1

			cmp ebx, Status.nSrcBottom		// if( y >= Status.nSrcBottom ) skip
			jge skip_draw1
			
			push esi						// (np)
			push ebx

			mov esi, ppSrcScanLine			// (np) ]AhX
			push eax

			mov esi, [esi+ebx*4]			// (np) ppSrcScanLine[y]
			push edx

			mov esi, [esi+eax*4]			// (np) ]sNZf[^擾 = ppSrcScanLine[y][x]

			mov eax, esi					// ]J[
			mov ebx, [edi]					// ]J[

			not ebx							// (np) J艺蕔JオԂɂ邽߂ɔ]

			mov edx, eax
			and eax, ebx					// rbgJオ蕔

			shl eax, 1						// Jオlɂ		<u>
			xor edx, ebx					// rbgJオȂ	<v>

			and edx, __MASK_fefefefe		// (np) ӂꔻŎgŉ1rbg̃S~폜

			add eax, edx					// (np) ӂꂷ邩ǂ

			and eax, __MASK_01010100		// ӂ̌o

			shr eax, 8						// ӂŌJオrbgŉʃrbgɈړ <u>
			mov ebx, [edi]					//													<v>

			add eax, __MASK_7f7f7f7f		// ӂꂪ80AȂ7f

			xor eax, __MASK_7f7f7f7f		// ӂꏈ̃}XN𐶐 (ӂꂠ=0xFF ӂȂ=0x00)
			
			or esi, eax						// ]ӂ}XNOR
			or ebx, eax						// ]ӂ}XNOR

			sub ebx, esi					// ӂĂȂ 0xFF(Dst)-0xFF(Src) = 0
			pop edx

			mov [edi], ebx					// ]sNZf[^ɓ]
			pop eax							// Œ菬yX^bNo

			mov [edi], ebx					// ]sNZf[^ɓ]
			pop ebx							// Œ菬yX^bNo

			pop esi							// (np)

	skip_draw1:

			add esi, Status.fxSrcAddXx_L	// (np) x += Status.fxSrcAddXx_L@()

			adc eax, Status.fxSrcAddXx_H	// x += Status.fxSrcAddXx_H ()	<u>
			add edx, Status.fxSrcAddXy_L	// y += Status.fxSrcAddXy_L	()	<v>

			adc ebx, Status.fxSrcAddXy_H	// y += Status.fxSrcAddXy_H	()	<u>
			add edi, 4						// ]͒ʏ					<v>

			sub ecx, __DEC_WIDTH
			jns loop_x1

			add esi, Status.fxSrcAddYx_L	// (np) x += Status.fxSrcAddYx_L@()

			adc eax, Status.fxSrcAddYx_H	// x += Status.fxSrcAddYx_H ()	<u>
			add edx, Status.fxSrcAddYy_L	// y += Status.fxSrcAddYy_L	()	<v>

			adc ebx, Status.fxSrcAddYy_H	// y += Status.fxSrcAddYy_H	()	<u>
			add edi, Status.nDstAddY		// ̃C ]͒ʏ	<v>

			sub ecx, __DEC_HEIGHT
			jns loop_y1
		}

		return SDIB32GLS_ROTATEBLT64BIT;
	}

	return S_OK;
}


/*----------------------------------------------------------------------------*
|	]ZufBO
|	
|	[]
|	LPSDIB32GL lpSrcSDIB32GLc]SDIB32GLC^[tFCX
|	int nDstXc] x W
|	int nDstYc] y W
|	LPSIZE  lpDstSizec]̕Bl𕉂ɂ邱ƂŃ~[]B
|				NULLw肷΃ftHgTCYɂȂ܂B
|	LPPOINT lpSrcPtc]WBNULLw肷΍W(0)ɂȂ܂B
|	LPSIZE  lpSrcSizec]̕BNULLw肷΃ftHgTCYɂȂ܂B
|	int		nAnglec]pxB1512x̒lłB
|	LPPOINT lpCenterPtc]SWBNULLw肷Ό݂̃|WV𒆐Sɂ܂B
*----------------------------------------------------------------------------*/
STDMETHODIMP CSDib32GLX86::RotateSubAlphaBlendBlt( LPSDIB32GL lpSrcSDIB32GL, int nDstX, int nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize, BYTE Alpha, int nAngle, LPPOINT lpCenterPt )
{
	// IuWFNgNULL`FbN
	_ASSERTE( lpSrcSDIB32GL != NULL );
	if( lpSrcSDIB32GL == NULL ) return E_POINTER;

	CSDib32GLX86* lpSrc = safe_cast( CSDib32GLX86*, lpSrcSDIB32GL );
	INVALIDOBJECTCHECK( lpSrc );

	_ASSERTE( m_pBits != NULL);
	_ASSERTE( lpSrc->m_pBits != NULL );

	if( m_pBits == NULL ) return SDIB32GLERR_NOTINITIALIZED;
	if( lpSrc->m_pBits == NULL ) return SDIB32GLERR_NOTINITIALIZED;

	// `Xe[^Xɓ]W̑
	SDIB32GLROTATESTATUS Status = { nDstX, nDstY, nAngle };

	// NbsO
	if( !Clipping( lpSrc, Status, lpDstSize, lpSrcPt, lpSrcSize, lpCenterPt ) ) return SDIB32GLERR_INVALIDPOSITION;

	// ]恕]̊JnAhX
	LPSDIB32GLCOLOR* ppSrcScanLine = lpSrc->m_ppScanLine;
	LPSDIB32GLCOLOR pDstBits = &m_ppScanLine[ Status.nDstY ][ Status.nDstX ];

	DWORD dwAlphaSrc = CONVERT_255To256( Alpha );	// At@

	// [vJE^AZupɕϊ
	Status.nWidth  = CONVERT_WIDTH( Status.nWidth );
	Status.nHeight = CONVERT_HEIGHT( Status.nHeight );

	if( !Status.b64bit )
	{
		// Œ菬32rbgvZ

		__asm
		{
			mov ecx, Status.nHeight			// ]鍂(Y[vJE^)
			mov edi, pDstBits				// ]AhX

			mov eax, Status.fxSrcScanX		// JnWx
			mov ebx, Status.fxSrcScanY		// JnWy

		loop_y0:

			or ecx, Status.nWidth			// ]镝(X[vJE^)

		loop_x0:
		
			// ]NbsO
			cmp eax, Status.fxSrcLeft		// if( x < Status.fxSrcLeft ) skip
			jl skip_draw0

			cmp ebx, Status.fxSrcTop		// if( y < Status.fxSrcTop ) skip
			jl skip_draw0

			cmp eax, Status.fxSrcRight		// if( x >= Status.fxSrcRight ) skip
			jge skip_draw0

			cmp ebx, Status.fxSrcBottom		// if( y >= Status.fxSrcBottom ) skip
			jge skip_draw0

			push ebx						// Œ菬xX^bNɕۑ
			push eax						// Œ菬yX^bNɕۑ
			
			shr ebx, 16						// Œ菬y𐮐ɂ
			mov esi, ppSrcScanLine			// ]AhX

			shr eax, 16						// Œ菬x𐮐ɂ
			mov esi, [esi+ebx*4]			// ppSrcScanLine[y]

			mov esi, [esi+eax*4]			// (np) ]sNZf[^擾 = ppSrcScanLine[y][x]

			mov ebx, esi					// (np)

			and esi, __AxGx_MASK_H			// ARGBlAGɕ(A͎gȂ)
			and ebx, __xRxB_MASK_L			// ARGBlRBɕ

			imul esi, dwAlphaSrc			// (np) Kp

			imul ebx, dwAlphaSrc			// (np) Kp

			and esi, __xGxx_MASK_H			// [؂̂(G)
			and ebx, __RxBx_MASK_L			// [؂̂(R,B)

			or esi, ebx						// (np) GR,B

			shr esi, 8						//							<u>

			mov eax, esi					// ]J[
			mov ebx, [edi]					// ]J[

			not ebx							// (np) J艺蕔JオԂɂ邽߂ɔ]

			mov edx, eax
			and eax, ebx					// rbgJオ蕔

			shl eax, 1						// Jオlɂ		<u>
			xor edx, ebx					// rbgJオȂ	<v>

			and edx, __MASK_fefefefe		// (np) ӂꔻŎgŉ1rbg̃S~폜

			add eax, edx					// (np) ӂꂷ邩ǂ

			and eax, __MASK_01010100		// ӂ̌o

			shr eax, 8						// ӂŌJオrbgŉʃrbgɈړ <u>
			mov ebx, [edi]					//													<v>

			add eax, __MASK_7f7f7f7f		// ӂꂪ80AȂ7f

			xor eax, __MASK_7f7f7f7f		// ӂꏈ̃}XN𐶐 (ӂꂠ=0xFF ӂȂ=0x00)

			or esi, eax						// ]ӂ}XNOR
			or ebx, eax						// ]ӂ}XNOR

			sub ebx, esi					// ӂĂȂ 0xFF(Dst)-0xFF(Src) = 0
			pop eax							// Œ菬yX^bNo

			mov [edi], ebx					// ]sNZf[^ɓ]
			pop ebx							// Œ菬xX^bNo

	skip_draw0:

			add eax, Status.fxSrcAddXx		// x += Status.fxSrcAddXx
			add ebx, Status.fxSrcAddXy		// y += Status.fxSrcAddXy
			
			add edi, 4						// ]͒ʏ
			sub ecx, __DEC_WIDTH

			jns loop_x0						// (np)

			add eax, Status.fxSrcAddYx		// x += Status.fxSrcAddYx
			add ebx, Status.fxSrcAddYy		// y += Status.fxSrcAddYy
			
			add edi, Status.nDstAddY		// ̃C ]͒ʏ
			sub ecx, __DEC_HEIGHT

			jns loop_y0						// (np)

		}

	}else
	{
		// Œ菬64rbgvZ(d)

		__asm
		{
			mov ecx, Status.nHeight			// ]鍂(Y[vJE^)
			mov edi, pDstBits				// ]AhX

			mov eax, Status.fxSrcScanX_H	// JnWx ()
			mov ebx, Status.fxSrcScanY_H	// JnWy ()
			
			mov esi, Status.fxSrcScanX_L	// JnWx ()
			mov edx, Status.fxSrcScanY_L	// JnWy ()

		loop_y1:

			or ecx, Status.nWidth			// ]镝(X[vJE^)

		loop_x1:
		
			// ]NbsO
			cmp eax, Status.nSrcLeft		// if( x < Status.nSrcLeft ) skip
			jl skip_draw1

			cmp ebx, Status.nSrcTop			// if( y < Status.nSrcTop ) skip
			jl skip_draw1

			cmp eax, Status.nSrcRight		// if( x >= Status.nSrcRight ) skip
			jge skip_draw1

			cmp ebx, Status.nSrcBottom		// if( y >= Status.nSrcBottom ) skip
			jge skip_draw1
			
			push esi						// (np)
			push ebx

			mov esi, ppSrcScanLine			// (np) ]AhX
			push eax

			mov esi, [esi+ebx*4]			// (np) ppSrcScanLine[y]
			push edx

			mov esi, [esi+eax*4]			// (np) ]sNZf[^擾 = ppSrcScanLine[y][x]

			mov ebx, esi					// (np)

			and esi, __AxGx_MASK_H			// ARGBlAGɕ(A͎gȂ)
			and ebx, __xRxB_MASK_L			// ARGBlRBɕ

			imul esi, dwAlphaSrc			// (np) Kp

			imul ebx, dwAlphaSrc			// (np) Kp

			and esi, __xGxx_MASK_H			// [؂̂(G)
			and ebx, __RxBx_MASK_L			// [؂̂(R,B)

			or esi, ebx						// (np) GR,B

			shr esi, 8						//							<u>

			mov eax, esi					// ]J[
			mov ebx, [edi]					// ]J[

			not ebx							// (np) J艺蕔JオԂɂ邽߂ɔ]

			mov edx, eax
			and eax, ebx					// rbgJオ蕔

			shl eax, 1						// Jオlɂ		<u>
			xor edx, ebx					// rbgJオȂ	<v>

			and edx, __MASK_fefefefe		// (np) ӂꔻŎgŉ1rbg̃S~폜

			add eax, edx					// (np) ӂꂷ邩ǂ

			and eax, __MASK_01010100		// ӂ̌o

			shr eax, 8						// ӂŌJオrbgŉʃrbgɈړ <u>
			mov ebx, [edi]					//													<v>

			add eax, __MASK_7f7f7f7f		// ӂꂪ80AȂ7f

			xor eax, __MASK_7f7f7f7f		// ӂꏈ̃}XN𐶐 (ӂꂠ=0xFF ӂȂ=0x00)
			
			or esi, eax						// ]ӂ}XNOR
			or ebx, eax						// ]ӂ}XNOR

			sub ebx, esi					// ӂĂȂ 0xFF(Dst)-0xFF(Src) = 0
			pop edx

			mov [edi], ebx					// ]sNZf[^ɓ]
			pop eax							// Œ菬yX^bNo

			mov [edi], ebx					// ]sNZf[^ɓ]
			pop ebx							// Œ菬yX^bNo

			pop esi							// (np)

	skip_draw1:

			add esi, Status.fxSrcAddXx_L	// (np) x += Status.fxSrcAddXx_L@()

			adc eax, Status.fxSrcAddXx_H	// x += Status.fxSrcAddXx_H ()	<u>
			add edx, Status.fxSrcAddXy_L	// y += Status.fxSrcAddXy_L	()	<v>

			adc ebx, Status.fxSrcAddXy_H	// y += Status.fxSrcAddXy_H	()	<u>
			add edi, 4						// ]͒ʏ					<v>

			sub ecx, __DEC_WIDTH
			jns loop_x1

			add esi, Status.fxSrcAddYx_L	// (np) x += Status.fxSrcAddYx_L@()

			adc eax, Status.fxSrcAddYx_H	// x += Status.fxSrcAddYx_H ()	<u>
			add edx, Status.fxSrcAddYy_L	// y += Status.fxSrcAddYy_L	()	<v>

			adc ebx, Status.fxSrcAddYy_H	// y += Status.fxSrcAddYy_H	()	<u>
			add edi, Status.nDstAddY		// ̃C ]͒ʏ	<v>

			sub ecx, __DEC_HEIGHT
			jns loop_y1
		}

		return SDIB32GLS_ROTATEBLT64BIT;
	}

	return S_OK;
}


/*----------------------------------------------------------------------------*
|	]`l摜]
|	
|	[]
|	LPSDIB32GL lpSrcSDIB32GLc]SDIB32GLC^[tFCX
|	int nDstXc] x W
|	int nDstYc] y W
|	LPSIZE  lpDstSizec]̕Bl𕉂ɂ邱ƂŃ~[]B
|				NULLw肷΃ftHgTCYɂȂ܂B
|	LPPOINT lpSrcPtc]WBNULLw肷΍W(0)ɂȂ܂B
|	LPSIZE  lpSrcSizec]̕BNULLw肷΃ftHgTCYɂȂ܂B
|	int		nAnglec]pxB1512x̒lłB
|	LPPOINT lpCenterPtc]SWBNULLw肷Ό݂̃|WV𒆐Sɂ܂B
*----------------------------------------------------------------------------*/
STDMETHODIMP CSDib32GLX86::RotateAlphaChannelBlt( LPSDIB32GL lpSrcSDIB32GL, int nDstX, int nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize, int nAngle, LPPOINT lpCenterPt )
{
	// IuWFNgNULL`FbN
	_ASSERTE( lpSrcSDIB32GL != NULL );
	if( lpSrcSDIB32GL == NULL ) return E_POINTER;

	CSDib32GLX86* lpSrc = safe_cast( CSDib32GLX86*, lpSrcSDIB32GL );
	INVALIDOBJECTCHECK( lpSrc );

	_ASSERTE( m_pBits != NULL);
	_ASSERTE( lpSrc->m_pBits != NULL );

	if( m_pBits == NULL ) return SDIB32GLERR_NOTINITIALIZED;
	if( lpSrc->m_pBits == NULL ) return SDIB32GLERR_NOTINITIALIZED;

	// `Xe[^Xɓ]W̑
	SDIB32GLROTATESTATUS Status = { nDstX, nDstY, nAngle };

	// NbsO
	if( !Clipping( lpSrc, Status, lpDstSize, lpSrcPt, lpSrcSize, lpCenterPt ) ) return SDIB32GLERR_INVALIDPOSITION;

	// ]恕]̊JnAhX
	LPSDIB32GLCOLOR* ppSrcScanLine = lpSrc->m_ppScanLine;
	LPSDIB32GLCOLOR pDstBits = &m_ppScanLine[ Status.nDstY ][ Status.nDstX ];

	DWORD dwAlphaSrc;
	DWORD dwAlphaDst;

	// [vJE^AZupɕϊ
	Status.nWidth  = CONVERT_WIDTH( Status.nWidth );
	Status.nHeight = CONVERT_HEIGHT( Status.nHeight );

	if( !Status.b64bit )
	{
		// Œ菬32rbgvZ

		__asm
		{
			mov ecx, Status.nHeight			// ]鍂(Y[vJE^)
			mov edi, pDstBits				// ]AhX

			mov eax, Status.fxSrcScanX		// JnWx
			mov ebx, Status.fxSrcScanY		// JnWy

		loop_y0:

			or ecx, Status.nWidth			// ]镝(X[vJE^)

		loop_x0:
		
			// ]NbsO
			cmp eax, Status.fxSrcLeft		// if( x < Status.fxSrcLeft ) skip
			jl skip_draw0

			cmp ebx, Status.fxSrcTop		// if( y < Status.fxSrcTop ) skip
			jl skip_draw0

			cmp eax, Status.fxSrcRight		// if( x >= Status.fxSrcRight ) skip
			jge skip_draw0

			cmp ebx, Status.fxSrcBottom		// if( y >= Status.fxSrcBottom ) skip
			jge skip_draw0

			push eax						// Œ菬xX^bNɕۑ
			push ebx						// Œ菬yX^bNɕۑ
			
			shr ebx, 16						// Œ菬y𐮐ɂ
			mov esi, ppSrcScanLine			// ]AhX

			shr eax, 16						// Œ菬x𐮐ɂ
			mov esi, [esi+ebx*4]			// ppSrcScanLine[y]

			mov esi, [esi+eax*4]			// (np) ]sNZf[^擾 = ppSrcScanLine[y][x]
			
			mov ebx, esi					// ]sNZf[^擾
			mov eax, 256					// ]̃`lp

			shr ebx, 24						// `l擾
			mov edx, esi					// ]sNZf[^擾
			
			shr edx, 31						// ŏʃrbg擾
			sub eax, ebx					// 256-`l

			add ebx, edx					// ]`l256iKɂ
			sub eax, edx					// ]惿`l256iKɂ

			mov dwAlphaSrc, ebx				// ]`l
			mov dwAlphaDst, eax				// ]惿`l

			mov edx, esi					// ]sNZf[^擾
			mov ebx, [edi]					// ]sNZf[^擾

			and edx, __xRxB_MASK_L			// }XN eax & 0x00ff00ff	
			and ebx, __xRxB_MASK_L			// }XN ebx & 0x00ff00ff

			imul edx, dwAlphaSrc			// (np) Kp

			imul ebx, dwAlphaDst			// (np) Kp
			
			add edx, ebx					// ]̃J[(RB)Ɠ]̃J[(RB)Z
			mov ebx, [edi]					// ]sNZf[^擾

			and esi, __AxGx_MASK_H			// }XN eax & 0x0000ff00
			and ebx, __AxGx_MASK_H			// (np) }XN eax & 0x0000ff00

			imul esi, dwAlphaSrc			// (np) Kp

			imul ebx, dwAlphaDst			// (np) Kp
			
			add esi, ebx					// (np) ]̃J[(G)Ɠ]̃J[(G)Z

			and esi, __xGxx_MASK_H			// [؂̂(G)
			and edx, __RxBx_MASK_L			// [؂̂(R,B)

			or esi, edx						// (np) GR,B
			
			shr esi, 8
			pop ebx							// Œ菬xX^bNo

			mov [edi], esi					// ]sNZf[^ɓ]
			pop eax							// Œ菬yX^bNo

	skip_draw0:

			add eax, Status.fxSrcAddXx		// x += Status.fxSrcAddXx
			add ebx, Status.fxSrcAddXy		// y += Status.fxSrcAddXy
			
			add edi, 4						// ]͒ʏ
			sub ecx, __DEC_WIDTH

			jns loop_x0						// (np)

			add eax, Status.fxSrcAddYx		// x += Status.fxSrcAddYx
			add ebx, Status.fxSrcAddYy		// y += Status.fxSrcAddYy
			
			add edi, Status.nDstAddY		// ̃C ]͒ʏ
			sub ecx, __DEC_HEIGHT

			jns loop_y0						// (np)

		}

	}else
	{
		// Œ菬64rbgvZ(d)

		__asm
		{
			mov ecx, Status.nHeight			// ]鍂(Y[vJE^)
			mov edi, pDstBits				// ]AhX

			mov eax, Status.fxSrcScanX_H	// JnWx ()
			mov ebx, Status.fxSrcScanY_H	// JnWy ()
			
			mov esi, Status.fxSrcScanX_L	// JnWx ()
			mov edx, Status.fxSrcScanY_L	// JnWy ()

		loop_y1:

			or ecx, Status.nWidth			// ]镝(X[vJE^)

		loop_x1:
		
			// ]NbsO
			cmp eax, Status.nSrcLeft		// if( x < Status.nSrcLeft ) skip
			jl skip_draw1

			cmp ebx, Status.nSrcTop			// if( y < Status.nSrcTop ) skip
			jl skip_draw1

			cmp eax, Status.nSrcRight		// if( x >= Status.nSrcRight ) skip
			jge skip_draw1

			cmp ebx, Status.nSrcBottom		// if( y >= Status.nSrcBottom ) skip
			jge skip_draw1
			
			push esi						// (np)
			push edx

			mov esi, ppSrcScanLine			// (np) ]AhX
			push ebx

			mov esi, [esi+ebx*4]			// (np) ppSrcScanLine[y]
			push eax

			mov esi, [esi+eax*4]			// (np) ]sNZf[^擾 = ppSrcScanLine[y][x]
			
			mov ebx, esi					// ]sNZf[^擾
			mov eax, 256					// ]̃`lp

			shr ebx, 24						// `l擾
			mov edx, esi					// ]sNZf[^擾
			
			shr edx, 31						// ŏʃrbg擾
			sub eax, ebx					// 256-`l

			add ebx, edx					// ]`l256iKɂ
			sub eax, edx					// ]惿`l256iKɂ

			mov dwAlphaSrc, ebx				// ]`l
			mov dwAlphaDst, eax				// ]惿`l

			mov edx, esi					// ]sNZf[^擾
			mov ebx, [edi]					// ]sNZf[^擾

			and edx, __xRxB_MASK_L			// }XN eax & 0x00ff00ff	
			and ebx, __xRxB_MASK_L			// }XN ebx & 0x00ff00ff

			imul edx, dwAlphaSrc			// (np) Kp

			imul ebx, dwAlphaDst			// (np) Kp
			
			add edx, ebx					// ]̃J[(RB)Ɠ]̃J[(RB)Z
			mov ebx, [edi]					// ]sNZf[^擾

			and esi, __AxGx_MASK_H			// }XN eax & 0x0000ff00
			and ebx, __AxGx_MASK_H			// (np) }XN eax & 0x0000ff00

			imul esi, dwAlphaSrc			// (np) Kp

			imul ebx, dwAlphaDst			// (np) Kp
			
			add esi, ebx					// (np) ]̃J[(G)Ɠ]̃J[(G)Z
			pop eax							// Œ菬yX^bNo

			and esi, __xGxx_MASK_H			// [؂̂(G)
			and edx, __RxBx_MASK_L			// [؂̂(R,B)

			or esi, edx						// (np) GR,B
			pop ebx							// Œ菬xX^bNo

			shr esi, 8
			pop edx

			mov [edi], esi					// ]sNZf[^ɓ]
			pop esi

	skip_draw1:

			add esi, Status.fxSrcAddXx_L	// (np) x += Status.fxSrcAddXx_L@()

			adc eax, Status.fxSrcAddXx_H	// x += Status.fxSrcAddXx_H ()	<u>
			add edx, Status.fxSrcAddXy_L	// y += Status.fxSrcAddXy_L	()	<v>

			adc ebx, Status.fxSrcAddXy_H	// y += Status.fxSrcAddXy_H	()	<u>
			add edi, 4						// ]͒ʏ					<v>

			sub ecx, __DEC_WIDTH
			jns loop_x1

			add esi, Status.fxSrcAddYx_L	// (np) x += Status.fxSrcAddYx_L@()

			adc eax, Status.fxSrcAddYx_H	// x += Status.fxSrcAddYx_H ()	<u>
			add edx, Status.fxSrcAddYy_L	// y += Status.fxSrcAddYy_L	()	<v>

			adc ebx, Status.fxSrcAddYy_H	// y += Status.fxSrcAddYy_H	()	<u>
			add edi, Status.nDstAddY		// ̃C ]͒ʏ	<v>

			sub ecx, __DEC_HEIGHT
			jns loop_y1
		}

		return SDIB32GLS_ROTATEBLT64BIT;
	}

	return S_OK;
}


/*----------------------------------------------------------------------------*
|	]`lufBO摜]
|	
|	[]
|	LPSDIB32GL lpSrcSDIB32GLc]SDIB32GLC^[tFCX
|	int nDstXc] x W
|	int nDstYc] y W
|	LPSIZE  lpDstSizec]̕Bl𕉂ɂ邱ƂŃ~[]B
|				NULLw肷΃ftHgTCYɂȂ܂B
|	LPPOINT lpSrcPtc]WBNULLw肷΍W(0)ɂȂ܂B
|	LPSIZE  lpSrcSizec]̕BNULLw肷΃ftHgTCYɂȂ܂B
|	BYTE AlphaclB
|	int		nAnglec]pxB1512x̒lłB
|	LPPOINT lpCenterPtc]SWBNULLw肷Ό݂̃|WV𒆐Sɂ܂B
*----------------------------------------------------------------------------*/
STDMETHODIMP CSDib32GLX86::RotateAlphaChannelAlphaBlendBlt( LPSDIB32GL lpSrcSDIB32GL, int nDstX, int nDstY, LPSIZE lpDstSize, LPPOINT lpSrcPt, LPSIZE lpSrcSize, BYTE Alpha, int nAngle, LPPOINT lpCenterPt )
{
	// IuWFNgNULL`FbN
	_ASSERTE( lpSrcSDIB32GL != NULL );
	if( lpSrcSDIB32GL == NULL ) return E_POINTER;

	CSDib32GLX86* lpSrc = safe_cast( CSDib32GLX86*, lpSrcSDIB32GL );
	INVALIDOBJECTCHECK( lpSrc );

	_ASSERTE( m_pBits != NULL);
	_ASSERTE( lpSrc->m_pBits != NULL );

	if( m_pBits == NULL ) return SDIB32GLERR_NOTINITIALIZED;
	if( lpSrc->m_pBits == NULL ) return SDIB32GLERR_NOTINITIALIZED;

	// `Xe[^Xɓ]W̑
	SDIB32GLROTATESTATUS Status = { nDstX, nDstY, nAngle };

	// NbsO
	if( !Clipping( lpSrc, Status, lpDstSize, lpSrcPt, lpSrcSize, lpCenterPt ) ) return SDIB32GLERR_INVALIDPOSITION;

	// ]恕]̊JnAhX
	LPSDIB32GLCOLOR* ppSrcScanLine = lpSrc->m_ppScanLine;
	LPSDIB32GLCOLOR pDstBits = &m_ppScanLine[ Status.nDstY ][ Status.nDstX ];

	DWORD dwAlpha = CONVERT_255To256( Alpha );
	DWORD dwAlphaSrc;
	DWORD dwAlphaDst;

	// [vJE^AZupɕϊ
	Status.nWidth  = CONVERT_WIDTH( Status.nWidth );
	Status.nHeight = CONVERT_HEIGHT( Status.nHeight );

	if( !Status.b64bit )
	{
		// Œ菬32rbgvZ

		__asm
		{
			mov ecx, Status.nHeight			// ]鍂(Y[vJE^)
			mov edi, pDstBits				// ]AhX

			mov eax, Status.fxSrcScanX		// JnWx
			mov ebx, Status.fxSrcScanY		// JnWy

		loop_y0:

			or ecx, Status.nWidth			// ]镝(X[vJE^)

		loop_x0:
		
			// ]NbsO
			cmp eax, Status.fxSrcLeft		// if( x < Status.fxSrcLeft ) skip
			jl skip_draw0

			cmp ebx, Status.fxSrcTop		// if( y < Status.fxSrcTop ) skip
			jl skip_draw0

			cmp eax, Status.fxSrcRight		// if( x >= Status.fxSrcRight ) skip
			jge skip_draw0

			cmp ebx, Status.fxSrcBottom		// if( y >= Status.fxSrcBottom ) skip
			jge skip_draw0

			push eax						// Œ菬xX^bNɕۑ
			push ebx						// Œ菬yX^bNɕۑ
			
			shr ebx, 16						// Œ菬y𐮐ɂ
			mov esi, ppSrcScanLine			// ]AhX

			shr eax, 16						// Œ菬x𐮐ɂ
			mov esi, [esi+ebx*4]			// ppSrcScanLine[y]

			mov esi, [esi+eax*4]			// (np) ]sNZf[^擾 = ppSrcScanLine[y][x]
			
			mov ebx, esi					// ]sNZf[^擾
			mov eax, 256					// ]̃`lp

			shr ebx, 24						// `l擾
			mov edx, esi					// ]sNZf[^擾
			
			shr edx, 31						// ŏʃrbg擾

			add ebx, edx					// ]`l256iKɂ
	
			imul ebx, dwAlpha				// `l

			shr ebx, 8						// 
			mov edx, esi					// ]sNZf[^擾

			sub eax, ebx					// 256-
			mov dwAlphaSrc, ebx				// ]`l

			mov ebx, [edi]					// ]sNZf[^擾
			mov dwAlphaDst, eax				// ]惿`l

			and edx, __xRxB_MASK_L			// }XN eax & 0x00ff00ff	
			and ebx, __xRxB_MASK_L			// }XN ebx & 0x00ff00ff

			imul edx, dwAlphaSrc			// (np) Kp

			imul ebx, dwAlphaDst			// (np) Kp
			
			add edx, ebx					// ]̃J[(RB)Ɠ]̃J[(RB)Z
			mov ebx, [edi]					// ]sNZf[^擾

			and esi, __AxGx_MASK_H			// }XN eax & 0x0000ff00
			and ebx, __AxGx_MASK_H			// (np) }XN eax & 0x0000ff00

			imul esi, dwAlphaSrc			// (np) Kp

			imul ebx, dwAlphaDst			// (np) Kp
			
			add esi, ebx					// (np) ]̃J[(G)Ɠ]̃J[(G)Z
	
			and esi, __xGxx_MASK_H			// [؂̂(G)
			and edx, __RxBx_MASK_L			// [؂̂(R,B)

			or esi, edx						// (np) GR,B
			
			shr esi, 8
			pop ebx							// Œ菬xX^bNo

			mov [edi], esi					// ]sNZf[^ɓ]
			pop eax							// Œ菬yX^bNo

	skip_draw0:

			add eax, Status.fxSrcAddXx		// x += Status.fxSrcAddXx
			add ebx, Status.fxSrcAddXy		// y += Status.fxSrcAddXy
			
			add edi, 4						// ]͒ʏ
			sub ecx, __DEC_WIDTH

			jns loop_x0						// (np)

			add eax, Status.fxSrcAddYx		// x += Status.fxSrcAddYx
			add ebx, Status.fxSrcAddYy		// y += Status.fxSrcAddYy
			
			add edi, Status.nDstAddY		// ̃C ]͒ʏ
			sub ecx, __DEC_HEIGHT

			jns loop_y0						// (np)

		}

	}else
	{
		// Œ菬64rbgvZ(d)

		__asm
		{
			mov ecx, Status.nHeight			// ]鍂(Y[vJE^)
			mov edi, pDstBits				// ]AhX

			mov eax, Status.fxSrcScanX_H	// JnWx ()
			mov ebx, Status.fxSrcScanY_H	// JnWy ()
			
			mov esi, Status.fxSrcScanX_L	// JnWx ()
			mov edx, Status.fxSrcScanY_L	// JnWy ()

		loop_y1:

			or ecx, Status.nWidth			// ]镝(X[vJE^)

		loop_x1:
		
			// ]NbsO
			cmp eax, Status.nSrcLeft		// if( x < Status.nSrcLeft ) skip
			jl skip_draw1

			cmp ebx, Status.nSrcTop			// if( y < Status.nSrcTop ) skip
			jl skip_draw1

			cmp eax, Status.nSrcRight		// if( x >= Status.nSrcRight ) skip
			jge skip_draw1

			cmp ebx, Status.nSrcBottom		// if( y >= Status.nSrcBottom ) skip
			jge skip_draw1
			
			push esi						// (np)
			push edx

			mov esi, ppSrcScanLine			// (np) ]AhX
			push ebx

			mov esi, [esi+ebx*4]			// (np) ppSrcScanLine[y]
			push eax

			mov esi, [esi+eax*4]			// (np) ]sNZf[^擾 = ppSrcScanLine[y][x]

			mov ebx, esi					// ]sNZf[^擾
			mov eax, 256					// ]̃`lp

			shr ebx, 24						// `l擾
			mov edx, esi					// ]sNZf[^擾
			
			shr edx, 31						// ŏʃrbg擾

			add ebx, edx					// ]`l256iKɂ
	
			imul ebx, dwAlpha				// `l

			shr ebx, 8						// 
			mov edx, esi					// ]sNZf[^擾

			sub eax, ebx					// 256-
			mov dwAlphaSrc, ebx				// ]`l

			mov ebx, [edi]					// ]sNZf[^擾
			mov dwAlphaDst, eax				// ]惿`l

			and edx, __xRxB_MASK_L			// }XN eax & 0x00ff00ff	
			and ebx, __xRxB_MASK_L			// }XN ebx & 0x00ff00ff

			imul edx, dwAlphaSrc			// (np) Kp

			imul ebx, dwAlphaDst			// (np) Kp
			
			add edx, ebx					// ]̃J[(RB)Ɠ]̃J[(RB)Z
			mov ebx, [edi]					// ]sNZf[^擾

			and esi, __AxGx_MASK_H			// }XN eax & 0x0000ff00
			and ebx, __AxGx_MASK_H			// (np) }XN eax & 0x0000ff00

			imul esi, dwAlphaSrc			// (np) Kp

			imul ebx, dwAlphaDst			// (np) Kp
			
			add esi, ebx					// (np) ]̃J[(G)Ɠ]̃J[(G)Z
			pop eax							// Œ菬yX^bNo

			and esi, __xGxx_MASK_H			// [؂̂(G)
			and edx, __RxBx_MASK_L			// [؂̂(R,B)

			or esi, edx						// (np) GR,B
			pop ebx							// Œ菬xX^bNo

			shr esi, 8
			pop edx

			mov [edi], esi					// ]sNZf[^ɓ]
			pop esi

	skip_draw1:

			add esi, Status.fxSrcAddXx_L	// (np) x += Status.fxSrcAddXx_L@()

			adc eax, Status.fxSrcAddXx_H	// x += Status.fxSrcAddXx_H ()	<u>
			add edx, Status.fxSrcAddXy_L	// y += Status.fxSrcAddXy_L	()	<v>

			adc ebx, Status.fxSrcAddXy_H	// y += Status.fxSrcAddXy_H	()	<u>
			add edi, 4						// ]͒ʏ					<v>

			sub ecx, __DEC_WIDTH
			jns loop_x1

			add esi, Status.fxSrcAddYx_L	// (np) x += Status.fxSrcAddYx_L@()

			adc eax, Status.fxSrcAddYx_H	// x += Status.fxSrcAddYx_H ()	<u>
			add edx, Status.fxSrcAddYy_L	// y += Status.fxSrcAddYy_L	()	<v>

			adc ebx, Status.fxSrcAddYy_H	// y += Status.fxSrcAddYy_H	()	<u>
			add edi, Status.nDstAddY		// ̃C ]͒ʏ	<v>

			sub ecx, __DEC_HEIGHT
			jns loop_y1
		}

		return SDIB32GLS_ROTATEBLT64BIT;
	}

	return S_OK;
}


/*----------------------------------------------------------------------------*
|	``
|@
|	w肵Fŋ`̈𔼓܂
|
|	[]
|	int xcx W
|	int ycy W
|	int nWidthc
|	int nHeightc
|	SDIB32GLCOLOR Colorc`F(ftHgł͍)
*----------------------------------------------------------------------------*/
STDMETHODIMP CSDib32GLX86::RectangleAlpha( int x, int y, int nWidth, int nHeight, SDIB32GLCOLOR Color )
{
	// IuWFNgNULL`FbN
	_ASSERTE( m_pBits != NULL);
	if( m_pBits == NULL ) return SDIB32GLERR_NOTINITIALIZED;

	// NbsO
	if( !Clipping( x, y, nWidth, nHeight ) ) return SDIB32GLERR_INVALIDPOSITION;
	
	DWORD dwAlphaSrc = CONVERT_255To256( SDIB32GL_GET_ALPHA(Color) );	// At@
	DWORD dwAlphaDst = DEST_ALPHA( dwAlphaSrc );// t̃At@
	DWORD dwAlphaColor_H;						// AGpAt@l(64rbgʕ)
	DWORD dwAlphaColor_L;						// RBpAt@l(64rbgʕ)
	DWORD dwAddWidth = (m_nWidth-nWidth)<<2;

//	LPSDIB32GLCOLOR pBits = &m_pBits[x+y*m_nWidth];
	LPSDIB32GLCOLOR pBits = &m_ppScanLine[y][x];

	__asm
	{
		mov eax, Color			// J[
		mov ebx, Color			// J[

		and eax, __AxGx_MASK_H	// ARGBlAGɕ(A͎gȂ)
		and ebx, __xRxB_MASK_L	// ARGBlRBɕ

		imul eax, dwAlphaSrc	// (np) ARGBl(A)G̃lvZ
		
		imul ebx, dwAlphaSrc	// (np) ARGBlRB̃lvZ

		mov dwAlphaColor_H, eax	// oオG(WORDf[^)
		mov dwAlphaColor_L, ebx	// oオR(WORDf[^)B(WORDf[^)

		mov edi, pBits			// ݂X,Yobt@AhX
		mov esi, dwAddWidth

		mov ecx, nWidth			// X[vJE^
		mov edx, nHeight		// Y[vJE^

	loop_x:

		mov eax, [edi]			// sNZf[^擾
		mov ebx, [edi]			// sNZf[^擾

		and eax, __AxGx_MASK_H	// }XN eax & 0x0000ff00
		and ebx, __xRxB_MASK_L	// }XN ebx & 0x00ff00ff

		imul eax, dwAlphaDst	// (np) Kp

		imul ebx, dwAlphaDst	// (np) Kp

		add eax, dwAlphaColor_H	// ]̃J[(G)Ɠ]̃J[(G)Z
		add ebx, dwAlphaColor_L	// ]̃J[(RB)Ɠ]̃J[(RB)Z

		and eax, __xGxx_MASK_H	// [؂̂(G)
		and ebx, __RxBx_MASK_L	// [؂̂(R,B)

		or eax, ebx				// GR,B
		add edi, 4				// ]ׂ̃sNZɈړ

		shr eax, 8				// 
		dec ecx

		mov [edi-4], eax		// 
		jne loop_x				// if( ecx != 0 )

		add edi, esi			// ̃CɈړ
		mov ecx, nWidth			// JE^A

		dec edx
		jne loop_x				// (np) if( edx != 0 )
	}

	return S_OK;
}


/*----------------------------------------------------------------------------*
|	Z``
|
|	w肵Fŋ`̈Z܂
|	lw肷邱ƂŔZ\
|@
|	[]
|	int xcx W
|	int ycy W
|	int nWidthc
|	int nHeightc
|	SDIB32GLCOLOR Colorc`F(ftHgł͍)
*----------------------------------------------------------------------------*/
STDMETHODIMP CSDib32GLX86::RectangleAdd( int x, int y, int nWidth, int nHeight, SDIB32GLCOLOR Color )
{
	// IuWFNgNULL`FbN
	_ASSERTE( m_pBits != NULL);
	if( m_pBits == NULL ) return SDIB32GLERR_NOTINITIALIZED;

	// ==0 || rgb==RGB(0,0,0)  
	if( !(Color&__Axxx_MASK) || !(Color&__xRGB_MASK) ) return S_OK;

	// NbsO
	if( !Clipping( x, y, nWidth, nHeight ) ) return SDIB32GLERR_INVALIDPOSITION;
	
	DWORD dwAlphaSrc = CONVERT_255To256( SDIB32GL_GET_ALPHA(Color) );	// At@
	DWORD dwAddWidth = (m_nWidth-nWidth)<<2;
	DWORD dwAlphaColor;

//	LPSDIB32GLCOLOR pBits = &m_pBits[x+y*m_nWidth];
	LPSDIB32GLCOLOR pBits = &m_ppScanLine[y][x];


	__asm
	{
		mov ecx, dwAlphaSrc
		mov ebx, Color

		cmp ecx, 256
		je skip_alphacolor

		mov eax, Color			// J[
		mov ebx, Color			// J[

		and eax, __AxGx_MASK_H	// ARGBlAGɕ(A͎gȂ)
		and ebx, __xRxB_MASK_L	// ARGBlRBɕ

		imul eax, ecx			// (np) Kp
		
		imul ebx, ecx			// (np) Kp

		and eax, __xGxx_MASK_H	// [؂̂(G)
		and ebx, __RxBx_MASK_L	// [؂̂(R,B)

		or ebx, eax				// (np) GR,B
		
		shr ebx, 8				// (np)

	skip_alphacolor:

		mov dwAlphaColor, ebx	// J[
		mov edi, pBits			// ݂X,Yobt@AhX

		mov ecx, nWidth			// X[vJE^
		mov edx, nHeight		// Y[vJE^

	loop_x:

		mov eax, dwAlphaColor	// ]J[
		mov ebx, [edi]			// ]J[

		and ebx, eax
		xor eax, [edi]

		shl ebx, 1					//	<u>
		and eax, __MASK_fefefefe	//	<v>

		add eax, ebx
		mov ebx, dwAlphaColor

		and eax, __MASK_01010100
		add ebx, [edi]

		shr eax, 8					// (np)

		add eax, __MASK_7f7f7f7f	// (np)

		xor eax, __MASK_7f7f7f7f	// (np)

		sub ebx, eax				// 
		add edi, 4					// AhXi߂
		
		or ebx, eax					// 
		dec ecx

		mov [edi-4], ebx			// `
		jne loop_x					// if( ecx != 0 )

		add edi, dwAddWidth			// ̃CɈړ
		mov ecx, nWidth				// JE^A

		dec edx
		jne loop_x					// (np) if( edx != 0 )
	}

	return S_OK;
}


/*----------------------------------------------------------------------------*
|	Z``
|	
|	w肵Fŋ`̈Z܂
|	lw肷邱ƂŔZ\
|	
|	[]
|	int xcx W
|	int ycy W
|	int nWidthc
|	int nHeightc
|	SDIB32GLCOLOR Colorc`F(ftHgł͍)
*----------------------------------------------------------------------------*/
STDMETHODIMP CSDib32GLX86::RectangleSub( int x, int y, int nWidth, int nHeight, SDIB32GLCOLOR Color )
{
	// IuWFNgNULL`FbN
	_ASSERTE( m_pBits != NULL);
	if( m_pBits == NULL ) return SDIB32GLERR_NOTINITIALIZED;

	// ==0 || rgb==RGB(255,255,255) 
	if( !(Color&__Axxx_MASK) || (Color&__xRGB_MASK)==__xRGB_MASK ) return S_OK;

	// NbsO
	if( !Clipping( x, y, nWidth, nHeight ) ) return SDIB32GLERR_INVALIDPOSITION;

	DWORD dwAlphaSrc = CONVERT_255To256( SDIB32GL_GET_ALPHA(Color) );	// At@
	DWORD dwAddWidth = (m_nWidth-nWidth)<<2;
	DWORD dwAlphaColor;

//	LPSDIB32GLCOLOR pBits = &m_pBits[x+y*m_nWidth];
	LPSDIB32GLCOLOR pBits = &m_ppScanLine[y][x];


	__asm
	{
		mov ecx, dwAlphaSrc
		mov ebx, Color

		cmp ecx, 256
		je skip_alphacolor

		mov eax, Color			// J[
		mov ebx, Color			// J[

		and eax, __AxGx_MASK_H	// ARGBlAGɕ(A͎gȂ)
		and ebx, __xRxB_MASK_L	// ARGBlRBɕ

		imul eax, ecx			// (np) Kp
		
		imul ebx, ecx			// (np) Kp

		and eax, __xGxx_MASK_H	// [؂̂(G)
		and ebx, __RxBx_MASK_L	// [؂̂(R,B)

		or ebx, eax				// (np) GR,B
		
		shr ebx, 8				// (np)

	skip_alphacolor:

		mov dwAlphaColor, ebx	// J[
		mov edi, pBits			// ݂X,Yobt@AhX

		mov ecx, nWidth			// X[vJE^
		mov edx, nHeight		// Y[vJE^

	loop_x:

		mov eax, dwAlphaColor	// ]J[
		mov ebx, [edi]			// ]J[

		not ebx					// (np)
		
		mov esi, dwAlphaColor
		and eax, ebx

		shl eax, 1					//	<u>
		xor esi, ebx				//	<v>

		and esi, __MASK_fefefefe	// (np)

		add eax, esi				// (np)

		mov esi, dwAlphaColor
		and eax, __MASK_01010100

		shr eax, 8					//	<u>
		mov ebx, [edi]				//	<v>

		add eax, __MASK_7f7f7f7f	// (np)
		add edi, 4					// AhXi߂

		xor eax, __MASK_7f7f7f7f	// (np)

		or esi, eax
		or ebx, eax

		sub ebx, esi				// 
		dec ecx

		mov [edi-4], ebx			// `
		jne loop_x					// if( ecx != 0 )

		add edi, dwAddWidth			// ̃CɈړ
		mov ecx, nWidth				// JE^A

		dec edx
		jne loop_x					// (np) if( edx != 0 )
	}

	return S_OK;
}


/*----------------------------------------------------------------------------*
|	
*----------------------------------------------------------------------------*/
STDMETHODIMP CSDib32GLX86::LineAlpha( int x0, int y0, int x1, int y1, SDIB32GLCOLOR Color )
{
	// IuWFNgNULL`FbN
	_ASSERTE( m_pBits != NULL);
	if( m_pBits == NULL ) return SDIB32GLERR_NOTINITIALIZED;

	LPSDIB32GLCOLOR* ppScanLine = m_ppScanLine;

	DWORD dwDx = abs(x0 - x1);		// JnWsxIWex܂ł̋
	DWORD dwDy = abs(y0 - y1);		// JnWsyIWey܂ł̋
	DWORD dw2Dx = dwDx<<1;			// vZp
	DWORD dw2Dy = dwDy<<1;			// vZp
	DWORD dwAx = x0 < x1? 1 : -1;	// pxX
	DWORD dwAy = y0 < y1? 1 : -1;	// pyY
	LONG  nClipLeft   = m_rcClip.left;
	LONG  nClipTop    = m_rcClip.top;
	LONG  nClipRight  = m_rcClip.right-1;
	LONG  nClipBottom = m_rcClip.bottom-1;
	DWORD dwEnd;

	DWORD dwAlphaSrc = CONVERT_255To256( SDIB32GL_GET_ALPHA(Color) );	// At@
	DWORD dwAlphaDst = DEST_ALPHA( dwAlphaSrc );// t̃At@
	DWORD dwAlphaColor_H;						// AGpAt@l(64rbgʕ)
	DWORD dwAlphaColor_L;						// RBpAt@l(64rbgʕ)

	__asm
	{
		mov eax, Color			// J[
		mov ebx, Color			// J[

		and eax, __AxGx_MASK_H	// ARGBlAGɕ(A͎gȂ)
		and ebx, __xRxB_MASK_L	// ARGBlRBɕ

		imul eax, dwAlphaSrc	// (np) ARGBl(A)G̃lvZ
		
		imul ebx, dwAlphaSrc	// (np) ARGBlRB̃lvZ

		mov dwAlphaColor_H, eax	// oオG(WORDf[^)
		mov dwAlphaColor_L, ebx	// oオR(WORDf[^)B(WORDf[^)

		mov edi, dwDx
		mov esi, dwDy

		cmp edi, esi
		jbe jump_y				// dwDx <= dwDy

		mov eax, x1
		mov ebx, dwAx

		add eax, ebx			// (np)

		mov dwEnd, eax			// (np) dwEnd = x1 + dwAx

		mov eax, x0				// JnXW
		mov ebx, y0				// JnYW

		mov edx, edi

		neg edx					// (np) 덷̏l dwDx*-1

	loop_0:

		// NbsO
		mov esi, nClipRight		// if( x<0 || x>nClipWidth || y<0 || y>nClipHeight )
		mov edi, nClipBottom	// ̎Wv
								// 
		sub esi, eax			// if( x<0 || nClipWidth-x<0 || y<0 || nClipHeight-y<0 )
		sub edi, ebx			// rbgŔ肷悤ɂɏ
								// if( (x | nClipWidth-x | y | nClipHeight-y )<0 )
		or esi, edi				// rxł
		mov ecx, eax			// QlTCg (c)D5. http://www.aya.or.jp/~sanami/

		mov edi, ebx
		sub ecx, nClipLeft

		sub edi, nClipTop
		or esi, ecx

		or esi, edi
		js skip_draw_0
		
		// `
		mov ecx, ppScanLine		// (np)

		mov ecx, [ecx+ebx*4]	// (np) YW̐擪AhX *(ppScanLine+y)
		
		mov edi, [ecx+eax*4]	// ]sNZ
		mov esi, [ecx+eax*4]	// ]sNZ

		and edi, __AxGx_MASK_H	// }XN
		and esi, __xRxB_MASK_L

		imul edi, dwAlphaDst	// (np) Kp

		imul esi, dwAlphaDst	// (np) Kp

		add edi, dwAlphaColor_H	// ]̃J[Ɠ]̃J[Z
		add esi, dwAlphaColor_L

		and edi, __xGxx_MASK_H	// [؂̂(G)
		and esi, __RxBx_MASK_L	// [؂̂(R,B)

		or edi, esi				// (np) GR,B

		shr edi, 8				// (np)

		mov [ecx+eax*4], edi	// ]sNZɕ`

	skip_draw_0:

		add eax, dwAx			// XZ
		add edx, dw2Dy			// 덷Z

		js skip_add_y			// edx-dw2DyȂWv
	
		add ebx, dwAy			// YZ
		sub edx, dw2Dx			// 덷
		
	skip_add_y:

		cmp eax, dwEnd			// I_ɂǂ
		jne loop_0
		
		jmp end_loop			// (np) I

	jump_y:
	
		mov eax, y1
		mov ebx, dwAy

		add eax, ebx			// (np)

		mov dwEnd, eax			// (np) dwEnd = y1 + dwAy

		mov eax, x0				// JnXW
		mov ebx, y0				// JnYW

		mov edx, esi

		neg edx					// (np) 덷̏l dwDx*-1

	loop_1:

		// NbsO
		mov esi, nClipRight		// if( x<0 || x>nClipWidth || y<0 || y>nClipHeight )
		mov edi, nClipBottom	// ̎Wv
								// 
		sub esi, eax			// if( x<0 || nClipWidth-x<0 || y<0 || nClipHeight-y<0 )
		sub edi, ebx			// rbgŔ肷悤ɂɏ
								// if( (x | nClipWidth-x | y | nClipHeight-y )<0 )
		or esi, edi				// rxł
		mov ecx, eax			// QlTCg (c)D5. http://www.aya.or.jp/~sanami/

		mov edi, ebx
		sub ecx, nClipLeft

		sub edi, nClipTop
		or esi, ecx

		or esi, edi
		js skip_draw_1
		
		// `
		mov ecx, ppScanLine		// (np) obt@

		mov ecx, [ecx+ebx*4]	// (np) YW		

		mov edi, [ecx+eax*4]	// ]sNZ
		mov esi, [ecx+eax*4]	// ]sNZ

		and edi, __AxGx_MASK_H	// }XN
		and esi, __xRxB_MASK_L

		imul edi, dwAlphaDst	// (np) Kp

		imul esi, dwAlphaDst	// (np)

		add edi, dwAlphaColor_H	// ]̃J[Ɠ]̃J[Z
		add esi, dwAlphaColor_L

		and edi, __xGxx_MASK_H	// [؂̂(G)
		and esi, __RxBx_MASK_L	// [؂̂(R,B)

		or edi, esi				// (np) GR,B

		shr edi, 8

		mov [ecx+eax*4], edi	// ]sNZɕ`

	skip_draw_1:

		add ebx, dwAy			// YZ
		add edx, dw2Dx			// 덷Z

		js skip_add_x			// edx-dw2DxȂWv
	
		add eax, dwAx			// XZ
		sub edx, dw2Dy			// 덷
		
	skip_add_x:

		cmp ebx, dwEnd			// I_ɂǂ
		jne loop_1

	end_loop:
		
	}

	return S_OK;
}


/*----------------------------------------------------------------------------*
|	Z
*----------------------------------------------------------------------------*/
STDMETHODIMP CSDib32GLX86::LineAdd( int x0, int y0, int x1, int y1, SDIB32GLCOLOR Color )
{
	// IuWFNgNULL`FbN
	_ASSERTE( m_pBits != NULL);
	if( m_pBits == NULL ) return SDIB32GLERR_NOTINITIALIZED;

	// ==0 || rgb==RGB(0,0,0)  
	if( !(Color&__Axxx_MASK) || !(Color&__xRGB_MASK) ) return S_OK;

	LPSDIB32GLCOLOR* ppScanLine = m_ppScanLine;

	DWORD dwDx = abs(x0 - x1);		// JnWsxIWex܂ł̋
	DWORD dwDy = abs(y0 - y1);		// JnWsyIWey܂ł̋
	DWORD dw2Dx = dwDx<<1;			// vZp
	DWORD dw2Dy = dwDy<<1;			// vZp
	DWORD dwAx = x0 < x1? 1 : -1;	// pxX
	DWORD dwAy = y0 < y1? 1 : -1;	// pyY
	LONG  nClipLeft   = m_rcClip.left;
	LONG  nClipTop    = m_rcClip.top;
	LONG  nClipRight  = m_rcClip.right-1;
	LONG  nClipBottom = m_rcClip.bottom-1;
	DWORD dwEnd;

	DWORD dwAlphaSrc  = CONVERT_255To256(SDIB32GL_GET_ALPHA(Color));	// At@
	DWORD dwAlphaColor;


	__asm
	{
		mov ecx, dwAlphaSrc
		mov ebx, Color

		cmp ecx, 256
		je skip_alphacolor

		mov eax, Color			// J[
		mov ebx, Color			// J[

		and eax, __AxGx_MASK_H	// ARGBlAGɕ(A͎gȂ)
		and ebx, __xRxB_MASK_L	// ARGBlRBɕ

		imul eax, ecx			// (np) Kp
		
		imul ebx, ecx			// (np) Kp

		and eax, __xGxx_MASK_H	// [؂̂(G)
		and ebx, __RxBx_MASK_L	// [؂̂(R,B)

		or ebx, eax				// (np) GR,B
		
		shr ebx, 8				// (np)

	skip_alphacolor:

		mov dwAlphaColor, ebx	// J[

		mov edi, dwDx
		mov esi, dwDy

		cmp edi, esi
		jbe jump_y				// dwDx <= dwDy

		mov eax, x1
		mov ebx, dwAx

		add eax, ebx			// (np)

		mov dwEnd, eax			// (np) dwEnd = x1 + dwAx

		mov eax, x0				// JnXW
		mov ebx, y0				// JnYW

		mov edx, edi

		neg edx					// (np) 덷̏l dwDx*-1

	loop_0:

		// NbsO
		mov esi, nClipRight		// if( x<0 || x>nClipWidth || y<0 || y>nClipHeight )
		mov edi, nClipBottom	// ̎Wv
								// 
		sub esi, eax			// if( x<0 || nClipWidth-x<0 || y<0 || nClipHeight-y<0 )
		sub edi, ebx			// rbgŔ肷悤ɂɏ
								// if( (x | nClipWidth-x | y | nClipHeight-y )<0 )
		or esi, edi				// rxł
		mov ecx, eax			// QlTCg (c)D5. http://www.aya.or.jp/~sanami/

		mov edi, ebx
		sub ecx, nClipLeft

		sub edi, nClipTop
		or esi, ecx

		or esi, edi
		js skip_draw_0
		
		// `
		mov ecx, ppScanLine		// (np)

		mov ecx, [ecx+ebx*4]	// (np) YW̐擪AhX *(ppScanLine+y)

		mov edi, [ecx+eax*4]	// ]J[
		mov esi, dwAlphaColor	// ]J[

		and edi, esi
		xor esi, [ecx+eax*4]

		shl edi, 1					//	<u>
		and esi, __MASK_fefefefe	//	<v>

		add esi, edi
		mov edi, dwAlphaColor

		and esi, __MASK_01010100
		add edi, [ecx+eax*4]

		shr esi, 8					// (np)

		add esi, __MASK_7f7f7f7f	// (np)

		xor esi, __MASK_7f7f7f7f	// (np)

		sub edi, esi				// (np)
		
		or edi, esi					// (np)

		mov [ecx+eax*4], edi		// `


	skip_draw_0:

		add eax, dwAx			// XZ
		add edx, dw2Dy			// 덷Z

		js skip_add_y			// edx-dw2DyȂWv
	
		add ebx, dwAy			// YZ
		sub edx, dw2Dx			// 덷
		
	skip_add_y:

		cmp eax, dwEnd			// I_ɂǂ
		jne loop_0
		
		jmp end_loop			// (np) I

	jump_y:
	
		mov eax, y1
		mov ebx, dwAy

		add eax, ebx			// (np)

		mov dwEnd, eax			// (np) dwEnd = y1 + dwAy

		mov eax, x0				// JnXW
		mov ebx, y0				// JnYW

		mov edx, esi

		neg edx					// (np) 덷̏l dwDx*-1

	loop_1:

		// NbsO
		mov esi, nClipRight		// if( x<0 || x>nClipWidth || y<0 || y>nClipHeight )
		mov edi, nClipBottom	// ̎Wv
								// 
		sub esi, eax			// if( x<0 || nClipWidth-x<0 || y<0 || nClipHeight-y<0 )
		sub edi, ebx			// rbgŔ肷悤ɂɏ
								// if( (x | nClipWidth-x | y | nClipHeight-y )<0 )
		or esi, edi				// rxł
		mov ecx, eax			// QlTCg (c)D5. http://www.aya.or.jp/~sanami/

		mov edi, ebx
		sub ecx, nClipLeft

		sub edi, nClipTop
		or esi, ecx

		or esi, edi
		js skip_draw_1
		
		// `
		mov ecx, ppScanLine		// (np)

		mov ecx, [ecx+ebx*4]	// (np) YW̐擪AhX *(ppScanLine+y)

		mov edi, [ecx+eax*4]	// ]J[
		mov esi, dwAlphaColor	// ]J[

		and edi, esi
		xor esi, [ecx+eax*4]

		shl edi, 1					// <u>
		and esi, __MASK_fefefefe	// <v>

		add esi, edi
		mov edi, dwAlphaColor

		and esi, __MASK_01010100
		add edi, [ecx+eax*4]

		shr esi, 8					// (np)

		add esi, __MASK_7f7f7f7f	// (np)

		xor esi, __MASK_7f7f7f7f	// (np)

		sub edi, esi				// (np)
		
		or edi, esi					// (np)

		mov [ecx+eax*4], edi		// `


	skip_draw_1:

		add ebx, dwAy			// YZ
		add edx, dw2Dx			// 덷Z

		js skip_add_x			// edx-dw2DxȂWv
	
		add eax, dwAx			// XZ
		sub edx, dw2Dy			// 덷
		
	skip_add_x:

		cmp ebx, dwEnd			// I_ɂǂ
		jne loop_1

	end_loop:
		
	}
	
	return S_OK;
}


/*----------------------------------------------------------------------------*
|	Z
*----------------------------------------------------------------------------*/
STDMETHODIMP CSDib32GLX86::LineSub( int x0, int y0, int x1, int y1, SDIB32GLCOLOR Color )
{
	// IuWFNgNULL`FbN
	_ASSERTE( m_pBits != NULL);
	if( m_pBits == NULL ) return SDIB32GLERR_NOTINITIALIZED;

	// ==0 || rgb==RGB(255,255,255) 
	if( !(Color&__Axxx_MASK) || (Color&__xRGB_MASK)==__xRGB_MASK ) return S_OK;

	LPSDIB32GLCOLOR* ppScanLine = m_ppScanLine;

	DWORD dwDx = abs(x0 - x1);		// JnWsxIWex܂ł̋
	DWORD dwDy = abs(y0 - y1);		// JnWsyIWey܂ł̋
	DWORD dw2Dx = dwDx<<1;			// vZp
	DWORD dw2Dy = dwDy<<1;			// vZp
	DWORD dwAx = x0 < x1? 1 : -1;	// pxX
	DWORD dwAy = y0 < y1? 1 : -1;	// pyY
	LONG  nClipLeft   = m_rcClip.left;
	LONG  nClipTop    = m_rcClip.top;
	LONG  nClipRight  = m_rcClip.right-1;
	LONG  nClipBottom = m_rcClip.bottom-1;
	DWORD dwEnd;

	DWORD dwAlphaSrc  = CONVERT_255To256(SDIB32GL_GET_ALPHA(Color));	// At@
	DWORD dwAlphaColor;


	__asm
	{
		mov ecx, dwAlphaSrc
		mov ebx, Color

		cmp ecx, 256
		je skip_alphacolor

		mov eax, Color			// J[
		mov ebx, Color			// J[

		and eax, __AxGx_MASK_H	// ARGBlAGɕ(A͎gȂ)
		and ebx, __xRxB_MASK_L	// ARGBlRBɕ

		imul eax, ecx			// (np) Kp
		
		imul ebx, ecx			// (np) Kp

		and eax, __xGxx_MASK_H	// [؂̂(G)
		and ebx, __RxBx_MASK_L	// [؂̂(R,B)

		or ebx, eax				// (np) GR,B
		
		shr ebx, 8				// (np)

	skip_alphacolor:

		mov dwAlphaColor, ebx	// J[

		mov edi, dwDx
		mov esi, dwDy

		cmp edi, esi
		jbe jump_y				// dwDx <= dwDy

		mov eax, x1
		mov ebx, dwAx

		add eax, ebx			// (np)

		mov dwEnd, eax			// (np) dwEnd = x1 + dwAx

		mov eax, x0				// JnXW
		mov ebx, y0				// JnYW

		mov edx, edi

		neg edx					// (np) 덷̏l dwDx*-1

	loop_0:

		// NbsO
		mov esi, nClipRight		// if( x<0 || x>nClipWidth || y<0 || y>nClipHeight )
		mov edi, nClipBottom	// ̎Wv
								// 
		sub esi, eax			// if( x<0 || nClipWidth-x<0 || y<0 || nClipHeight-y<0 )
		sub edi, ebx			// rbgŔ肷悤ɂɏ
								// if( (x | nClipWidth-x | y | nClipHeight-y )<0 )
		or esi, edi				// rxł
		mov ecx, eax			// QlTCg (c)D5. http://www.aya.or.jp/~sanami/

		mov edi, ebx
		sub ecx, nClipLeft

		sub edi, nClipTop
		or esi, ecx

		or esi, edi
		js skip_draw_0
		
		// `
		push edx				// 덷̕ۑ
		mov ecx, ppScanLine		// (np)

		mov ecx, [ecx+ebx*4]	// (np) YW̐擪AhX *(ppScanLine+y)
		
		mov edi, [ecx+eax*4]	// ]J[
		mov esi, dwAlphaColor	// ]J[

		not edi					// (np)

		mov edx, dwAlphaColor
		and esi, edi

		shl esi, 1					// <u>
		xor edx, edi				// <v>

		and edx, __MASK_fefefefe	// (np)

		add esi, edx				// (np)

		mov edx, dwAlphaColor
		and esi, __MASK_01010100

		shr esi, 8					// <u>
		mov edi, [ecx+eax*4]		// <v>

		add esi, __MASK_7f7f7f7f	// (np)

		xor esi, __MASK_7f7f7f7f	// (np)

		or edx, esi
		or edi, esi

		sub edi, edx				// (np)

		mov [ecx+eax*4], edi		// `
		pop edx

	skip_draw_0:

		add eax, dwAx			// XZ
		add edx, dw2Dy			// 덷Z

		js skip_add_y			// edx-dw2DyȂWv
	
		add ebx, dwAy			// YZ
		sub edx, dw2Dx			// 덷
		
	skip_add_y:

		cmp eax, dwEnd			// I_ɂǂ
		jne loop_0
		
		jmp end_loop			// (np) I

	jump_y:
	
		mov eax, y1
		mov ebx, dwAy

		add eax, ebx			// (np)

		mov dwEnd, eax			// (np) dwEnd = y1 + dwAy

		mov eax, x0				// JnXW
		mov ebx, y0				// JnYW

		mov edx, esi

		neg edx					// (np) 덷̏l dwDx*-1

	loop_1:

		// NbsO
		mov esi, nClipRight		// if( x<0 || x>nClipWidth || y<0 || y>nClipHeight )
		mov edi, nClipBottom	// ̎Wv
								// 
		sub esi, eax			// if( x<0 || nClipWidth-x<0 || y<0 || nClipHeight-y<0 )
		sub edi, ebx			// rbgŔ肷悤ɂɏ
								// if( (x | nClipWidth-x | y | nClipHeight-y )<0 )
		or esi, edi				// rxł
		mov ecx, eax			// QlTCg (c)D5. http://www.aya.or.jp/~sanami/

		mov edi, ebx
		sub ecx, nClipLeft

		sub edi, nClipTop
		or esi, ecx

		or esi, edi
		js skip_draw_1
		
		// `
		push edx				// 덷̕ۑ
		mov ecx, ppScanLine		// (np)

		mov ecx, [ecx+ebx*4]	// (np) YW̐擪AhX *(ppScanLine+y)
		
		mov edi, [ecx+eax*4]	// ]J[
		mov esi, dwAlphaColor	// ]J[

		not edi					// (np)

		mov edx, dwAlphaColor
		and esi, edi

		shl esi, 1					// <u>
		xor edx, edi				// <v>

		and edx, __MASK_fefefefe	// (np)

		add esi, edx				// (np)

		mov edx, dwAlphaColor
		and esi, __MASK_01010100

		shr esi, 8					// <u>
		mov edi, [ecx+eax*4]		// <v>

		add esi, __MASK_7f7f7f7f	// (np)

		xor esi, __MASK_7f7f7f7f	// (np)

		or edx, esi
		or edi, esi

		sub edi, edx				// (np)

		mov [ecx+eax*4], edi		// `
		pop edx

	skip_draw_1:

		add ebx, dwAy			// YZ
		add edx, dw2Dx			// 덷Z

		js skip_add_x			// edx-dw2DxȂWv
	
		add eax, dwAx			// XZ
		sub edx, dw2Dy			// 덷
		
	skip_add_x:

		cmp ebx, dwEnd			// I_ɂǂ
		jne loop_1

	end_loop:
		
	}

	return S_OK;
}


/*----------------------------------------------------------------------------*
|	ȉ~
*----------------------------------------------------------------------------*/
STDMETHODIMP CSDib32GLX86::EllipseAlpha( int x0, int y0, int rx, int ry, SDIB32GLCOLOR Color )
{
	// IuWFNgNULL`FbN
	_ASSERTE( m_pBits != NULL);
	if( m_pBits == NULL ) return SDIB32GLERR_NOTINITIALIZED;

	if( rx == 0 || ry == 0 ) return S_OK;

	if( rx < 0 ) rx = -rx;
	if( ry < 0 ) ry = -ry; 

	LPSDIB32GLCOLOR* ppScanLine = m_ppScanLine;
	LONG  nClipLeft   = m_rcClip.left;
	LONG  nClipTop    = m_rcClip.top;
	LONG  nClipRight  = m_rcClip.right;
	LONG  nClipBottom = m_rcClip.bottom-1;	// ỹNbv͕Ȃ̂-1

	DWORD dwW = ry*ry;
	DWORD dwH = rx*rx;
	DWORD dw2w = dwW<<1;
	DWORD dw2h = dwH<<1;
	DWORD dw4w = dwW<<2;
	DWORD dw4h = dwH<<2;
	BOOL  bLine;

	DWORD dwAlphaSrc = CONVERT_255To256(SDIB32GL_GET_ALPHA(Color));	// At@
	DWORD dwAlphaDst = DEST_ALPHA( dwAlphaSrc );// t̃At@
	DWORD dwAlphaColor_H;						// AGpAt@l(64rbgʕ)
	DWORD dwAlphaColor_L;						// RBpAt@l(64rbgʕ)

	__asm
	{
		mov eax, Color			// J[
		mov ebx, Color			// J[

		and eax, __AxGx_MASK_H	// ARGBlAGɕ(A͎gȂ)
		and ebx, __xRxB_MASK_L	// ARGBlRBɕ

		imul eax, dwAlphaSrc	// (np) ARGBl(A)G̃lvZ
		
		imul ebx, dwAlphaSrc	// (np) ARGBlRB̃lvZ

		mov dwAlphaColor_H, eax	// oオG(WORDf[^)
		mov dwAlphaColor_L, ebx	// oオR(WORDf[^)B(WORDf[^)

		mov ecx, rx
		mov edx, ry

		imul edx, edx			// (np) r=rx*ry

		imul ecx, edx			// (np) r*ry

		neg ecx					// (np) -(r*ry)

		mov edx, ecx			// Rs[

		shl ecx, 1				//					<u>
		mov eax, rx				// JnXW(x)		<v>

		shl edx, 2				//					<u>
		mov ebx, 0				// JnYW(y)		<v>

		add ecx, dw2h
		add edx, dw2w

		add ecx, dwW			// ܂ F=(-(r*ry)<<1)+_2h+w
		add edx, dwH			// ܂ H=(-(r*ry)<<2)+_2w+h

		// X̃NbsO
		mov edi, eax			// X[vJE^()
		mov esi, x0				// `JnXWp(SX)

		shl edi, 1				//						<u>
		sub esi, eax			// `JnXWx0-x	<v>

		add edi, 1				// (np) n_I_̕ł̏ꍇ-xx܂ł͈̔͂Ȃ̂(x<<1)+1ƂȂ

		cmp esi, nClipRight		// SX]敝ȏȂI
		jge end_

		cmp esi, nClipLeft		// SX0ȏȂNbsOȂ
		jge width0_clip

		sub edi, nClipLeft

		add edi, esi			// NbsO
		mov esi, nClipLeft		// SX0ɂ(w=w-nClipLeft+x)

		cmp edi, 0				// 0ȉɂȂI
		jle end_

	width0_clip:

		push ecx				// WX^ޔ(FH)
		push edx

		mov ecx, esi			// (np)
		
		add ecx, edi			// (np)

		cmp ecx, nClipRight		// SX+]敝ȉȂNbsOȂ
		jle y_line0_clip

		mov edi, nClipRight		// (np)
		
		sub edi, esi			// (np) ]敝|SX

	y_line0_clip:

		// YWNbsO
		mov ecx, nClipBottom
		mov edx, y0				// `YW(SY)

		sub ecx, edx			// nClipBottom-SY
		sub edx, nClipTop		// SY-nClipTop

		or ecx, edx				// if( ((nClipBottom-SY)|(SY-nClipTop)<0 )
		js y_line0_end			// SY0艺A]捂ȏȂ烉C͈Ȃ

		mov ecx, ppScanLine		// obt@
		mov edx, y0

		mov ecx, [ecx+edx*4]	// (np) ]YW

		lea ecx, [ecx+esi*4]	// ]XWAhX
		nop

		nop						// AGIXg[
		nop

	loop_x0:

		mov edx, [ecx]			// ]sNZ
		mov esi, [ecx]			// ]sNZ

		and edx, __AxGx_MASK_H	// }XN
		and esi, __xRxB_MASK_L

		imul edx, dwAlphaDst	// (np) Kp

		imul esi, dwAlphaDst	// (np) Kp

		add edx, dwAlphaColor_H	// ]̃J[Ɠ]̃J[Z
		add esi, dwAlphaColor_L

		and edx, __xGxx_MASK_H	// [؂̂(G)
		and esi, __RxBx_MASK_L	// [؂̂(R,B)

		or edx, esi				// (np) GR,B

		shr edx, 8				// (np)

		mov [ecx], edx			// (np) `

		add ecx, 4				// AhXZ
		dec edi					// [vJE^ --

		jne loop_x0				// (np)


	y_line0_end:

		pop edx					// WX^(FH)
		pop ecx

		mov bLine, FALSE		// (np) C͈

	loop_:

		cmp bLine, FALSE
		je xy_add				// CtO0ȂWv

		// XWNbsO
		mov edi, eax			// X[vJE^()
		mov esi, x0				// `JnXWp(SX)

		shl edi, 1				//						<u>
		sub esi, eax			// `JnXWx0-x	<v>

		add edi, 1				// (np) n_I_̕ł̏ꍇ-xx܂ł͈̔͂Ȃ̂(x<<1)+1ƂȂ

		cmp esi, nClipRight		// SX]敝ȏȂI
		jge end_

		cmp esi, nClipLeft		// SX0ȏȂNbsOȂ
		jge width_clip

		sub edi, nClipLeft

		add edi, esi			// NbsO
		mov esi, nClipLeft		// SX0ɂ

		cmp edi, 0				// 0ȉɂȂI
		jle end_

	width_clip:

		push ecx				// WX^ޔ(FH)
		push edx

		mov ecx, esi			// (np)
		
		add ecx, edi			// (np)

		cmp ecx, nClipRight		// SX+]敝ȉȂNbsOȂ
		jle y_line_clip_down

		mov edi, nClipRight
		
		sub edi, esi			// ]敝|SX

	y_line_clip_down:

		// YWNbsO
		mov ecx, nClipBottom
		mov edx, y0				// `YW(SY)

		add edx, ebx			// (np) SY+=y

		sub ecx, edx			// nClipBottom-SY
		sub edx, nClipTop		// SY-nClipTop

		or ecx, edx				// if( ((nClipBottom-SY)|SY-nClipTop)<0 )
		js y_line_clip_up		// SY0艺A]捂ȏȂ烉C͈Ȃ

		mov ecx, ppScanLine		// (np) obt@
		add edx, nClipTop		// SY+nClipTop

		mov ecx, [ecx+edx*4]	// (np) ]YW

		lea ecx, [ecx+esi*4]	// ]XWAhX
		push esi				// XWޔ

		push edi				// [vJE^ޔ
		nop						// AGIXg[

	loop_x_down:

		// ̔~`
		mov edx, [ecx]			// ]sNZ
		mov esi, [ecx]			// ]sNZ

		and edx, __AxGx_MASK_H	// }XN
		and esi, __xRxB_MASK_L

		imul edx, dwAlphaDst	// (np) Kp

		imul esi, dwAlphaDst	// (np) Kp

		add edx, dwAlphaColor_H	// ]̃J[Ɠ]̃J[Z
		add esi, dwAlphaColor_L

		and edx, __xGxx_MASK_H	// [؂̂(G)
		and esi, __RxBx_MASK_L	// [؂̂(R,B)

		or edx, esi				// (np) GR,B

		shr edx, 8				// (np)

		mov [ecx], edx			// (np) `

		add ecx, 4				// AhXZ
		dec edi					// [vJE^ --

		jne loop_x_down			// (np) AGIXg[͂ŉƁc

		pop edi					// [vJE^
		pop esi					// XW

	y_line_clip_up:

		// YWNbsO
		mov ecx, nClipBottom
		mov edx, y0				// `YW(SY)

		sub edx, ebx			// (np) SY-=y

		sub ecx, edx			// nClipBottom-SY
		sub edx, nClipTop		// SY-nClipTop

		or ecx, edx				// if( ((nClipBottom-SY)|(SY-nClipTop)<0 )
		js y_line_end			// SY0艺A]捂ȏȂ烉C͈Ȃ

		mov ecx, ppScanLine		// (np) obt@
		add edx, nClipTop		// SY+nClipTop

		mov ecx, [ecx+edx*4]	// (np) ]YW

		lea ecx, [ecx+esi*4]	// ]XWAhX
		nop

		nop						// AGIXg[
		nop

	loop_x_up:

		// ̔~`
		mov edx, [ecx]			// ]sNZ
		mov esi, [ecx]			// ]sNZ

		and edx, __AxGx_MASK_H	// }XN
		and esi, __xRxB_MASK_L

		imul edx, dwAlphaDst	// (np) Kp

		imul esi, dwAlphaDst	// (np) Kp

		add edx, dwAlphaColor_H	// ]̃J[Ɠ]̃J[Z
		add esi, dwAlphaColor_L

		and edx, __xGxx_MASK_H	// [؂̂(G)
		and esi, __RxBx_MASK_L	// [؂̂(R,B)

		or edx, esi				// (np) GR,B

		shr edx, 8				// (np)

		mov [ecx], edx			// (np) `

		add ecx, 4				// AhXZ
		dec edi					// [vJE^ --

		jne loop_x_up			// (np) AGIXg[͂ŉƁc

	y_line_end:

		pop edx					// WX^(FH)
		pop ecx

		mov bLine, FALSE		// (np) C͈

	xy_add:

		// 덷̌vZ
		cmp ecx, 0				// if( F >= 0 )ȂH̃`FbN
		jge skip_F

		inc ebx					// y++
		mov edi, dw4h

		imul edi, ebx			// (np) dw4h*y
		
		add ecx, edi			// F+=dw4h*y
		add edx, edi			// H+=dw4h*y
		
		add ecx, dw2h			// F+=dw2h
		mov bLine, TRUE			// yω̂ŃC`tOON

		jmp end_FH				// (np)

	skip_F:

		cmp edx, 0				// if( H < 0 )ȂXZAYZ
		jl skip_H

		dec eax					// x--
		mov esi, dw4w

		imul esi, eax			// (np) dw4w*x
		
		sub ecx, esi			// F-=dw4w*x
		sub edx, esi			// H-=dw4w*x
		
		add ecx, dw2w			// H+=dw2w
		jmp end_FH

	skip_H:

		dec eax					// x--
		inc ebx					// y++
		
		mov esi, dw4w
		mov edi, dw4h

		imul esi, eax			// (np) dw4w*x

		imul edi, ebx			// (np) dw4h*y

		sub edi, esi			// dw4h*y-dw4w*x
		mov bLine, TRUE			// yω̂ŃC`tOON

		add ecx, edi			// F+=dw4h*y-dw4w*x
		add edx, edi			// H+=dw4h*y-dw4w*x

		add ecx, dw2h			// F+=dw2h
		add edx, dw2w			// H+=dw2w

	end_FH:

		cmp eax, 0				// x0ȏȂ烋[v
		jge loop_

	end_:

	}

	return S_OK;
}


/*----------------------------------------------------------------------------*
|	Zȉ~
*----------------------------------------------------------------------------*/
STDMETHODIMP CSDib32GLX86::EllipseAdd( int x0, int y0, int rx, int ry, SDIB32GLCOLOR Color )
{
	// IuWFNgNULL`FbN
	_ASSERTE( m_pBits != NULL);
	if( m_pBits == NULL ) return SDIB32GLERR_NOTINITIALIZED;

	if( rx == 0 || ry == 0 ) return S_OK;

	if( rx < 0 ) rx = -rx;
	if( ry < 0 ) ry = -ry; 

	LPSDIB32GLCOLOR* ppScanLine = m_ppScanLine;
	LONG  nClipLeft   = m_rcClip.left;
	LONG  nClipTop    = m_rcClip.top;
	LONG  nClipRight  = m_rcClip.right;
	LONG  nClipBottom = m_rcClip.bottom-1;	// ỹNbv͕Ȃ̂-1

	DWORD dwW = ry*ry;
	DWORD dwH = rx*rx;
	DWORD dw2w = dwW<<1;
	DWORD dw2h = dwH<<1;
	DWORD dw4w = dwW<<2;
	DWORD dw4h = dwH<<2;
	BOOL  bLine;

	DWORD dwAlphaSrc  = CONVERT_255To256(SDIB32GL_GET_ALPHA(Color));	// At@
	DWORD dwAlphaColor;

	__asm
	{
		mov ecx, dwAlphaSrc
		mov ebx, Color

		cmp ecx, 256
		je skip_alphacolor

		mov eax, Color			// J[
		mov ebx, Color			// J[

		and eax, __AxGx_MASK_H	// ARGBlAGɕ(A͎gȂ)
		and ebx, __xRxB_MASK_L	// ARGBlRBɕ

		imul eax, ecx			// (np) Kp
		
		imul ebx, ecx			// (np) Kp

		and eax, __xGxx_MASK_H	// [؂̂(G)
		and ebx, __RxBx_MASK_L	// [؂̂(R,B)

		or ebx, eax				// (np) GR,B
		
		shr ebx, 8				// (np)

	skip_alphacolor:

		mov dwAlphaColor, ebx	// J[

		mov ecx, rx
		mov edx, ry

		imul edx, edx			// (np) r=rx*ry

		imul ecx, edx			// (np) r*ry

		neg ecx					// (np) -(r*ry)

		mov edx, ecx			// (np) Rs[

		shl ecx, 1				//				<u>
		mov eax, rx				// JnXW(x)	<v>

		shl edx, 2				//				<u>
		mov ebx, 0				// JnYW(y)	<v>

		add ecx, dw2h
		add edx, dw2w

		add ecx, dwW			// ܂ F=(-(r*ry)<<1)+_2h+w
		add edx, dwH			// ܂ H=(-(r*ry)<<2)+_2w+h

		// X̃NbsO
		mov edi, eax			// X[vJE^()
		mov esi, x0				// `JnXWp(SX)

		shl edi, 1				//						<u>
		sub esi, eax			// `JnXWx0-x	<v>

		add edi, 1				// (np) n_I_̕ł̏ꍇ-xx܂ł͈̔͂Ȃ̂(x<<1)+1ƂȂ

		cmp esi, nClipRight		// SX]敝ȏȂI
		jge end_

		cmp esi, nClipLeft		// SX0ȏȂNbsOȂ
		jge width0_clip

		sub edi, nClipLeft

		add edi, esi			// NbsO
		mov esi, nClipLeft		// SX0ɂ(w=w-nClipLeft+x)

		cmp edi, 0				// 0ȉɂȂI
		jle end_

	width0_clip:

		push ecx				// WX^ޔ(FH)
		push edx

		mov ecx, esi			// (np)
		
		add ecx, edi			// (np)

		cmp ecx, nClipRight		// SX+]敝ȉȂNbsOȂ
		jle y_line0_clip

		mov edi, nClipRight		// (np)
		
		sub edi, esi			// (np) ]敝|SX

	y_line0_clip:

		// YWNbsO
		mov ecx, nClipBottom
		mov edx, y0				// `YW(SY)

		sub ecx, edx			// nClipBottom-SY
		sub edx, nClipTop		// SY-nClipTop

		or ecx, edx				// if( ((nClipBottom-SY)|(SY-nClipTop)<0 )
		js y_line0_end			// SY0艺A]捂ȏȂ烉C͈Ȃ

		mov ecx, ppScanLine		// obt@
		mov edx, y0

		mov ecx, [ecx+edx*4]	// (np) ]YW

		lea ecx, [ecx+esi*4]	// ]XWAhX
		nop

		nop						// AGIXg[
		nop

	loop_x0:

		mov edx, [ecx]
		mov esi, dwAlphaColor

		and edx, esi
		xor esi, [ecx]

		shl edx, 1				//	<u>
		and esi, __MASK_fefefefe//	<v>

		add esi, edx
		mov edx, dwAlphaColor

		and esi, __MASK_01010100
		add edx, [ecx]

		shr esi, 8				// (np)
		
		add esi, __MASK_7f7f7f7f// (np)

		xor esi, __MASK_7f7f7f7f// (np)

		sub edx, esi			// (np)

		or edx, esi				// (np)

		mov [ecx], edx			// (np) `

		add ecx, 4				// AhXZ
		dec edi					// [vJE^ --

		jne loop_x0				// (np)

	y_line0_end:

		pop edx					// WX^(FH)
		pop ecx

		mov bLine, FALSE		// (np) C͈

	loop_:

		cmp bLine, FALSE
		je xy_add				// CtO0ȂWv

		// XWNbsO
		mov edi, eax			// X[vJE^()
		mov esi, x0				// `JnXWp(SX)

		shl edi, 1				//						<u>
		sub esi, eax			// `JnXWx0-x	<v>

		add edi, 1				// (np) n_I_̕ł̏ꍇ-xx܂ł͈̔͂Ȃ̂(x<<1)+1ƂȂ

		cmp esi, nClipRight		// SX]敝ȏȂI
		jge end_

		cmp esi, nClipLeft		// SX0ȏȂNbsOȂ
		jge width_clip

		sub edi, nClipLeft

		add edi, esi			// NbsO
		mov esi, nClipLeft		// SX0ɂ

		cmp edi, 0				// 0ȉɂȂI
		jle end_

	width_clip:

		push ecx				// WX^ޔ(FH)
		push edx

		mov ecx, esi			// (np)
		
		add ecx, edi			// (np)

		cmp ecx, nClipRight		// SX+]敝ȉȂNbsOȂ
		jle y_line_clip_down

		mov edi, nClipRight
		
		sub edi, esi			// ]敝|SX

	y_line_clip_down:

		// YWNbsO
		mov ecx, nClipBottom
		mov edx, y0				// `YW(SY)

		add edx, ebx			// (np) SY+=y

		sub ecx, edx			// nClipBottom-SY
		sub edx, nClipTop		// SY-nClipTop

		or ecx, edx				// if( ((nClipBottom-SY)|SY-nClipTop)<0 )
		js y_line_clip_up		// SY0艺A]捂ȏȂ烉C͈Ȃ

		mov ecx, ppScanLine		// (np) obt@
		add edx, nClipTop		// SY+nClipTop

		mov ecx, [ecx+edx*4]	// (np) ]YW

		lea ecx, [ecx+esi*4]	// ]XWAhX
		push esi				// XWޔ

		push edi				// [vJE^ޔ
		nop						// AGIXg[

	loop_x_down:

		// ̔~`
		mov edx, [ecx]
		mov esi, dwAlphaColor

		and edx, esi
		xor esi, [ecx]

		shl edx, 1				//	<u>
		and esi, __MASK_fefefefe//	<v>

		add esi, edx
		mov edx, dwAlphaColor

		and esi, __MASK_01010100
		add edx, [ecx]

		shr esi, 8				// (np)
		
		add esi, __MASK_7f7f7f7f// (np)

		xor esi, __MASK_7f7f7f7f// (np)

		sub edx, esi			// (np)

		or edx, esi				// (np)

		mov [ecx], edx			// (np) `

		add ecx, 4				// AhXZ
		dec edi					// [vJE^ --

		jne loop_x_down			// (np) AGIXg[͂ŉƁc

		pop edi					// [vJE^
		pop esi					// XW

	y_line_clip_up:

		// YWNbsO
		mov ecx, nClipBottom
		mov edx, y0				// `YW(SY)

		sub edx, ebx			// (np) SY-=y

		sub ecx, edx			// nClipBottom-SY
		sub edx, nClipTop		// SY-nClipTop

		or ecx, edx				// if( ((nClipBottom-SY)|(SY-nClipTop)<0 )
		js y_line_end			// SY0艺A]捂ȏȂ烉C͈Ȃ

		mov ecx, ppScanLine		// (np) obt@
		add edx, nClipTop		// SY+nClipTop

		mov ecx, [ecx+edx*4]	// (np) ]YW

		lea ecx, [ecx+esi*4]	// ]XWAhX
		nop

		nop						// AGIXg[
		nop

	loop_x_up:

		// ̔~`
		mov edx, [ecx]
		mov esi, dwAlphaColor

		and edx, esi
		xor esi, [ecx]

		shl edx, 1				//	<u>
		and esi, __MASK_fefefefe//	<v>

		add esi, edx
		mov edx, dwAlphaColor

		and esi, __MASK_01010100
		add edx, [ecx]

		shr esi, 8				// (np)
		
		add esi, __MASK_7f7f7f7f// (np)

		xor esi, __MASK_7f7f7f7f// (np)

		sub edx, esi			// (np)

		or edx, esi				// (np)

		mov [ecx], edx			// (np) `

		add ecx, 4				// AhXZ
		dec edi					// [vJE^ --

		jne loop_x_up			// (np) AGIXg[͂ŉƁc

	y_line_end:

		pop edx					// WX^(FH)
		pop ecx

		mov bLine, FALSE		// (np) C͈

	xy_add:

		// 덷̌vZ
		cmp ecx, 0				// if( F >= 0 )ȂH̃`FbN
		jge skip_F

		inc ebx					// y++
		mov edi, dw4h

		imul edi, ebx			// (np) dw4h*y
		
		add ecx, edi			// F+=dw4h*y
		add edx, edi			// H+=dw4h*y
		
		add ecx, dw2h			// F+=dw2h
		mov bLine, TRUE			// yω̂ŃC`tOON

		jmp end_FH				// (np)

	skip_F:

		cmp edx, 0				// if( H < 0 )ȂXZAYZ
		jl skip_H

		dec eax					// x--
		mov esi, dw4w

		imul esi, eax			// (np) dw4w*x
		
		sub ecx, esi			// F-=dw4w*x
		sub edx, esi			// H-=dw4w*x
		
		add ecx, dw2w			// H+=dw2w
		jmp end_FH

	skip_H:

		dec eax					// x--
		inc ebx					// y++
		
		mov esi, dw4w
		mov edi, dw4h

		imul esi, eax			// (np) dw4w*x

		imul edi, ebx			// (np) dw4h*y

		sub edi, esi			// dw4h*y-dw4w*x
		mov bLine, TRUE			// yω̂ŃC`tOON

		add ecx, edi			// F+=dw4h*y-dw4w*x
		add edx, edi			// H+=dw4h*y-dw4w*x

		add ecx, dw2h			// F+=dw2h
		add edx, dw2w			// H+=dw2w

	end_FH:

		cmp eax, 0				// x0ȏȂ烋[v
		jge loop_

	end_:

	}

	return S_OK;
}


/*----------------------------------------------------------------------------*
|	Zȉ~
*----------------------------------------------------------------------------*/
STDMETHODIMP CSDib32GLX86::EllipseSub( int x0, int y0, int rx, int ry, SDIB32GLCOLOR Color )
{
	// IuWFNgNULL`FbN
	_ASSERTE( m_pBits != NULL);
	if( m_pBits == NULL ) return SDIB32GLERR_NOTINITIALIZED;

	if( rx == 0 || ry == 0 ) return S_OK;

	if( rx < 0 ) rx = -rx;
	if( ry < 0 ) ry = -ry; 

	LPSDIB32GLCOLOR* ppScanLine = m_ppScanLine;
	LONG  nClipLeft   = m_rcClip.left;
	LONG  nClipTop    = m_rcClip.top;
	LONG  nClipRight  = m_rcClip.right;
	LONG  nClipBottom = m_rcClip.bottom-1;	// ỹNbv͕Ȃ̂-1

	DWORD dwW = ry*ry;
	DWORD dwH = rx*rx;
	DWORD dw2w = dwW<<1;
	DWORD dw2h = dwH<<1;
	DWORD dw4w = dwW<<2;
	DWORD dw4h = dwH<<2;
	BOOL  bLine;

	DWORD dwAlphaSrc  = CONVERT_255To256(SDIB32GL_GET_ALPHA(Color));	// At@
	DWORD dwAlphaColor;

	__asm
	{
		mov ecx, dwAlphaSrc
		mov ebx, Color

		cmp ecx, 256
		je skip_alphacolor

		mov eax, Color			// J[
		mov ebx, Color			// J[

		and eax, __AxGx_MASK_H	// ARGBlAGɕ(A͎gȂ)
		and ebx, __xRxB_MASK_L	// ARGBlRBɕ

		imul eax, ecx			// (np) Kp
		
		imul ebx, ecx			// (np) Kp

		and eax, __xGxx_MASK_H	// [؂̂(G)
		and ebx, __RxBx_MASK_L	// [؂̂(R,B)

		or ebx, eax				// (np) GR,B
		
		shr ebx, 8				// (np)

	skip_alphacolor:

		mov dwAlphaColor, ebx	// J[

		mov ecx, rx
		mov edx, ry

		imul edx, edx			// (np) r=rx*ry

		imul ecx, edx			// (np) r*ry

		neg ecx					// (np) -(r*ry)

		mov edx, ecx			// (np) Rs[

		shl ecx, 1				//				<u>
		mov eax, rx				// JnXW(x)	<v>

		shl edx, 2				//				<u>
		mov ebx, 0				// JnYW(y)	<v>

		add ecx, dw2h
		add edx, dw2w

		add ecx, dwW			// ܂ F=(-(r*ry)<<1)+_2h+w
		add edx, dwH			// ܂ H=(-(r*ry)<<2)+_2w+h

		// X̃NbsO
		mov edi, eax			// X[vJE^()
		mov esi, x0				// `JnXWp(SX)

		shl edi, 1				//						<u>
		sub esi, eax			// `JnXWx0-x	<v>

		add edi, 1				// (np) n_I_̕ł̏ꍇ-xx܂ł͈̔͂Ȃ̂(x<<1)+1ƂȂ

		cmp esi, nClipRight		// SX]敝ȏȂI
		jge end_

		cmp esi, nClipLeft		// SX0ȏȂNbsOȂ
		jge width0_clip

		sub edi, nClipLeft

		add edi, esi			// NbsO
		mov esi, nClipLeft		// SX0ɂ(w=w-nClipLeft+x)

		cmp edi, 0				// 0ȉɂȂI
		jle end_

	width0_clip:

		push ecx				// WX^ޔ(FH)
		push edx

		mov ecx, esi			// (np)
		
		add ecx, edi			// (np)

		cmp ecx, nClipRight		// SX+]敝ȉȂNbsOȂ
		jle y_line0_clip

		mov edi, nClipRight		// (np)
		
		sub edi, esi			// (np) ]敝|SX

	y_line0_clip:

		// YWNbsO
		mov ecx, nClipBottom
		mov edx, y0				// `YW(SY)

		sub ecx, edx			// nClipBottom-SY
		sub edx, nClipTop		// SY-nClipTop

		or ecx, edx				// if( ((nClipBottom-SY)|(SY-nClipTop)<0 )
		js y_line0_end			// SY0艺A]捂ȏȂ烉C͈Ȃ

		mov ecx, ppScanLine		// obt@
		mov edx, y0

		mov ecx, [ecx+edx*4]	// (np) ]YW

		lea ecx, [ecx+esi*4]	// ]XWAhX
		push eax				// xޔ

		nop						// AGIXg[
		nop

	loop_x0:

		mov edx, [ecx]				// ]J[
		mov esi, dwAlphaColor		// ]J[

		not edx						// (np)

		mov eax, dwAlphaColor
		and esi, edx

		shl esi, 1					// <u>
		xor eax, edx				// <v>

		and eax, __MASK_fefefefe	// (np)

		add esi, eax				// (np)

		mov eax, dwAlphaColor
		and esi, __MASK_01010100

		shr esi, 8					// <u>
		mov edx, [ecx]				// <v>

		add esi, __MASK_7f7f7f7f	// (np)

		xor esi, __MASK_7f7f7f7f	// (np)

		or eax, esi
		or edx, esi

		sub edx, eax				// (np)

		mov [ecx], edx				// `

		add ecx, 4					// AhXZ
		dec edi						// [vJE^ --

		jne loop_x0					// (np)
		
		pop eax						// (np) x

	y_line0_end:

		pop edx					// WX^(FH)
		pop ecx

		mov bLine, FALSE		// (np) C͈

	loop_:

		cmp bLine, FALSE
		je xy_add				// CtO0ȂWv

		// XWNbsO
		mov edi, eax			// X[vJE^()
		mov esi, x0				// `JnXWp(SX)

		shl edi, 1				//						<u>
		sub esi, eax			// `JnXWx0-x	<v>

		add edi, 1				// (np) n_I_̕ł̏ꍇ-xx܂ł͈̔͂Ȃ̂(x<<1)+1ƂȂ

		cmp esi, nClipRight		// SX]敝ȏȂI
		jge end_

		cmp esi, nClipLeft		// SX0ȏȂNbsOȂ
		jge width_clip

		sub edi, nClipLeft

		add edi, esi			// NbsO
		mov esi, nClipLeft		// SX0ɂ

		cmp edi, 0				// 0ȉɂȂI
		jle end_

	width_clip:

		push ecx				// WX^ޔ(FH)
		push edx

		mov ecx, esi			// (np)
		
		add ecx, edi			// (np)

		cmp ecx, nClipRight		// SX+]敝ȉȂNbsOȂ
		jle y_line_clip_down

		mov edi, nClipRight
		
		sub edi, esi			// ]敝|SX

	y_line_clip_down:

		// YWNbsO
		mov ecx, nClipBottom
		mov edx, y0				// `YW(SY)

		add edx, ebx			// (np) SY+=y

		sub ecx, edx			// nClipBottom-SY
		sub edx, nClipTop		// SY-nClipTop

		or ecx, edx				// if( ((nClipBottom-SY)|SY-nClipTop)<0 )
		js y_line_clip_up		// SY0艺A]捂ȏȂ烉C͈Ȃ

		mov ecx, ppScanLine		// (np) obt@
		add edx, nClipTop		// SY+nClipTop

		mov ecx, [ecx+edx*4]	// (np) ]YW

		lea ecx, [ecx+esi*4]	// ]XWAhX
		push esi				// XWޔ

		push edi				// [vJE^ޔ
		push eax				// xޔ

	loop_x_down:

		// ̔~`
		mov edx, [ecx]				// ]J[
		mov esi, dwAlphaColor		// ]J[

		not edx						// (np)

		mov eax, dwAlphaColor
		and esi, edx

		shl esi, 1					// <u>
		xor eax, edx				// <v>

		and eax, __MASK_fefefefe
		add esi, eax

		mov eax, dwAlphaColor
		and esi, __MASK_01010100

		shr esi, 8					// <u>
		mov edx, [ecx]				// <v>

		add esi, __MASK_7f7f7f7f	// (np)

		xor esi, __MASK_7f7f7f7f	// (np)

		or eax, esi
		or edx, esi

		sub edx, eax				// (np)

		mov [ecx], edx				// `

		add ecx, 4				// AhXZ
		dec edi					// [vJE^ --

		jne loop_x_down			// (np) AGIXg[͂ŉƁc

		pop eax					// (np) x

		pop edi					// [vJE^
		pop esi					// XW

	y_line_clip_up:

		// YWNbsO
		mov ecx, nClipBottom
		mov edx, y0				// `YW(SY)

		sub edx, ebx			// (np) SY-=y

		sub ecx, edx			// nClipBottom-SY
		sub edx, nClipTop		// SY-nClipTop

		or ecx, edx				// if( ((nClipBottom-SY)|(SY-nClipTop)<0 )
		js y_line_end			// SY0艺A]捂ȏȂ烉C͈Ȃ

		mov ecx, ppScanLine		// (np) obt@
		add edx, nClipTop		// SY+nClipTop

		mov ecx, [ecx+edx*4]	// (np) ]YW

		lea ecx, [ecx+esi*4]	// ]XWAhX
		push eax				// xޔ

		nop						// AGIXg[
		nop

	loop_x_up:

		// ̔~`
		mov edx, [ecx]				// ]J[
		mov esi, dwAlphaColor		// ]J[

		not edx						// (np)

		mov eax, dwAlphaColor
		and esi, edx

		shl esi, 1					// <u>
		xor eax, edx				// <v>

		and eax, __MASK_fefefefe
		add esi, eax

		mov eax, dwAlphaColor
		and esi, __MASK_01010100

		shr esi, 8					// <u>
		mov edx, [ecx]				// <v>

		add esi, __MASK_7f7f7f7f	// (np)

		xor esi, __MASK_7f7f7f7f	// (np)

		or eax, esi
		or edx, esi

		sub edx, eax				// (np)

		mov [ecx], edx				// `

		add ecx, 4					// AhXZ
		dec edi						// [vJE^ --

		jne loop_x_up				// (np) AGIXg[͂ŉƁc

		pop eax						// (np)	x

	y_line_end:

		pop edx					// WX^(FH)
		pop ecx

		mov bLine, FALSE		// (np) C͈

	xy_add:

		// 덷̌vZ
		cmp ecx, 0				// if( F >= 0 )ȂH̃`FbN
		jge skip_F

		inc ebx					// y++
		mov edi, dw4h

		imul edi, ebx			// (np) dw4h*y
		
		add ecx, edi			// F+=dw4h*y
		add edx, edi			// H+=dw4h*y
		
		add ecx, dw2h			// F+=dw2h
		mov bLine, TRUE			// yω̂ŃC`tOON

		jmp end_FH				// (np)

	skip_F:

		cmp edx, 0				// if( H < 0 )ȂXZAYZ
		jl skip_H

		dec eax					// x--
		mov esi, dw4w

		imul esi, eax			// (np) dw4w*x
		
		sub ecx, esi			// F-=dw4w*x
		sub edx, esi			// H-=dw4w*x
		
		add ecx, dw2w			// H+=dw2w
		jmp end_FH

	skip_H:

		dec eax					// x--
		inc ebx					// y++
		
		mov esi, dw4w
		mov edi, dw4h

		imul esi, eax			// (np) dw4w*x

		imul edi, ebx			// (np) dw4h*y

		sub edi, esi			// dw4h*y-dw4w*x
		mov bLine, TRUE			// yω̂ŃC`tOON

		add ecx, edi			// F+=dw4h*y-dw4w*x
		add edx, edi			// H+=dw4h*y-dw4w*x

		add ecx, dw2h			// F+=dw2h
		add edx, dw2w			// H+=dw2w

	end_FH:

		cmp eax, 0				// x0ȏȂ烋[v
		jge loop_

	end_:

	}

	return S_OK;
}


/*----------------------------------------------------------------------------*
|	ẅ̗mN
|
|	[]
|	int xcx W
|	int ycy W
|	int nWidthc
|	int nHeightc
|	BYTE Strengthc 0ŃtJ[A255ŊSmN
*----------------------------------------------------------------------------*/
STDMETHODIMP CSDib32GLX86::Mono( int x, int y, int nWidth, int nHeight, BYTE Strength )
{
	// IuWFNgNULL`FbN
	_ASSERTE( m_pBits != NULL);
	if( m_pBits == NULL ) return SDIB32GLERR_NOTINITIALIZED;

	if( Strength == 0 ) return S_OK;

	// NbsO
	if( !Clipping( x, y, nWidth, nHeight ) ) return SDIB32GLERR_INVALIDPOSITION;

	
	LPSDIB32GLCOLOR pBits = &m_ppScanLine[y][x];
	DWORD dwAddWidth = (m_nWidth-nWidth)<<2;

	nWidth  = CONVERT_WIDTH( nWidth );
	nHeight = CONVERT_HEIGHT( nHeight );

	static const DWORD dwY_RB = 0x4d00001c;
	static const DWORD dwY_G  = 0x00000097;

	LPSDIB32GLCOLOR lpMonoTbl = m_MonoTbl;


	if( Strength != 255 )
	{

		DWORD dwStrength1 = CONVERT_255To256(Strength);
		DWORD dwStrength2 = DEST_ALPHA(dwStrength1);

		__asm
		{
			mov edi, pBits
			mov ecx, nHeight			// X[vJE^

			mov esi, lpMonoTbl
		loop_y0:

			or ecx, nWidth

		loop_x0:

			mov eax, [edi]				// sNZf[^擾
			mov ebx, [edi]				// sNZf[^擾

			and eax, __xRxB_MONO_MASK	// ԂƐ}XN
			and ebx, __xxGx_MONO_MASK	// ΂}XN

			mul dwY_RB					// ԂƐɉdϒlZ
			
			shr edx, 8					// 
			and eax, __xxBB_MONO_MASK	// 

			shr ebx, 8
			add eax, edx				// +
			
			xchg eax, ebx				// (+)Ɨ΃Xbv

			mul dwY_G					// ΂ɉdϒlZ

			add eax, ebx				// OCXP[Px
			mov edx, [edi]

			shr eax, 8					// OCXP[Px

			mov edx, [esi+eax*4]		//  uh̃\[XRsy
			mov ebx, [edi]

			and edx, __xRxB_MASK_L		// }XN eax & 0x00ff00ff	
			and ebx, __xRxB_MASK_L		// }XN ebx & 0x00ff00ff

			imul edx, dwStrength1		// (np)

			imul ebx, dwStrength2		// (np)
		
			add edx, ebx
			mov eax, [esi+eax*4]

			mov ebx, [edi]
			and eax, __AxGx_MASK_H		// }XN eax & 0x0000ff00

			and ebx, __AxGx_MASK_H		// (np) }XN eax & 0x0000ff00

			imul eax, dwStrength1		// (np)

			imul ebx, dwStrength2		// (np)	

			add eax, ebx
			add edi, 4

			and eax, __xGxx_MASK_H		// [؂̂(G)
			and edx, __RxBx_MASK_L		// [؂̂(R,B)

			or eax, edx					// (np) GR,B
			mov edx, [edi-4]

			shr eax, 8
			and edx, __Axxx_MASK

			or eax, edx
			sub ecx, __DEC_WIDTH

			mov [edi-4], eax
			jns loop_x0

			add edi, dwAddWidth
			sub ecx, __DEC_HEIGHT

			jns loop_y0

		}

	}else
	{
		__asm
		{
			mov ecx, nHeight			// X[vJE^
			mov esi, lpMonoTbl

			mov edi, pBits

		loop_y1:

			or ecx, nWidth

		loop_x1:

			mov eax, [edi]				// sNZf[^擾
			mov ebx, [edi]				// sNZf[^擾

			and eax, __xRxB_MONO_MASK	// ԂƐ}XN
			and ebx, __xxGx_MONO_MASK	// ΂}XN

			mul dwY_RB					// ԂƐɉdϒlZ
			
			shr edx, 8					// 
			and eax, __xxBB_MONO_MASK	// 

			shr ebx, 8
			add eax, edx				// +
			
			xchg eax, ebx				// (+)Ɨ΃Xbv

			mul dwY_G					// ΂ɉdϒlZ

			add eax, ebx				// OCXP[Px
			mov edx, [edi]

			shr eax, 8
			and edx, __Axxx_MASK

			or edx, [esi+eax*4]
			add edi, 4
			
			mov [edi-4], edx			// OCXP[J[]
			sub ecx, __DEC_WIDTH
			
			jns loop_x1

			add edi, dwAddWidth
			sub ecx, __DEC_HEIGHT

			jns loop_y1

		}
	}

	return S_OK;
}


/*----------------------------------------------------------------------------*
|	ẅ̗ZsA
|
|	[]
|	int xcx W
|	int ycy W
|	int nWidthc
|	int nHeightc
|	BYTE Strengthc 0ŃtJ[A255ŊSZsA
|	SDIB32GLCOLOR Colorc߂F@(ZsAcR=240 G=200 B=145)
*----------------------------------------------------------------------------*/
STDMETHODIMP CSDib32GLX86::Sepia( int x, int y, int nWidth, int nHeight, BYTE Strength, SDIB32GLCOLOR Color )
{
	// IuWFNgNULL`FbN
	_ASSERTE( m_pBits != NULL);
	if( m_pBits == NULL ) return SDIB32GLERR_NOTINITIALIZED;

	if( Strength == 0 ) return S_OK;

	// NbsO
	if( !Clipping( x, y, nWidth, nHeight ) ) return SDIB32GLERR_INVALIDPOSITION;

	
	LPSDIB32GLCOLOR pBits = &m_ppScanLine[y][x];
	DWORD dwAddWidth = (m_nWidth-nWidth)<<2;

	nWidth  = CONVERT_WIDTH( nWidth );
	nHeight = CONVERT_HEIGHT( nHeight );

	static const DWORD dwY_RB = 0x4d00001c;
	static const DWORD dwY_G  = 0x00000097;
	
	// pZsAϊe[u
	SDIB32GLCOLOR SepiaTbl[256];
	DWORD dwSepiaR = CONVERT_255To256(SDIB32GL_GET_RED(Color));
	DWORD dwSepiaG = CONVERT_255To256(SDIB32GL_GET_GREEN(Color));
	DWORD dwSepiaB = CONVERT_255To256(SDIB32GL_GET_BLUE(Color));

	// ZsAϊe[u쐬
	__asm
	{
		mov ecx, 255
		lea edi, SepiaTbl

	loop_tbl:

		mov eax, ecx
		mov ebx, ecx

		mov edx, ecx

		imul eax, dwSepiaB

		imul ebx, dwSepiaG

		imul edx, dwSepiaR

		shr eax, 8
		and ebx, 0x0000ff00

		or eax, ebx
		and edx, 0x0000ff00

		shl edx, 8

		or eax, edx
		dec ecx

		mov [edi+ecx*4+4], eax
		jns loop_tbl
	}


	if( Strength != 255 )
	{

		DWORD dwStrength1 = CONVERT_255To256(Strength);
		DWORD dwStrength2 = DEST_ALPHA(dwStrength1);

		__asm
		{
			mov edi, pBits
			mov ecx, nHeight			// X[vJE^

			lea esi, SepiaTbl

		loop_y0:

			or ecx, nWidth

		loop_x0:

			mov eax, [edi]				// sNZf[^擾
			mov ebx, [edi]				// sNZf[^擾

			and eax, __xRxB_MONO_MASK	// ԂƐ}XN
			and ebx, __xxGx_MONO_MASK	// ΂}XN

			mul dwY_RB					// ԂƐɉdϒlZ
			
			shr edx, 8					// 
			and eax, __xxBB_MONO_MASK	// 

			shr ebx, 8
			add eax, edx				// +
			
			xchg eax, ebx				// (+)Ɨ΃Xbv

			mul dwY_G					// ΂ɉdϒlZ

			add eax, ebx

			shr eax, 8					// OCXP[Px

			mov edx, [esi+eax*4]		// uh̃\[XRsy
			mov ebx, [edi]

			and edx, __xRxB_MASK_L		// }XN eax & 0x00ff00ff	
			and ebx, __xRxB_MASK_L		// }XN ebx & 0x00ff00ff

			imul edx, dwStrength1		// (np)

			imul ebx, dwStrength2		// (np)
		
			add edx, ebx
			mov eax, [esi+eax*4]

			mov ebx, [edi]
			and eax, __AxGx_MASK_H		// }XN eax & 0x0000ff00

			and ebx, __AxGx_MASK_H		// (np) }XN eax & 0x0000ff00

			imul eax, dwStrength1		// (np)

			imul ebx, dwStrength2		// (np)	

			add eax, ebx
			add edi, 4

			and eax, __xGxx_MASK_H		// [؂̂(G)
			and edx, __RxBx_MASK_L		// [؂̂(R,B)

			or eax, edx					// (np) GR,B
			mov edx, [edi-4]

			shr eax, 8
			and edx, __Axxx_MASK

			or eax, edx
			sub ecx, __DEC_WIDTH

			mov [edi-4], eax
			jns loop_x0

			add edi, dwAddWidth
			sub ecx, __DEC_HEIGHT

			jns loop_y0

		}

	}else
	{
		__asm
		{
			mov edi, pBits
			lea esi, SepiaTbl

			mov ecx, nHeight			// X[vJE^

		loop_y1:

			or ecx, nWidth

		loop_x1:

			mov eax, [edi]				// sNZf[^擾
			mov ebx, [edi]				// sNZf[^擾

			and eax, __xRxB_MONO_MASK	// ԂƐ}XN
			and ebx, __xxGx_MONO_MASK	// ΂}XN

			mul dwY_RB					// ԂƐɉdϒlZ
			
			shr edx, 8					// 
			and eax, __xxBB_MONO_MASK	// 

			shr ebx, 8
			add eax, edx				// +
			
			xchg eax, ebx				// (+)Ɨ΃Xbv

			mul dwY_G					// ΂ɉdϒlZ

			add eax, ebx				// OCXP[Px
			mov edx, [edi]

			shr eax, 8
			and edx, __Axxx_MASK

			or edx, [esi+eax*4]
			add edi, 4
			
			mov [edi-4], edx			// OCXP[J[]
			sub ecx, __DEC_WIDTH

			jns loop_x1

			add edi, dwAddWidth
			sub ecx, __DEC_HEIGHT

			jns loop_y1

		}
	}

	return S_OK;
}


/*----------------------------------------------------------------------------*
|	ẅ̗̖邳
|
|	[]
|	int xcx W
|	int ycy W
|	int nWidthc
|	int nHeightc
|	int nBrightc邳 -255()`255()
*----------------------------------------------------------------------------*/
STDMETHODIMP CSDib32GLX86::Bright( int x, int y, int nWidth, int nHeight, int nBright )
{
	// IuWFNgNULL`FbN
	_ASSERTE( m_pBits != NULL);
	if( m_pBits == NULL ) return SDIB32GLERR_NOTINITIALIZED;

	if( nBright == 0 ) return S_OK;

	// NbsO
	if( !Clipping( x, y, nWidth, nHeight ) ) return SDIB32GLERR_INVALIDPOSITION;

	
	LPSDIB32GLCOLOR pBits = &m_ppScanLine[y][x];
	DWORD dwAddWidth = (m_nWidth-nWidth)<<2;

	nWidth  = CONVERT_WIDTH( nWidth );
	nHeight = CONVERT_HEIGHT( nHeight );

	BYTE BrightTbl[256];

	nBright %= 256;

	if( nBright > 0 )
	{
		__asm
		{
			mov ecx, 255
			lea edi, BrightTbl

			mov edx, nBright

		loop_tbl_light:

			mov eax, ecx

			add eax, edx

			cmp eax, 255			// if( eax > 255 ) eax = 255
			jle skip_over_light

			mov eax, 255

		skip_over_light:

			mov [edi+ecx*1], al

			dec ecx
			jns loop_tbl_light

		}

	}else
	{
		__asm
		{
			mov ecx, 255
			lea edi, BrightTbl

			mov edx, nBright

		loop_tbl_dark:

			mov eax, ecx

			add eax, edx			// if( eax < 0 ) eax = 0
			jns skip_over_dark

			mov eax, 0

		skip_over_dark:

			mov [edi+ecx*1], al

			dec ecx
			jns loop_tbl_dark

		}
	}


	__asm
	{
		mov edi, pBits
		mov ecx, nHeight			// X[vJE^

		lea esi, BrightTbl

	loop_y0:

		or ecx, nWidth

	loop_x0:

		mov eax, [edi]
		xor ebx, ebx

		mov bl, al
		xor edx, edx

		mov bl, byte ptr[esi+ebx*1]
		mov dl, ah

		shr eax, 16
		mov bh, byte ptr[esi+edx*1]

		mov dl, al
		mov eax, [edi]

		mov dl, byte ptr[esi+edx*1]
		and eax, __Axxx_MASK

		shl edx, 16
		or ebx, eax

		or ebx, edx

		mov [edi], ebx

		add edi, 4

		sub ecx, __DEC_WIDTH
		jns loop_x0

		add edi, dwAddWidth
		sub ecx, __DEC_HEIGHT

		jns loop_y0

	}


	return S_OK;
}